VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ActionCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public GagOutput As Boolean
Private SessionObject As frmSession

Private arrContents() As Action
Private strBuffer As String

Friend Sub Init(SessionForm As frmSession)
    Set SessionObject = SessionForm
    GagOutput = False
End Sub

'Public Sub AddObject(objColItem As ICollectionItem)
'    Dim lngIdx As Long
'    lngIdx = GetIndex(objColItem.Name)
'    If lngIdx = -1 Then
'        lngIdx = UBound(arrContents)
'        ReDim Preserve arrContents(lngIdx + 1)
'        Set arrContents(lngIdx) = New Action
'    End If
'    With arrContents(lngIdx)
'        .Enabled = objColItem.bEnabled
'        .CaseSensitive = objColItem.bCaseSensitive
'        .Name = objColItem.Name
'        .Simple = objColItem.bSimple
'        .Command = objColItem.Command
'        .Pattern = objColItem.Pattern
'    End With
'End Sub

Public Sub Add(Name As String, Pattern As String, Command As String, bCaseSensitive As Boolean, Optional bEnabled As Boolean = True, Optional bSimple As Boolean = True)
'// Adds a new action.
    On Error GoTo errHandler
    Dim lngIdx As Long
    lngIdx = GetIndex(Name)
    If lngIdx = -1 Then
        lngIdx = UBound(arrContents)
        ReDim Preserve arrContents(lngIdx + 1)
        Set arrContents(lngIdx) = New Action
    End If
    With arrContents(lngIdx)
        .Enabled = bEnabled
        .CaseSensitive = bCaseSensitive
        .Name = Name
        .Command = Command
        .Simple = bSimple
        .Pattern = Pattern
    End With
    Exit Sub
errHandler:
    ErrorIn "ActionCollection.Add(Name,Pattern,Command,bCaseSensitive,bEnabled,bSimple)", _
         Array(Name, Pattern, Command, bCaseSensitive, bEnabled, bSimple)
End Sub

Friend Sub AddObject(objAction As Action)
    Dim lngIdx As Long
    lngIdx = UBound(arrContents)
    ReDim Preserve arrContents(lngIdx + 1)
    Set arrContents(lngIdx) = objAction
End Sub

Public Sub Remove(Index As Variant)
'// Removes an action. Use the name of the action as Index.
    On Error GoTo errHandler
    Dim lngIdx As Long
    Dim lng As Long
    Dim lngOrigSize As Long
    lngOrigSize = UBound(arrContents) - 1
    lngIdx = GetIndex(Index)
    For lng = lngIdx + 1 To lngOrigSize
        Set arrContents(lng - 1) = arrContents(lng)
    Next
    ReDim Preserve arrContents(lngOrigSize)
    Set arrContents(lngOrigSize) = Nothing
    Exit Sub
errHandler:
    ErrorIn "ActionCollection.Remove(Index)", Index
End Sub

Public Property Get Item(Index As Variant) As Action
Attribute Item.VB_UserMemId = 0
'// Returns the action.
On Error GoTo ErrorH
    Set Item = arrContents(GetIndex(Index))
    Exit Property
ErrorH:
    Set Item = Nothing
End Property

Public Function GetIndex(Index As Variant) As Long
    On Error GoTo errHandler
    Dim lng As Long
    GetIndex = -1
    Select Case VarType(Index)
        Case vbLong, vbByte, vbInteger
            If Index < UBound(arrContents) Then GetIndex = Index
        Case vbString
            For lng = 0 To UBound(arrContents) - 1
                If arrContents(lng).Name = Index Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
        Case vbObject
            For lng = 0 To UBound(arrContents) - 1
                If arrContents(lng) Is Index Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
    End Select
    Exit Function
errHandler:
    ErrorIn "ActionCollection.GetIndex(Index)", Index
End Function

Public Property Get Count() As Long
'// Returns the number of actions in this session.
    On Error GoTo errHandler
    Count = UBound(arrContents)
    Exit Property
errHandler:
    ErrorIn "ActionCollection.Count"
End Property

Public Sub Swap(Index1 As Variant, Index2 As Variant)
'// Swaps to actions.
    On Error GoTo errHandler
    Dim oTemp As Action
    Dim l1 As Long, l2 As Long
    l1 = GetIndex(Index1)
    l2 = GetIndex(Index2)
    Set oTemp = arrContents(l1)
    Set arrContents(l1) = arrContents(l2)
    Set arrContents(l2) = oTemp
    Exit Sub
errHandler:
    ErrorIn "ActionCollection.Swap(Index1,Index2)", Array(Index1, Index2)
End Sub

Private Sub Class_Initialize()
    On Error GoTo errHandler
    ReDim arrContents(0)
    strBuffer = String(ActionBufferLen, vbNullChar)
    Exit Sub
errHandler:
    ErrorIn "ActionCollection.Class_Initialize"
End Sub

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------

Private Sub AddtoBuffer(strInput As String)
    On Error GoTo errHandler
    Dim lngAction As Long
    If Len(strInput) > ActionBufferLen Then strInput = Right(strInput, ActionBufferLen)
    strBuffer = Mid(strBuffer, Len(strInput) + 1) & strInput
    For lngAction = 0 To UBound(arrContents) - 1
        With arrContents(lngAction)
            .SearchFromIdx = .SearchFromIdx - Len(strInput)
            If .SearchFromIdx < 1 Then .SearchFromIdx = 1
        End With
    Next
    Exit Sub
errHandler:
    ErrorIn "ActionCollection.AddtoBuffer(strInput)", strInput
End Sub

Private Sub DoAction(ActionNo As Long)
    On Error GoTo errHandler
    Dim lngCmdIdx As Long
    Dim vntOK As Variant
    Dim objMatches As MatchCollection
    With arrContents(ActionNo)
        Set objMatches = .RegExp.Execute(Mid(strBuffer, .SearchFromIdx))
        While objMatches.Count > 0
            If objMatches.Item(0).Length = 0 Then
                .Enabled = False
                SessionObject.Terminal.PrintString vbCrLf & "#Warning Action " & .Name & " disabled because of zerolength match." & vbCrLf
                Exit Sub
            End If
            .SearchFromIdx = .SearchFromIdx + objMatches.Item(0).FirstIndex + objMatches.Item(0).Length
            SessionObject.EvaluateCommand .Command, MC2Collection(objMatches), GagOutput, True
            Set objMatches = .RegExp.Execute(Mid(strBuffer, .SearchFromIdx))
        Wend
    End With
    Exit Sub
errHandler:
    ErrorIn "ActionCollection.DoAction(ActionNo)", ActionNo
End Sub

Public Sub Evaluate(strText As String)
    On Error GoTo errHandler
'executes all the actions required....
    Dim lngAction As Long
    AddtoBuffer strText
    For lngAction = 0 To UBound(arrContents) - 1
        If arrContents(lngAction).Enabled And arrContents(lngAction).Pattern <> "" Then
            DoAction lngAction
        End If
    Next
    Exit Sub
errHandler:
    ErrorIn "ActionCollection.Evaluate(strText)", strText
End Sub

