VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Alias"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// This holds information about a single alias.

Private sName As String
Private sPattern As String
Private sCommand As String
Private bEnabled As Boolean
Private bSimple As Boolean
Private oRegExp As RegExp
Private bCaseSensitive As Boolean

Private Function SimplePattern2Regexp(sSimple As String) As String
    SimplePattern2Regexp = "^(?:" & sSimple & "|" & sSimple & "\s+(.*))$"
End Function

Private Sub UpdatePattern()
    On Error GoTo RegexpSyntaxError
    If Not bEnabled Then Exit Sub
    Dim sTmpPattern As String
    sTmpPattern = sPattern
    If bSimple Then sTmpPattern = SimplePattern2Regexp(sTmpPattern)
    oRegExp.Pattern = ParseHomeMadeRegExp(sTmpPattern)
    oRegExp.Execute "Syntax check"
Exit Sub
RegexpSyntaxError:
    oRegExp.Pattern = ""
    bEnabled = False
    Err.Raise Regexp_SyntaxError, "Syntax error in regexp. " & sName & " has been disabled.", TypeName(Me)
End Sub

Public Property Get Name() As String
'// Reads or writes the name of the alias.
    Name = sName
End Property
Public Property Let Name(sVal As String)
    sName = sVal
End Property

Public Property Get Pattern() As String
'// Reads or writes the pattern that triggers the alias.
    Pattern = sPattern
End Property

Public Property Let Pattern(sVal As String)
    sPattern = sVal
    UpdatePattern
End Property

Public Property Get Command() As String
'// Reads or writes the command to be executed when the pattern is matched.
    Command = sCommand
End Property
Public Property Let Command(sVal As String)
    On Error GoTo errHandler
    sCommand = ConvertToCRLF(sVal)
    Exit Property
errHandler:
    ErrorIn "alias.Command(sVal)", sVal
End Property

Public Property Get Enabled() As Boolean
'// Reads or writes the Enabled status of the pattern. No aliases will execute if they are disabled.
    Enabled = bEnabled
End Property
Public Property Let Enabled(bVal As Boolean)
    On Error GoTo errHandler
    If bEnabled = bVal Then Exit Property
    bEnabled = bVal
    UpdatePattern
    Exit Property
errHandler:
    ErrorIn "alias.Enabled(bVal)", bVal
End Property

Public Property Get Simple() As Boolean
'// Reads or writes the Simple status. Simple alises match with GLOB patterns. Non-simple match with Regular Expressions.
    Simple = bSimple
End Property
Public Property Let Simple(bVal As Boolean)
    If bSimple = bVal Then Exit Property
    bSimple = bVal
    UpdatePattern
End Property

Public Property Get CaseSensitive() As Boolean
'// reads or writes the CaseSensitive flag. With CaseSensitive enabled, only patterns with right case with match.
    On Error GoTo errHandler
    CaseSensitive = Not oRegExp.IgnoreCase
    Exit Property
errHandler:
    ErrorIn "Alias.CaseSensitive"
End Property
Public Property Let CaseSensitive(bVal As Boolean)
    oRegExp.IgnoreCase = Not bVal
End Property

Public Property Get RegExp() As VBScript_RegExp_55.RegExp
'// Returns the RegExp object this alias will match.
    On Error GoTo errHandler
    Set RegExp = oRegExp
    Exit Property
errHandler:
    ErrorIn "Alias.RegExp"
End Property


Private Sub Class_Initialize()
    On Error GoTo errHandler
    Set oRegExp = New VBScript_RegExp_55.RegExp
    oRegExp.MultiLine = False
    oRegExp.Global = False
    bEnabled = True
    bCaseSensitive = False
    oRegExp.IgnoreCase = Not bCaseSensitive
    Exit Sub
errHandler:
    ErrorIn "Alias.Class_Initialize"
End Sub
