VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AliasCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// Collection holding all aliases.


Private arrContents() As Alias

Private SessionObject As frmSession

Friend Sub Init(SessionForm As frmSession)
    Set SessionObject = SessionForm
End Sub

Public Sub Add(Name As String, Pattern As String, Command As String, bCaseSensitive As Boolean, Optional bEnabled As Boolean = True, Optional bSimple As Boolean = True)
'// Adds a new alias.
    On Error GoTo errHandler
    Dim lngIdx As Long
    lngIdx = GetIndex(Name)
    If lngIdx = -1 Then
        lngIdx = UBound(arrContents)
        ReDim Preserve arrContents(lngIdx + 1)
        Set arrContents(lngIdx) = New Alias
    End If
    With arrContents(lngIdx)
        .Enabled = bEnabled
        .CaseSensitive = bCaseSensitive
        .Name = Name
        .Simple = bSimple
        .Command = Command
        .Pattern = Pattern
    End With
    Exit Sub
errHandler:
    ErrorIn "AliasCollection.Add(Name,Pattern,Command,bCaseSensitive,bEnabled,bSimple)", _
         Array(Name, Pattern, Command, bCaseSensitive, bEnabled, bSimple)
End Sub

Friend Sub AddObject(objAlias As Alias)
    Dim lngIdx As Long
    lngIdx = UBound(arrContents)
    ReDim Preserve arrContents(lngIdx + 1)
    Set arrContents(lngIdx) = objAlias
End Sub

Public Sub Remove(Index As Variant)
'// Removed an alias. Index can be a number or the name of the alias.
    On Error GoTo errHandler
    Dim lngIdx As Long
    Dim lng As Long
    Dim lngOrigSize As Long
    lngOrigSize = UBound(arrContents) - 1
    lngIdx = GetIndex(Index)
    For lng = lngIdx + 1 To lngOrigSize
        Set arrContents(lng - 1) = arrContents(lng)
    Next
    ReDim Preserve arrContents(lngOrigSize)
    Set arrContents(lngOrigSize) = Nothing
    Exit Sub
errHandler:
    ErrorIn "AliasCollection.Remove(Index)", Index
End Sub

Public Property Get Item(Index As Variant) As Alias
Attribute Item.VB_UserMemId = 0
'// Default property. Returns an alias.
On Error GoTo ErrorH
    Set Item = arrContents(GetIndex(Index))
    Exit Property
ErrorH:
    Set Item = Nothing
End Property

Public Function GetIndex(Index As Variant) As Long
    On Error GoTo errHandler
    Dim lng As Long
    GetIndex = -1
    Select Case VarType(Index)
        Case vbLong, vbByte, vbInteger
            If Index < UBound(arrContents) Then GetIndex = Index
        Case vbString
            For lng = 0 To UBound(arrContents) - 1
                If arrContents(lng).Name = Index Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
        Case vbObject
            For lng = 0 To UBound(arrContents) - 1
                If arrContents(lng) Is Index Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
    End Select
    Exit Function
errHandler:
    ErrorIn "AliasCollection.GetIndex(Index)", Index
End Function

Public Property Get Count() As Long
'// Returns the number of aliases in the collection.
    On Error GoTo errHandler
    Count = UBound(arrContents)
    Exit Property
errHandler:
    ErrorIn "AliasCollection.Count"
End Property

Public Sub Swap(Index1 As Variant, Index2 As Variant)
'// Swaps the index of two aliases.
    On Error GoTo errHandler
    Dim oTemp As Alias
    Dim l1 As Long, l2 As Long
    l1 = GetIndex(Index1)
    l2 = GetIndex(Index2)
    Set oTemp = arrContents(l1)
    Set arrContents(l1) = arrContents(l2)
    Set arrContents(l2) = oTemp
    Exit Sub
errHandler:
    ErrorIn "AliasCollection.Swap(Index1,Index2)", Array(Index1, Index2)
End Sub

Private Sub Class_Initialize()
    On Error GoTo errHandler
    ReDim arrContents(0)
    Exit Sub
errHandler:
    ErrorIn "AliasCollection.Class_Initialize"
End Sub

Public Function Evaluate(strText As String) As Variant
'// Evaluates the command strText against this alias and executes if it matches.
    On Error GoTo errHandler
'executes all the actions required....
    Dim lngIdx As Long
    Dim objMatches As MatchCollection
    For lngIdx = 0 To UBound(arrContents) - 1
        With arrContents(lngIdx)
            If .Enabled Then
                Set objMatches = .RegExp.Execute(strText)
                If objMatches.Count > 0 Then
                    Evaluate = InsertMatches(.Command, MC2Collection(objMatches))
                    Exit Function
                End If
            End If
        End With
    Next
    Evaluate = Null
    Exit Function
errHandler:
    ErrorIn "AliasCollection.Evaluate(strText)", strText
End Function
