VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Buffers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// This class holds some information linked to a specific output source. Changing the buffer can redirect output from one source to another.
'// The constants are:
'//    bf_CurrentBuffer = -1
'//    bf_MUDResponse = 0
'//    bf_SubstituteResponse = 1
'//    bf_TestResponse = 2
'//    bf_WebResponse = 3


Public Enum enmBuffer
    bf_CurrentBuffer = -1
    bf_MUDResponse = 0
    bf_SubstituteResponse = 1
    bf_TestResponse = 2
    bf_WebResponse = 3
End Enum

Private lCurrentBuffer As enmBuffer

Private oBuffers(4) As StringBuffer

Private oSession As frmSession

Friend Sub Init(oInitSession As frmSession)
    Dim l As Long
    Set oSession = oInitSession
    lCurrentBuffer = bf_MUDResponse
    For l = 0 To UBound(oBuffers)
        Set oBuffers(l) = New StringBuffer
    Next
End Sub

Public Property Get Buffer(Optional ByVal lBufferNo As enmBuffer = bf_CurrentBuffer) As StringBuffer
'// Reads the value of the selected buffer. If no buffer is selected, the current(default for the scope) buffer will be used.
    If lBufferNo = bf_CurrentBuffer Then lBufferNo = lCurrentBuffer
    Set Buffer = oBuffers(lBufferNo)
End Property

Public Sub Append(ByVal sIn As String)
'// Adds a string to the current buffer.
    Buffer(lCurrentBuffer).Append sIn
End Sub

Public Property Let BufferNo(lNewBuffer As enmBuffer)
'// Read/write. The current buffer in use.
    If lNewBuffer = bf_CurrentBuffer Then Exit Property
    lCurrentBuffer = lNewBuffer
End Property
Public Property Get BufferNo() As enmBuffer
    BufferNo = lCurrentBuffer
End Property
