VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CommandHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// Handles scripts and parsing of commands.

Public Script As New ScriptHandler
'// Returns the script object.

Private Enum enmParseState
    Normal = 1
    InScript = 2
    InEyes = 512
    InEscape = 1024
    InStatement = 2048
    InExpression = 4096
    InLine = 8192 'is this a mixed script and nonscript line?
    OutputInEyes = 16384
    MustBeExecuted = 32768 'use response.append or cmdhandler.executeline
End Enum

Private SessionObject As frmSession

Friend Sub Init(SessionForm As frmSession)
    On Error GoTo errHandler
    Set SessionObject = SessionForm
    Script.Init SessionForm
    Exit Sub
errHandler:
    ErrorIn "CommandHandler.Init(SessionForm)", SessionForm
End Sub


Private Function ConvertToScript(sCommand As String) As String
    Dim lParseState As enmParseState
    Dim C As String
    Dim lastC As String
    Dim l As Long
    Dim sOut As String
    Dim sCollect As String
    sOut = ""
    lParseState = Normal
    For l = 1 To Len(sCommand)
        C = Mid(sCommand, l, 1)
        If (lParseState And InEscape) > 0 Then
            sCollect = sCollect & C
            lParseState = lParseState Xor InEscape 'go out of escape mode
        ElseIf ((lParseState And InScript) > 0) And ((lParseState And InEyes) = 0) Then
            Select Case C
                Case ">"
                    If lastC = "%" Then
                        sCollect = Left(sCollect, Len(sCollect) - 1) 'remove %
                        lParseState = (lParseState And (MustBeExecuted)) Or Normal
                        C = ""
                    End If
                Case vbCr
                    C = ""
                Case "="
                    If (lParseState And (InStatement Or InExpression)) = 0 Then
                        If Len(sCollect) > 0 Then
                            sCollect = sCollect & " & "
                        End If
                        lParseState = lParseState Or InExpression Or MustBeExecuted
                        C = ""
                    End If
                Case " ", vbTab
                    If (lParseState And InStatement) = 0 Then
                        C = "" 'eat whitespace in beginning of line
                    End If
                Case vbLf
                    If (lParseState And MustBeExecuted) > 0 Then
                        sOut = sOut & "Session.Cmdhandler.ExecuteLine " & sCollect & " & vblf " & vbLf
                    Else
                        If Len(sCollect) > 0 Then
                            sOut = sOut & sCollect & vbLf
                        End If
                    End If
                    C = ""
                    sCollect = ""
                    lParseState = InScript  'remove ineyes, mustbeex, inexpr, instate
                Case """"
                    lParseState = lParseState Or InEyes
            End Select
            If Len(C) > 0 Then
                If (lParseState And InStatement) = 0 Then
                    If (Len(sCollect) > 0) And ((lParseState And InExpression) = 0) Then
                        'happens if we get something like: monkey <% DoSomething %>
                        If (lParseState And MustBeExecuted) > 0 Then
                            sOut = sOut & "Session.Cmdhandler.ExecuteLine " & sCollect & " & vblf " & vbLf
                        Else
                            If Len(sCollect) > 0 Then
                                sOut = sOut & sCollect & vbLf
                            End If
                        End If
                        sCollect = ""
                        lParseState = InScript
                    End If
                End If
                sCollect = sCollect & C
                lParseState = lParseState Or InStatement
            End If
        ElseIf (lParseState And (InScript Or InEyes)) > 0 Then
            Select Case C
                Case """"
                    sCollect = sCollect & C
                    lParseState = lParseState And (Not InEyes)
                Case vbLf
                    sCollect = sCollect & C
                    lParseState = lParseState And (Not InEyes)
                Case Else
                    sCollect = sCollect & C
            End Select
        ElseIf (lParseState And Normal) > 0 Then
            Select Case C
                Case "%"
                    If lastC = "<" Then
                        sCollect = Left(sCollect, Len(sCollect) - 1) 'remove <
                        If sCollect = """" Then
                            sCollect = ""
                            lParseState = lParseState And (Not OutputInEyes)
                        End If
                        If lParseState And OutputInEyes Then
                            sCollect = sCollect & """"
                            lParseState = lParseState Xor OutputInEyes
                        End If
                        lParseState = lParseState Or InScript
                    Else
                        If (lParseState And OutputInEyes) = 0 Then
                            If Len(sCollect) = 0 Then
                                sCollect = sCollect & """"
                            Else
                                sCollect = sCollect & " & """
                            End If
                            lParseState = lParseState Or OutputInEyes
                        End If
                        lParseState = lParseState Or MustBeExecuted
                        sCollect = sCollect & C
                    End If
                Case "\" 'escapes should just be respected not deescaped...
                         'they will be unescaped in session.executeline except
                    sCollect = sCollect & C
                    lParseState = lParseState Or InEscape
                Case vbCr 'eat cr's
                Case vbLf
                    If (lParseState And OutputInEyes) > 0 Then
                        sCollect = sCollect & """"
                        lParseState = lParseState Xor OutputInEyes
                    End If
                    If Len(sCollect) > 0 Then
                        sOut = sOut & "Session.Cmdhandler.ExecuteLine " & sCollect & " & vbLf" & vbLf
                    Else
                        sOut = sOut & "Session.Response.Append vbLf" & vbLf
                    End If
                    sCollect = ""
                    lParseState = Normal
                Case """"
                    If (lParseState And OutputInEyes) = 0 Then
                        If Len(sCollect) = 0 Then
                            sCollect = sCollect & """"
                        Else
                            sCollect = sCollect & " & """
                        End If
                        lParseState = lParseState Or OutputInEyes
                    End If
                    lParseState = lParseState Or MustBeExecuted
                    sCollect = sCollect & """"""
                Case Else
                    If (lParseState And OutputInEyes) = 0 Then
                        If Len(sCollect) = 0 Then
                            sCollect = sCollect & """"
                        Else
                            sCollect = sCollect & " & """
                        End If
                        lParseState = lParseState Or OutputInEyes
                    End If
                    lParseState = lParseState Or MustBeExecuted
                    sCollect = sCollect & C
            End Select
        End If
        If ((lParseState And InEscape) = 0) And lastC = "\" Then
            lastC = "\" & C
        Else
            lastC = C
        End If
    Next
    
    If Len(sCollect) > 0 Then
        If (lParseState And OutputInEyes) Then
            sCollect = sCollect & """"
        End If
        If (lParseState And InScript) > 0 Then '<% er ikke afsluttet
            If (lParseState And MustBeExecuted) > 0 Then
                sOut = sOut & "Session.Cmdhandler.ExecuteLine " & sCollect
            Else
                sOut = sOut & sCollect
            End If
        Else
            sOut = sOut & "Session.cmdhandler.ExecuteLine " & sCollect
        End If
    End If
    ConvertToScript = sOut
End Function

Public Sub Execute(ByVal sCommand As String, Optional ByVal oMatches As Collection = Nothing, Optional lBuffer As enmBuffer = bf_CurrentBuffer, Optional bResetRecursionLevel As Boolean = False)
'// Executes a command but no result is written and the resultbuffer will grow (See and use the EvaluateCommand on the session object.
'// If you insist on using this (might come in handy?) remember to read from Response.Buffer with the called buffer and then flushing the Buffer afterwards. If you do not flush it, it will stay in the buffer and might be executed later.
    Dim sScript As String
    Dim lTempBuffer As Long
On Error GoTo errHandler
    Static lRecursionLevel As Long
    If bResetRecursionLevel Then lRecursionLevel = 0
    If lRecursionLevel > 100 Then 'infinite recursion
        If (lRecursionLevel And &H40000000) = 0 Then
            lRecursionLevel = lRecursionLevel Or &H40000000
            SessionObject.Terminal.PrintString vbCrLf & "WARNING: Recursion limit exceeded" & vbCrLf
        End If
        Exit Sub
    End If
    lRecursionLevel = lRecursionLevel + 1
    lTempBuffer = SessionObject.Response.BufferNo 'PUSH
    SessionObject.Response.BufferNo = lBuffer
    
    If sCommand = "" Then Exit Sub
    sCommand = InsertMatches(sCommand, oMatches)
    sScript = ConvertToScript(sCommand)
    Script.ExecuteCommand sScript
    
    SessionObject.Response.BufferNo = lTempBuffer 'POP
    lRecursionLevel = lRecursionLevel - 1
    Exit Sub
errHandler:
    lRecursionLevel = lRecursionLevel - 1
    ErrorIn "CommandHandler.Execute(sCommand,oMatches,lBuffer)", Array(sCommand, oMatches, lBuffer)
End Sub

Public Function ExecuteLine(ByVal sLine As String, Optional lBuffer As enmBuffer = bf_CurrentBuffer)
'// Executes a single line against the selected buffer(lBuffer). After the execution the buffer will revert to the default buffer(or the last set with .BufferNo)
    Dim vCommands As Variant
    Dim bNewLine As Boolean
    Dim lTempBuffer As Long
    lTempBuffer = SessionObject.Response.BufferNo 'PUSH
    SessionObject.Response.BufferNo = lBuffer
    
    If Right(sLine, 1) = vbLf Then
        sLine = Left(sLine, Len(sLine) - 1)
        bNewLine = True
    End If
    
    vCommands = SessionObject.Aliases.Evaluate(sLine)
    If IsNull(vCommands) Then
        SessionObject.Response.Append UnEscape(sLine)
    Else
        Execute vCommands
    End If
    If bNewLine Then SessionObject.Response.Append vbLf

    SessionObject.Response.BufferNo = lTempBuffer 'POP
End Function


Private Sub Class_Initialize()
    'AutoUpdate = False
    'WalkLettersEnabled = True
End Sub

