VERSION 5.00
Begin VB.UserControl DetailsAction 
   ClientHeight    =   5685
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4395
   ScaleHeight     =   5685
   ScaleWidth      =   4395
   ToolboxBitmap   =   "DetailsAction.ctx":0000
   Begin VB.CheckBox SimpleSyntax 
      Caption         =   "Simple Pattern"
      Height          =   255
      Left            =   0
      TabIndex        =   5
      Top             =   4560
      Width           =   1335
   End
   Begin VB.CheckBox CaseSensitive 
      Caption         =   "Case sensitive"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   4080
      Width           =   1335
   End
   Begin VB.CheckBox Active 
      Caption         =   "Active"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   4320
      Value           =   1  'Checked
      Width           =   855
   End
   Begin VB.TextBox txtName 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   240
      Width           =   3495
   End
   Begin VB.TextBox txtPattern 
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Top             =   840
      Width           =   3495
   End
   Begin VB.TextBox txtCommand 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2535
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   1440
      Width           =   3495
   End
   Begin VB.Label lblName 
      Caption         =   "Action Name:"
      Height          =   255
      Left            =   0
      TabIndex        =   8
      Top             =   0
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Commands:"
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   1200
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Pattern:"
      Height          =   255
      Left            =   0
      TabIndex        =   6
      Top             =   600
      Width           =   615
   End
End
Attribute VB_Name = "DetailsAction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private oAction As Action
Private sKey As String

Public Event Change(objAction As Action, ByRef strKey As String)


Public Sub Init(objAction As Action, strKey As String)
    On Error GoTo errHandler
    If Not objAction Is oAction Then Update 'auto update when necesarry
    Set oAction = objAction
    sKey = strKey
    If Not oAction Is Nothing Then 'if not new
        txtName.Text = oAction.Name
        txtPattern.Text = oAction.Pattern
        txtCommand.Text = oAction.Command
        Active.Value = oAction.Enabled And 1
        CaseSensitive.Value = oAction.CaseSensitive And 1
        SimpleSyntax.Value = oAction.Simple And 1
    Else
        txtName.Text = ""
        txtPattern.Text = ""
        txtCommand.Text = ""
        Active.Value = 1
        CaseSensitive.Value = 0
        SimpleSyntax.Value = 1
    End If
    Exit Sub
errHandler:
    ErrorIn "DetailsAction.Init(objAction,strKey)", Array(objAction, strKey)
End Sub

Private Sub UserControl_ExitFocus()
    On Error GoTo errHandler
   Update 'auto update when necesarry
    Exit Sub
errHandler:
    ErrorIn "DetailsAction.UserControl_ExitFocus", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Hide()
    On Error GoTo errHandler
    Set oAction = Nothing
    txtName.Text = ""
    sKey = ""
    Exit Sub
errHandler:
    ErrorIn "DetailsAction.UserControl_Hide", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    txtName.Width = UserControl.ScaleWidth
    txtCommand.Width = UserControl.ScaleWidth
    txtPattern.Width = UserControl.ScaleWidth
    SimpleSyntax.Top = UserControl.ScaleHeight - SimpleSyntax.Height
    Active.Top = SimpleSyntax.Top - Active.Height
    CaseSensitive.Top = Active.Top - CaseSensitive.Height
    txtCommand.Height = CaseSensitive.Top - txtCommand.Top
End Sub

Public Sub Update()
    On Error GoTo errHandler
    If oAction Is Nothing Then 'if not new
        If Trim(txtName.Text) = "" Then Exit Sub
        Set oAction = New Action
    End If
    With oAction
        On Error Resume Next
        .Enabled = False 'disable the syntax check while updating
        .CaseSensitive = (CaseSensitive.Value = 1)
        .Simple = (SimpleSyntax.Value = 1)
        .Pattern = txtPattern.Text
        .Name = txtName.Text
        .Command = txtCommand.Text
        .Enabled = (Active.Value = 1) And (Err.Number = 0)
        If Err.Number <> 0 Then
            MsgBox "Error during update:" & vbCrLf & vbCrLf & Err.Description, , "MonkeyTerm"
        End If
    End With
    RaiseEvent Change(oAction, sKey)
    Exit Sub
errHandler:
    ErrorIn "DetailsAction.Update"
End Sub



