VERSION 5.00
Begin VB.UserControl DetailsEvent 
   ClientHeight    =   5775
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3840
   ScaleHeight     =   5775
   ScaleWidth      =   3840
   ToolboxBitmap   =   "DetailsEvent.ctx":0000
   Begin MonkeyTerm.PropertyEditor Prop 
      Height          =   375
      Left            =   0
      TabIndex        =   3
      Top             =   5160
      Width           =   3495
      _ExtentX        =   6165
      _ExtentY        =   661
   End
   Begin VB.ComboBox cmbType 
      Height          =   315
      ItemData        =   "DetailsEvent.ctx":0312
      Left            =   1080
      List            =   "DetailsEvent.ctx":0314
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   720
      Width           =   2415
   End
   Begin VB.TextBox txtName 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   240
      Width           =   3495
   End
   Begin VB.TextBox txtCommand 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3735
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   1440
      Width           =   3495
   End
   Begin VB.Label Label1 
      Caption         =   "Event Type:"
      Height          =   255
      Left            =   0
      TabIndex        =   6
      Top             =   720
      Width           =   975
   End
   Begin VB.Label lblName 
      Caption         =   "Event Name:"
      Height          =   255
      Left            =   0
      TabIndex        =   5
      Top             =   0
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Commands:"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   1200
      Width           =   1575
   End
End
Attribute VB_Name = "DetailsEvent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private oEvent As clsEvent
Private sKey As String
Private Const cMaxHeight As Long = 910

Public Event Change(objEvent As clsEvent, ByRef strKey As String)

Public Sub Init(objEvent As clsEvent, strKey As String)
    On Error GoTo errHandler
    Dim lngLoop As Long
    
    If Not objEvent Is oEvent Then  ' New event.
        Update 'auto update when necesarry
    End If
    
    cmbType.Clear       ' Find better Init place...
    For lngLoop = 1 To UBound(arrEventTypes)
        cmbType.AddItem arrEventTypes(lngLoop)
    Next
        
    Set oEvent = objEvent
    sKey = strKey
    If Not oEvent Is Nothing Then 'if not new
        txtName.Text = oEvent.Name
        txtCommand.Text = oEvent.Command
        cmbType.ListIndex = oEvent.EventType - 1    ' _click() gets called and properties sat accordingly if type changed.
        Select Case objEvent.EventType
            Case etTimer
                Prop.Property("Interval") = objEvent.GetData("Interval")
                Prop.Property("FireOnce") = objEvent.GetData("FireOnce")
            Case etWeb
                Prop.Property("Pattern") = objEvent.GetData("Pattern")
            Case Else
        End Select
        Prop.Property("Enabled") = oEvent.Enabled
    Else
        txtName.Text = ""
        txtCommand.Text = ""
        Prop.ClearPropertySheet
        Prop.AddProperty "Enabled", prpBoolean
        Prop.Property("Enabled") = False
        Prop.AdjustHeight cMaxHeight
        cmbType.ListIndex = -1
    End If
    
    Exit Sub
errHandler:
    ErrorIn "DetailsEvent.Init(objEvent,strKey)", Array(objEvent, strKey)
End Sub

Private Sub cmbType_click()
    On Error GoTo errHandler
    Prop.ClearPropertySheet
    Select Case cmbType.ListIndex + 1
        Case etUndefinied ', etWeb
        Case etTimer
            Prop.AddProperty "Interval", prpNumber, "^\d{1,4}$|^\d{0,4}\.\d{1,5}$"
            Prop.AddProperty "FireOnce", prpBoolean
        Case etWeb
            Prop.AddProperty "Pattern", prpText
    End Select
    Prop.AddProperty "Enabled", prpBoolean
    Prop.AdjustHeight cMaxHeight
    UserControl_Resize
    Exit Sub
errHandler:
    ErrorIn "DetailsEvent.cmbType_click", , EA_EXTERNCALL
    HandleError
End Sub



Private Sub UserControl_ExitFocus()
    On Error GoTo errHandler
   Update 'auto update when necesarry
    Exit Sub
errHandler:
    ErrorIn "DetailsEvent.UserControl_ExitFocus", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Hide()
    On Error GoTo errHandler
    Set oEvent = Nothing
    txtName.Text = ""
    Prop.ClearPropertySheet
    sKey = ""
    Exit Sub
errHandler:
    ErrorIn "DetailsEvent.UserControl_Hide", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    txtName.Width = UserControl.ScaleWidth
    txtCommand.Width = UserControl.ScaleWidth
    Prop.Top = UserControl.ScaleHeight - Prop.Height
    Prop.Width = UserControl.ScaleWidth
    txtCommand.Height = Prop.Top - txtCommand.Top
End Sub

Public Sub Update() 'Optional blnNewEvent As Boolean = False)
    On Error GoTo errHandler
    Dim objCol As Collection
    Dim blnDelete As Boolean
    
    If (Trim(txtName.Text) = "") Or (sKey = "") Then Exit Sub
    
    If (oEvent Is Nothing) Then Set oEvent = New clsEvent
    With oEvent
        .Command = txtCommand.Text
        .Name = txtName.Text
        .Enabled = Prop.Property("Enabled")
        .EventType = cmbType.ListIndex + 1
        Select Case .EventType
            Case etTimer
                Set objCol = New Collection
                objCol.Add Prop.Property("FireOnce"), "FireOnce"
                objCol.Add Prop.Property("Interval"), "Interval"
            Case etWeb
                Set objCol = New Collection
                objCol.Add Prop.Property("Pattern"), "Pattern"
        End Select
        If Not (objCol Is Nothing) Then .SetData objCol
    End With
    
    RaiseEvent Change(oEvent, sKey)
    Exit Sub
errHandler:
    ErrorIn "DetailsEvent.Update"
End Sub




