Attribute VB_Name = "ErrorHandling"
Option Explicit

Public Const ForAppending = 8

Public Enum ErrorCodes
    Regexp_SyntaxError = vbObjectError + 10
    LoadSave_FileNotFound = vbObjectError + 100
    LoadSave_ErrorLoading = vbObjectError + 101
    LoadSave_ErrorSaving = vbObjectError + 102
    StackUnderflow
    StackOverflow
End Enum


Public Sub LogEvent(strEventType As String, strMsg As String)
    On Error GoTo ErrorHandler
    Static bDisabled As Boolean
    If bDisabled Then Exit Sub
    Dim oFSO As Object
    Dim oTS As Object
    Set oFSO = CreateObject("Scripting.FileSystemObject")
    Set oTS = oFSO.OpenTextFile(App.Path & "\MonkeyLog.txt", ForAppending, True)
    oTS.WriteLn Left(strEventType & Space(8), 8) & Now & " " & strMsg
    oTS.Close
Exit Sub
ErrorHandler:
    bDisabled = True
    MsgBox "Could't log event... Logging will be disabled." & vbCrLf & vbCrLf & strEventType & ": " & strMsg, vbCritical, "MonkeyTerm"
End Sub

Public Sub LogError(strLocation As String, lngErrNumber As Long, strErrorDescription As String, Optional bExposeUser = True, _
Optional bReRaiseError As Boolean = False)
    LogEvent "ERROR", strLocation & "  " & lngErrNumber & ":" & strErrorDescription
    If bExposeUser Then
        MsgBox "The following error was logged." & vbCrLf & vbCrLf & strLocation & ":" & strErrorDescription, vbCritical, "MonkeyTerm"
    End If
    If bReRaiseError Then
        Err.Raise lngErrNumber, strLocation, strErrorDescription
    End If
End Sub

Public Sub Assert(blnExpression As String, strDescription As String)
    If blnExpression Then Err.Raise vbObjectError + 10, , "Assert Failed: " & vbCrLf & strDescription
End Sub

Public Function HandleError()
    ErrSaveToFile
    MsgBox ErrReport
End Function

