VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "KeyBinding"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// Holds information about a specific keybinding.

Private intKeyCode As Integer
Private intShift As Integer
Private strCommand As String
Private blnEnabled As Boolean

Public Property Get KeyCode() As Integer
'// Read/write. The keycode associated with the keybinding.
    KeyCode = intKeyCode
End Property

Public Property Let KeyCode(KeyCode As Integer)
    intKeyCode = KeyCode
End Property

Public Property Get Shift() As Integer
'// Read/write. The Shift status of the keybinding.
'// FLAG 3-digit binary field (Alt, Ctrl, Shift). Or in other words, Shift=1, Ctrl=2 and Alt=4.
    Shift = intShift
End Property

Public Property Let Shift(Shift As Integer)
    intShift = Shift
End Property

Public Property Get Command() As String
'// Read/write. The commands to be executed once the keybinding is hit.
    Command = strCommand
End Property

Public Property Let Command(Command As String)
    strCommand = Command
End Property

Public Property Get Enabled() As Boolean
'// Read/write. When False, the keybinding is turned off.
    Enabled = blnEnabled
End Property

Public Property Let Enabled(Enabled As Boolean)
    blnEnabled = Enabled
End Property

Public Property Get Name() As String
'// Returns the name of the keybinding, which is a combination of the Keycode and the Shift.
    Name = GetKeyCombination
End Property

Friend Property Get GetKeyCode() As String
    Select Case intKeyCode
        Case Asc("A") To Asc("Z"), Asc("0") To Asc("9"), Asc("."), _
            Asc(",")
            GetKeyCode = Chr(intKeyCode)
        Case vbKeyNumpad0 To vbKeyNumpad9
            GetKeyCode = "Numpad " & Chr(intKeyCode - vbKeyNumpad0 + Asc("0"))
        Case vbKeyF1 To vbKeyF12
            GetKeyCode = "F" & CStr(intKeyCode - vbKeyF1 + 1)
        Case vbKeyScrollLock
            GetKeyCode = "Scroll Lock"
        Case vbKeyPause
            GetKeyCode = "Pause"
        Case vbKeyEscape
            GetKeyCode = "Escape"
        Case vbKeyUp
            GetKeyCode = "Up"
        Case vbKeyDown
            GetKeyCode = "Down"
        Case vbKeyLeft
            GetKeyCode = "Left"
        Case vbKeyRight
            GetKeyCode = "Right"
        Case vbKeyInsert
            GetKeyCode = "Insert"
        Case vbKeyDelete
            GetKeyCode = "Delete"
        Case vbKeyHome
            GetKeyCode = "Home"
        Case vbKeyEnd
            GetKeyCode = "End"
        Case vbKeyPageUp
            GetKeyCode = "PageUp"
        Case vbKeyPageDown
            GetKeyCode = "PageDown"
        Case vbKeyAdd
            GetKeyCode = "[+]"
        Case vbKeySubtract
            GetKeyCode = "[-]"
        Case vbKeyMultiply
            GetKeyCode = "[*]"
        Case vbKeyDivide
            GetKeyCode = "[/]"
        Case Else
            GetKeyCode = "[" & intKeyCode & "]"
    End Select
End Property

Public Property Get GetKeyCombination() As String
    On Error GoTo errHandler
    Dim strShift As String
    strShift = ""
    Select Case intShift
        Case 0
        Case 1
            strShift = "Shift+"
        Case 2
            strShift = "Ctrl+"
        Case 3
            strShift = "Shift+Ctrl+"
        Case 4
            strShift = "Alt+"
        Case 5
            strShift = "Shift+Alt+"
        Case 6
            strShift = "Alt+Ctrl+"
        Case 7
            strShift = "Shift+Alt+Ctrl+"
        Case Else
            strShift = "????+"
    End Select
    GetKeyCombination = strShift & GetKeyCode
    Exit Property
errHandler:
    ErrorIn "KeyBinding.GetKeyCombination"
End Property



