VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "KeyBindingCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private objKeyBindings As Collection

Public Sub AddObject(oKeyBinding As KeyBinding)
    With oKeyBinding
        Add .KeyCode, .Shift, .Command, .Enabled
    End With
End Sub

Public Sub Add(KeyCode As Integer, Shift As Integer, Command As String, Enabled As Boolean)
    On Error GoTo errHandler
    Dim lngIdx As Long
    Dim objKeyBind As KeyBinding
    lngIdx = GetIndex(KeyCode, Shift)
    If lngIdx = -1 Then
        Set objKeyBind = New KeyBinding
    Else
        Set objKeyBind = objKeyBindings(lngIdx)
    End If
    
    With objKeyBind
        .KeyCode = KeyCode
        .Shift = Shift
        .Command = ConvertToCRLF(Command)
        .Enabled = Enabled
    End With
    objKeyBindings.Add objKeyBind, objKeyBind.GetKeyCombination ' GetKeyCombination(KeyCode, Shift)
    Exit Sub
errHandler:
    ErrorIn "KeyBindingCollection.Add(KeyCode,Shift,Command)", Array(KeyCode, Shift, Command)
End Sub

Public Sub Remove(KeyCode As Integer, Optional Shift As Integer = -1)
    On Error GoTo errHandler
    objKeyBindings.Remove GetIndex(KeyCode, Shift)
    Exit Sub
errHandler:
    ErrorIn "KeyBindingCollection.Remove(KeyCode,Shift)", Array(KeyCode, Shift)
End Sub

'Public Property Get ItemCommand(KeyCode As Integer, Optional Shift As Integer = -1) As String
'    On Error GoTo errHandler
'    With objKeyBindings(GetIndex(KeyCode, Shift))
'        ItemCommand = .Command
'    End With
'    Exit Property
'errHandler:
'    ErrorIn "KeyBindingCollection.ItemCommand(KeyCode,Shift)", Array(KeyCode, Shift)
'End Property
'
'Public Property Let ItemCommand(KeyCode As Integer, Optional Shift As Integer = -1, strVal As String)
'    On Error GoTo errHandler
'    With objKeyBindings(GetIndex(KeyCode, Shift))
'        .Command = ConvertToCRLF(strVal)
'    End With
'    Exit Property
'errHandler:
'    ErrorIn "KeyBindingCollection.ItemCommand(KeyCode,Shift,strVal)", Array(KeyCode, Shift, strVal)
'End Property
'
'Public Property Get ItemKeyCode(KeyCode As Integer, Optional Shift As Integer = -1) As Integer
'    On Error GoTo errHandler
'    With objKeyBindings(GetIndex(KeyCode, Shift))
'        ItemKeyCode = .KeyCode
'    End With
'    Exit Property
'errHandler:
'    ErrorIn "KeyBindingCollection.ItemKeyCode(KeyCode,Shift)", Array(KeyCode, Shift)
'End Property
'
'Public Property Let ItemKeyCode(KeyCode As Integer, Optional Shift As Integer = -1, intVal As Integer)
'    On Error GoTo errHandler
'    With objKeyBindings(GetIndex(KeyCode, Shift))
'        .KeyCode = intVal
'    End With
'    Exit Property
'errHandler:
'    ErrorIn "KeyBindingCollection.ItemKeyCode(KeyCode,Shift,intVal)", Array(KeyCode, Shift, intVal)
'End Property
'
'Public Property Get ItemShift(KeyCode As Integer, Optional Shift As Integer = -1) As Integer
'    On Error GoTo errHandler
'    With objKeyBindings(GetIndex(KeyCode, Shift))
'        ItemShift = .Shift
'    End With
'    Exit Property
'errHandler:
'    ErrorIn "KeyBindingCollection.ItemShift(KeyCode,Shift)", Array(KeyCode, Shift)
'End Property
'
'Public Property Let ItemShift(KeyCode As Integer, Optional Shift As Integer = -1, intVal As Integer)
'    On Error GoTo errHandler
'    With objKeyBindings(GetIndex(KeyCode, Shift))
'        .Shift = intVal
'    End With
'    Exit Property
'errHandler:
'    ErrorIn "KeyBindingCollection.ItemShift(KeyCode,Shift,intVal)", Array(KeyCode, Shift, intVal)
'End Property
'
'Public Property Get ItemKeyCombination(KeyCode As Integer, Optional Shift As Integer = -1) As String
'    On Error GoTo errHandler
'    With objKeyBindings(GetIndex(KeyCode, Shift))
'        ItemKeyCombination = GetKeyCombination(.KeyCode, .Shift)
'    End With
'    Exit Property
'errHandler:
'    ErrorIn "KeyBindingCollection.ItemKeyCombination(KeyCode,Shift)", Array(KeyCode, Shift)
'End Property

Public Function GetIndex(KeyCode, Optional Shift As Integer = -1) As Long
    On Error GoTo errHandler
    Dim lng As Long
    GetIndex = -1
    If Shift = -1 Then
        GetIndex = KeyCode
    Else
        For lng = 1 To objKeyBindings.Count
            With objKeyBindings(lng)
                If .KeyCode = KeyCode And .Shift = Shift Then
                    GetIndex = lng
                    Exit Function
                End If
            End With
        Next
    End If
    Exit Function
errHandler:
    ErrorIn "KeyBindingCollection.GetIndex(KeyCode,Shift)", Array(KeyCode, Shift)
End Function

Public Property Get Item(Index) As KeyBinding
Attribute Item.VB_UserMemId = 0
    Set Item = objKeyBindings(GetIndex(Index))
End Property

Public Property Get Count() As Long
    On Error GoTo errHandler
    Count = objKeyBindings.Count
    Exit Property
errHandler:
    ErrorIn "KeyBindingCollection.Count"
End Property

Private Sub Class_Initialize()
    On Error GoTo errHandler
    Set objKeyBindings = New Collection
    Exit Sub
errHandler:
    ErrorIn "KeyBindingCollection.Class_Initialize"
End Sub
