Attribute VB_Name = "MainModule"
Option Explicit

Private strMonkeyIcon As String

Public Application As frmMain
Public RecentFiles As New RecentCollection
Public TipOfTheDay As Boolean


Public Const ActionBufferLen = 2048
Public Const strFileFilter = "MonkeyTerm Sessions (*.xml)|*.xml|All Files (*.*)|*.*"
Public Const strRegistryOffset = "Software\MonkeyTerm"
Public arrEventTypes As Variant

Type typLogInfo
    blnLog As Boolean
    objFile As Object
    strFileName As String
    'strLine As String
End Type

Public Enum eEventType
    etUndefinied = 0
    etTimer = 1
    etWeb = 2
    etOnSave = 3
    etOnLoad = 4
    etOnConnect = 5
    etOnDisconnect = 6
    etOnOpen = 7
    etOnClose = 8
    etOnSelectedText = 9
    etOnDocumentComplete = 10
    etOnTerminalSelect = 11
End Enum

Public Sub Main()
    On Error GoTo errHandler
    Dim CmdLine As String
    strMonkeyIcon = App.Path & "\" & App.EXEName & ",0"
    InitRegistry
    InitInternalVars
    frmMain.Show
    Application.Media.Beep 1
    CmdLine = Trim(Command())
    If CmdLine <> "" Then
        Application.OpenFile CmdLine
    Else
        ' wierd unload error!
        On Error Resume Next
        frmTip.Show vbModal
        On Error GoTo errHandler
        
        If RecentFiles.Count > 0 Then
            frmRecent.Show vbModal
        End If
    End If
    Exit Sub
errHandler:
    ErrorIn "MainModule.Main"
End Sub

Public Sub InitInternalVars()
    arrEventTypes = Array("Undefined", "Timer", "Web", "OnSave", "OnLoad", "OnConnect", "OnDisconnect", "OnOpen", "OnClose", "OnSelectedText", "OnDocumentComplete")
End Sub

Public Function EventTypeValue(EventName) As eEventType
    Dim intLoop As Integer
    EventTypeValue = etUndefinied
    For intLoop = 0 To UBound(arrEventTypes)
        If Trim(EventName & "") = arrEventTypes(intLoop) Then
            EventTypeValue = intLoop
            Exit Function
        End If
    Next
End Function

Public Sub InitRegistry()
    On Error GoTo errHandler
    Dim RH As New RegistryHandler
    Dim AppName As String
    'RH.CreateKey HKEY_LOCAL_MACHINE, strRegistryOffset & "\Settings"
    'RH.CreateKey HKEY_LOCAL_MACHINE, strRegistryOffset & "\Recent"
    If Not RH.ExistsKey(HKEY_CLASSES_ROOT, ".mos") Then SetScriptfileViewer "NOTEPAD.EXE"
    RH.SetSetting HKEY_LOCAL_MACHINE, strRegistryOffset, "Version", App.Major & "." & App.Minor & "." & App.Revision
    Exit Sub
errHandler:
    ErrorIn "MainModule.InitRegistry"
End Sub

Public Sub SetScriptfileViewer(strViewer As String)
    On Error GoTo errHandler
    Dim RH As New RegistryHandler
    Dim AppName As String
'Register .MOS file----------------------------------------------------
    AppName = strViewer
    If InStr(strViewer, " ") > 0 Then AppName = """" & AppName & """"
'HKEY_CLASSES_ROOT
    RH.CreateKey HKEY_CLASSES_ROOT, ".mos"
    RH.SetSetting HKEY_CLASSES_ROOT, ".mos", "", "mosfile"
    RH.CreateKey HKEY_CLASSES_ROOT, "mosfile\DefaultIcon"
    RH.SetSetting HKEY_CLASSES_ROOT, "mosfile\DefaultIcon", "", strMonkeyIcon
    RH.SetSetting HKEY_CLASSES_ROOT, "mosfile", "", "Monkey Term Script"
    RH.SetSetting HKEY_CLASSES_ROOT, "mosfile", "EditFlags", 0
    RH.SetSetting HKEY_CLASSES_ROOT, "mosfile\DefaultIcon", "", AppName & ",0"
    RH.CreateKey HKEY_CLASSES_ROOT, "mosfile\Shell\Open\Command"
    RH.SetSetting HKEY_CLASSES_ROOT, "mosfile\Shell\Open\Command", "", AppName & " %1"
    Exit Sub
errHandler:
    ErrorIn "MainModule.SetScriptfileViewer(strViewer)", strViewer
End Sub

Private Function CheckComponents()
    'not in use yet
    On Error Resume Next
    Dim obj As Object
    Dim oTemp As Object
    'regexp
    Err.Clear
    Set obj = CreateObject("VBScript.RegExp")
    obj.Pattern = "(abc)"
    Set oTemp = obj.Execute("abcabc")
    Set oTemp = oTemp(0).SubMatches
    If Err.Number > 0 Then
        Debug.Print "Regexp Not ok"
    End If
    'scripting
    Err.Clear
    Set obj = CreateObject("MSScriptControl.ScriptControl")
    If Err.Number > 0 Then
        Debug.Print "scripting Not ok"
    End If
    'xml
    Err.Clear
    Set obj = CreateObject("MSXML.DOMDocument")
    obj.loadXML ("<test><kok></kok></test>")
    Set oTemp = obj.createElement("myroot")
    oTemp.setAttribute "woop", "yeah"
    Set oTemp = obj.selectSingleNode("test/kok").appendChild(oTemp)
    Set oTemp = obj.createCDATASection("<blabla>")
    Set oTemp = obj.selectSingleNode("test/kok").appendChild(oTemp)
    If Err.Number > 0 Then
        'if MsgBox()=vbYes
        Debug.Print "XML Not ok"
    End If
    Application.Media.ShellOpen "http://www.eternals.dk/monkeyterm/autohelp.asp?"
End Function

