VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MediaHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal _
     lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Private Declare Function waveOutGetNumDevs Lib "winmm.dll" () As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As Any, ByVal lpFile As String, ByVal lpParameters As Any, ByVal lpDirectory As Any, ByVal nShowCmd As Long) As Long
Private Declare Function auxSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long

Private Const SW_SHOWNORMAL = 1

'for resource sounds
'Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
'Private Declare Function LoadResource Lib "kernel32" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long
'Private Declare Function LockResource Lib "kernel32" (ByVal hResData As Long) As Long
'Private Declare Function FreeResource Lib "kernel32" (ByVal hResData As Long) As Long
'Private Declare Function FindResource Lib "kernel32" Alias "FindResourceA" (ByVal hInstance As Long, ByVal lpName As String, ByVal lpType As String) As Long

Private Const SND_SYNC = &H0
Private Const SND_ASYNC = &H1
Private Const SND_NODEFAULT = &H2
Private Const SND_FILENAME = &H20000
Private Const SND_MEMORY = &H4
Private Const SND_RESOURCE = &H40004
'Private Declare Function midiOutGetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Private Declare Function midiOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, ByRef Source As Any, ByVal Length As Long)


Private blnCanPlayWavs As Boolean

Private oMusic As New MonkeyMediaPlayer
Private oSoundEffect As New MonkeyMediaPlayer

Private Sub Class_Initialize()
    blnCanPlayWavs = waveOutGetNumDevs()
End Sub

Public Property Get Music() As MonkeyMediaPlayer
'// Returns the Music object. This object only works on Win98 or greater.
    Set Music = oMusic
End Property

Public Property Get Sound() As MonkeyMediaPlayer
'// Returns the Sound object. This object only works on Win98 or greater.
    Set Sound = oSoundEffect
End Property


Public Sub PlayWAV(strFileName As String)
'// Plays a WAV file.
    On Error GoTo errHandler
    Dim lngFlags As Long
    If blnCanPlayWavs Then
        'Flag Values for Parameter
        'Set the flags for PlaySound
        lngFlags = SND_NODEFAULT Or SND_FILENAME Or SND_ASYNC
        'Play the WAV file
        Call PlaySound(strFileName, 0&, lngFlags)
    End If
    Exit Sub
errHandler:
    ErrorIn "MediaHandler.PlayWAV(strFileName)", strFileName
End Sub

Public Sub Beep(Optional lngMonkey As Long = 1)
'// Plays a beep. lngMonkey can be changed for other beep sounds.
    On Error GoTo errHandler
    Dim lngFlags As Long
    If blnCanPlayWavs Then
        lngFlags = SND_NODEFAULT Or SND_ASYNC Or SND_RESOURCE
        PlaySound "MONKEY" & lngMonkey, App.hInstance, lngFlags
    End If
    Exit Sub
errHandler:
    ErrorIn "MediaHandler.Beep(lngMonkey)", lngMonkey
End Sub

Public Sub ShellOpen(strFileName As String)
'// This will shell open any file. It is equivalent to double-clicking/running it from a normal Windows environment.
    On Error GoTo errHandler
    ErrSysHandlerSet
    ShellExecute 0, 0&, strFileName & vbNullString, 0&, 0&, SW_SHOWNORMAL
    ErrSysHandlerRelease
Exit Sub
errHandler:
    ErrorIn "MediaHandler.ShellOpen(strFileName)", strFileName
End Sub

Public Sub RunShellCommand(strCommand As String, Optional Mode As VbAppWinStyle = vbMaximizedFocus)
'// Runs a shell command. A simple way to execute/run external programs.
'// You can normally manipulate external programs much better through a script function instead.
    On Error GoTo errHandler
    Shell strCommand, Mode
    Exit Sub
errHandler:
    ErrorIn "MediaHandler.RunShellCommand(strCommand,Mode)", Array(strCommand, Mode)
End Sub

Public Function FindRandomFile(ByVal sPath As String) As String
'// Used for the MSP (Mud Sound Protocol). It will pick a random file matching sPath.
    On Error GoTo errHandler
    Dim col As New Collection
    Dim lP As Long
    Dim sName As String
    sName = Dir(sPath, vbNormal Or vbHidden Or vbSystem Or vbReadOnly)
    While sName <> ""
        col.Add sName
        sName = Dir
    Wend
    If col.Count > 0 Then
        lP = InStrRev(sPath, "\")
        If lP > 0 Then sName = Left(sPath, lP) Else sName = ""
        FindRandomFile = sName & col.Item(1 + Int(Rnd * col.Count))
    End If
    Exit Function
errHandler:
    ErrorIn "MediaHandler.FindRandomFile(sPath)", sPath
End Function
