VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MonkeyMediaPlayer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// This class uses a newer version of the WMP (Windows Media Player) and will therefore not work on Win95 since they no longer support that OS. Win98 or newer is required.

Private WithEvents WMP As WMPLib.WindowsMediaPlayer
Attribute WMP.VB_VarHelpID = -1

Private sngGlobalVolume As Single '0 to 100

'Current File:
Private sFilename As String
Private lLoopCount As Long '-1 = infinite
Private sngPriority As Single '0 to 100
Private sngVolume As Single '0 to 100
Private bContinue As Boolean

Private Sub Class_Initialize()
    On Error GoTo errHandler
    sngGlobalVolume = 100
    
    ClearSettings

    Set WMP = New WMPLib.WindowsMediaPlayer
    WMP.settings.autoStart = False
    Exit Sub
errHandler:
    ErrorIn "MonkeyMediaPlayer.Class_Initialize"
End Sub

Public Sub ApplyVolume()
'// Apply the new volume change.
    On Error GoTo errHandler
    WMP.settings.Volume = (sngVolume * sngGlobalVolume) / 100
    Exit Sub
errHandler:
    ErrorIn "MonkeyMediaPlayer.ApplyVolume"
End Sub

Public Sub StopPlaying()
'// Stops playback.
    On Error GoTo errHandler
    ClearSettings
    WMP.Controls.Stop
    Exit Sub
errHandler:
    ErrorIn "MonkeyMediaPlayer.StopPlaying"
End Sub

Public Sub RequestPlay(ByVal sFile As String, Optional ByVal Priority As Single = 50, _
    Optional ByVal Volume As Single = 100, Optional ByVal Loopcount As Long = 1, _
    Optional ByVal Continue As Boolean = False)
'//The interface for RequestPlay closely matches the requirements for MSPv0.3 (Mud Sound Protocol).
'//<i>sFile</i>: Filename/url of the media file (MID,MP3,WAV,++)
'//<i>Priority</i>: If a sound is requested while another sound is being played, whichever sound has the higher priority wins. In case of a tie the continue parameter determines which sound will win. If continue is true the currently playing sound will win.
'//<i>Volume</i>: a volume in the range from 0 to 100. 100 being loudest.
'//<i>LoopCount</i>: How many times should the media file loop. -1 begin infinitely.
'//<i>Continue</i>: specifies whether the file should simply continue playing if requested again, or if it should restart.
On Error GoTo ErrorHandler
    Dim bResetParams As Boolean
    Dim bPlay As Boolean

    If lLoopCount = 0 Then
        bResetParams = True
        bPlay = True
    End If
    
    lLoopCount = Loopcount
    If (Priority > sngPriority) Then
        bResetParams = True
        If sFile = sFilename Then
            If Not (Continue Or bContinue) Then
                bPlay = True
            End If
        End If
    ElseIf (Priority = sngPriority) And (Not (Continue Or bContinue)) Then
        'MSP Music tags should go in here
        
        bResetParams = True
        bPlay = True
    End If
    
    
    If bResetParams Then
        sngVolume = Volume
        sngPriority = Priority
        sFilename = sFile
        lLoopCount = Loopcount
        bContinue = Continue
    End If
    
    If bPlay Then
        Play
    End If
Exit Sub
ErrorHandler:
    WMP.Controls.Stop
    WMP.URL = ""
    ClearSettings
    Err.Raise Err.Number, "MonkeyMediaPlayer", Err.Description
End Sub

Public Sub Play()
'// Plays the currently selected file.
    On Error GoTo errHandler
    ApplyVolume
    WMP.Controls.pause
    If sFilename <> WMP.URL Then WMP.URL = sFilename
    WMP.Controls.currentPosition = 0
    WMP.Controls.Play
    Exit Sub
errHandler:
    ErrorIn "MonkeyMediaPlayer.Play"
End Sub

Private Sub ClearSettings()
    sFilename = ""
    lLoopCount = 0
    sngPriority = 0
    sngVolume = 100
    bContinue = True
End Sub

Private Sub Class_Terminate()
    WMP.Controls.Stop
End Sub



Private Sub WMP_Error()
    ClearSettings
    Debug.Print "wmperror"
End Sub

Private Sub WMP_PlayStateChange(ByVal NewState As Long)
    On Error GoTo errHandler
    'Debug.Print "newstate", NewState
    If NewState = wmppsReady Then
        StopPlaying
    End If
    If NewState = wmppsStopped Then
        If lLoopCount > 0 Then lLoopCount = lLoopCount - 1
        If lLoopCount <> 0 Then
            Play
        End If
    End If
    Exit Sub
errHandler:
    ErrorIn "MonkeyMediaPlayer.WMP_PlayStateChange(NewState)", NewState
End Sub

