VERSION 5.00
Begin VB.UserControl PropertyEditor 
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.VScrollBar VScroll1 
      Height          =   2655
      Left            =   3840
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   240
      Width           =   255
   End
   Begin VB.Frame Frame 
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      Height          =   2895
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3255
      Begin VB.ComboBox cCombo 
         Appearance      =   0  'Flat
         Height          =   315
         Index           =   0
         IntegralHeight  =   0   'False
         Left            =   1440
         Style           =   2  'Dropdown List
         TabIndex        =   5
         Top             =   1560
         Visible         =   0   'False
         Width           =   1335
      End
      Begin VB.TextBox cText 
         Appearance      =   0  'Flat
         BorderStyle     =   0  'None
         Height          =   315
         Index           =   0
         Left            =   1440
         TabIndex        =   2
         Text            =   "Textbox"
         Top             =   480
         Visible         =   0   'False
         Width           =   1335
      End
      Begin VB.CheckBox cCheckBox 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         ForeColor       =   &H80000008&
         Height          =   255
         Index           =   0
         Left            =   1560
         TabIndex        =   3
         Top             =   960
         Visible         =   0   'False
         Width           =   255
      End
      Begin VB.Line Line1 
         BorderColor     =   &H8000000F&
         X1              =   840
         X2              =   840
         Y1              =   840
         Y2              =   1320
      End
      Begin VB.Line HLine 
         BorderColor     =   &H8000000F&
         Index           =   0
         Visible         =   0   'False
         X1              =   720
         X2              =   2040
         Y1              =   2160
         Y2              =   2160
      End
      Begin VB.Label Label 
         Appearance      =   0  'Flat
         AutoSize        =   -1  'True
         BackColor       =   &H80000005&
         Caption         =   "Label"
         ForeColor       =   &H80000007&
         Height          =   195
         Index           =   0
         Left            =   120
         TabIndex        =   1
         Top             =   480
         Visible         =   0   'False
         Width           =   390
      End
   End
End
Attribute VB_Name = "PropertyEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private oCollection As New Collection
Private sngMaxLabelWidth As Single
Private sngLineHeight As Single

Public Enum enmPropertyTypes
    prpText = 0
    prpNumber = 1
    prpBoolean = 2
    prpCombo = 3
End Enum

Public Sub AddProperty(sName As String, lType As enmPropertyTypes, Optional sValidationRule As String = "")
    On Error GoTo errHandler
    Dim lCur As Long
    Dim oControl As Control
    Dim l As Long
    Dim sSplit() As String
    lCur = Label.Count
    Load Label(lCur)
    With Label(lCur)
        .Top = (sngLineHeight) * (lCur - 1) + UserControl.ScaleY(3, vbPixels, UserControl.ScaleMode)
        .Left = UserControl.ScaleY(2, vbPixels, UserControl.ScaleMode)
        .Visible = True
        .AutoSize = True
        .Caption = sName
        .Tag = lType
        .AutoSize = False
        .Width = .Width
        '.Height = Label(0).Height
        If .Width > sngMaxLabelWidth Then
            sngMaxLabelWidth = .Width
            For l = 0 To Label.Count - 1
                Label(l).Width = sngMaxLabelWidth
            Next
            For Each oControl In oCollection
                SetControlPosition oControl
            Next
            Line1.X1 = sngMaxLabelWidth + .Left + UserControl.ScaleY(3, vbPixels, UserControl.ScaleMode)
            Line1.X2 = Line1.X1
            UserControl_Resize
        Else
            .Width = sngMaxLabelWidth
        End If
        Frame.Height = sngLineHeight * lCur
        Load HLine(lCur)
        HLine(lCur).Y1 = sngLineHeight * lCur
        HLine(lCur).Y2 = HLine(lCur).Y1
        HLine(lCur).Visible = True
        Line1.Y1 = 0
        Line1.Y2 = Frame.Height
    End With
    VScroll1.Max = UserControl.ScaleY(Frame.Height - UserControl.ScaleHeight, UserControl.ScaleMode, vbPixels)
    VScroll1.SmallChange = UserControl.ScaleY(Label(0).Height, UserControl.ScaleMode, vbPixels)
    VScroll1.LargeChange = UserControl.ScaleY(Label(0).Height * 10, UserControl.ScaleMode, vbPixels)
    Select Case lType
        Case prpText
            Load cText(lCur)
            Set oControl = cText(lCur)
            oControl.Tag = sValidationRule
            oControl.Text = ""
        Case prpNumber
            Load cText(lCur)
            Set oControl = cText(lCur)
            oControl.Tag = sValidationRule
            'oControl.Alignment = 1 'right --- i think that right justified sux
            If sValidationRule <> "" Then
                oControl.Tag = sValidationRule
            Else
                oControl.Tag = "^-?\d{1,6}$|^-?\d{0,6}\.\d{0,5}$"
            End If
            oControl.Text = 0
        Case prpBoolean
            Load cCheckBox(lCur)
            Set oControl = cCheckBox(lCur)
        Case prpCombo
            Load cCombo(lCur)
            Set oControl = cCombo(lCur)
            sSplit = Split(sValidationRule, ";")
            For l = 0 To UBound(sSplit)
                oControl.AddItem sSplit(l)
            Next
            oControl.Text = sSplit(0)
    End Select
    oControl.Visible = True
    SetControlPosition oControl
    oCollection.Add oControl, sName
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.AddProperty(sName,lType,sValidationRule)", Array(sName, lType, _
         sValidationRule)
End Sub

Private Sub SetControlPosition(oControl As Control)
    On Error GoTo errHandler
    oControl.Top = Label(oControl.Index).Top
    Select Case LCase(oControl.Name)
        Case "ccheckbox"
            oControl.Left = Line1.X1 + UserControl.ScaleY(4, vbPixels, UserControl.ScaleMode)
            oControl.Top = Label(oControl.Index).Top - UserControl.ScaleY(2, vbPixels, UserControl.ScaleMode)
            oControl.Width = Frame.Width - oControl.Left
        Case "ccombo"
            oControl.Top = HLine(oControl.Index - 1).Y1
            oControl.Left = Line1.X1
            oControl.Width = Frame.Width - oControl.Left
        Case Else
            oControl.Top = Label(oControl.Index).Top
            oControl.Left = Line1.X1 + UserControl.ScaleY(3, vbPixels, UserControl.ScaleMode)
            oControl.Width = Frame.Width - oControl.Left - UserControl.ScaleY(3, vbPixels, UserControl.ScaleMode)
            oControl.Height = Label(oControl.Index).Height
    End Select
    oControl.TabIndex = oControl.Index
    oControl.TabStop = True
    oControl.ZOrder 0
    HLine(oControl.Index).X1 = 0
    HLine(oControl.Index).X2 = Frame.Width
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.SetControlPosition(oControl)", oControl
End Sub

Public Property Let Property(sName As String, vValue As Variant)
    On Error GoTo errHandler
    Dim oControl As Control
    Set oControl = oCollection(sName)
    Select Case LCase(oControl.Name)
        Case "ccheckbox"
            oControl.Value = vValue And 1
        Case "ctext", "ccombo"
            oControl.Text = vValue
    End Select
    Exit Property
errHandler:
    ErrorIn "PropertyEditor.Property(sName,vValue)", Array(sName, vValue)
End Property

Public Property Get Property(sName As String) As Variant
    On Error GoTo errHandler
    Dim oControl As Control
    Set oControl = oCollection(sName)
    Select Case LCase(oControl.Name)
        Case "ccheckbox"
            Property = (oControl.Value = 1)
        Case "ctext"
            If CLng(Label(oControl.Index).Tag) = prpNumber Then
                Property = Val(oControl.Text)
            Else
                Property = oControl.Text
            End If
        Case "ccombo"
            Property = oControl.Text
    End Select
    Exit Property
errHandler:
    ErrorIn "PropertyEditor.Property(sName)", sName
End Property

Public Sub ClearPropertySheet()
    On Error Resume Next
    Dim l As Long
    Dim oControl As Control
    For l = 1 To Label.Count - 1
        Unload Label(l)
        Unload HLine(l)
    Next
    For Each oControl In oCollection
        Unload oControl
    Next
    VScroll1.Max = 0
    Frame.Height = 0
    sngMaxLabelWidth = 0
    Set oCollection = New Collection
End Sub







Private Sub cCheckBox_GotFocus(Index As Integer)
    On Error GoTo errHandler
    ShowFocus Index
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.cCheckBox_GotFocus(Index)", Index, EA_EXTERNCALL
    HandleError
End Sub

Private Sub cCombo_GotFocus(Index As Integer)
    On Error GoTo errHandler
    ShowFocus Index
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.cCombo_GotFocus(Index)", Index, EA_EXTERNCALL
    HandleError
End Sub

Private Sub cText_GotFocus(Index As Integer)
    On Error GoTo errHandler
    ShowFocus Index
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.cText_GotFocus(Index)", Index, EA_EXTERNCALL
    HandleError
End Sub

Private Sub cText_Validate(Index As Integer, Cancel As Boolean)
    On Error GoTo errHandler
    Dim oRE As New RegExp
    If cText(Index).Tag & "" <> "" Then 'has validation rule
        oRE.Pattern = cText(Index).Tag
        If Not oRE.Test(cText(Index).Text) Then
            Cancel = True
            Beep  'VALIDATION ERROR
        End If
    End If
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.cText_Validate(Index,Cancel)", Array(Index, Cancel), EA_EXTERNCALL
    HandleError
End Sub

Private Sub ShowFocus(Index As Integer)
    On Error GoTo errHandler
    Dim l As Long
    For l = 1 To Label.Count - 1
        If l = Index Then
            Label(l).BackColor = &HFFE0E0
        Else
            Label(l).BackColor = &H80000005
        End If
    Next
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.ShowFocus(Index)", Index
End Sub

Private Sub Label_Click(Index As Integer)
    On Error GoTo errHandler
    oCollection(Label(Index).Caption).SetFocus
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.Label_Click(Index)", Index, EA_EXTERNCALL
    HandleError
End Sub

Private Sub Label_DblClick(Index As Integer)
    On Error GoTo errHandler
    Dim oControl As Control
    Dim l As Long
    Set oControl = oCollection(Label(Index).Caption)
    Select Case LCase(oControl.Name)
        Case "ccheckbox"
            oControl.Value = oControl.Value Xor 1
        Case "ccombo"
            l = oControl.ListIndex + 1
            If l >= oControl.ListCount Then l = 0
            oControl.ListIndex = l
        Case "ctext"
            oControl.SelStart = 0
            oControl.SelLength = Len(oControl.Text)
    End Select
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.Label_DblClick(Index)", Index, EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Initialize()
    On Error GoTo errHandler
    Frame.Top = 0
    HLine(0).Y1 = 0
    HLine(0).Y2 = 0
    sngLineHeight = Label(0).Height + UserControl.ScaleY(6, vbPixels, UserControl.ScaleMode)
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.UserControl_Initialize", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    Dim l As Long
    Dim oControl As Control
    VScroll1.Max = UserControl.ScaleY(Frame.Height - UserControl.ScaleHeight, UserControl.ScaleMode, vbPixels)
    Frame.Left = 0
    VScroll1.Top = 0
    VScroll1.Height = UserControl.ScaleHeight
    If Frame.Height <= UserControl.ScaleHeight Then
        Frame.Top = 0
        VScroll1.Left = UserControl.ScaleWidth
    Else
        VScroll1.Left = UserControl.ScaleWidth - VScroll1.Width
    End If
    Frame.Width = VScroll1.Left
    For Each oControl In oCollection
        SetControlPosition oControl
    Next
End Sub

Private Sub VScroll1_Change()
    On Error GoTo errHandler
    Frame.Top = -UserControl.ScaleY(VScroll1.Value, vbPixels, UserControl.ScaleMode)
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.VScroll1_Change", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub VScroll1_Scroll()
    On Error GoTo errHandler
    Frame.Top = -UserControl.ScaleY(VScroll1.Value, vbPixels, UserControl.ScaleMode)
    Exit Sub
errHandler:
    ErrorIn "PropertyEditor.VScroll1_Scroll", , EA_EXTERNCALL
    HandleError
End Sub

Public Sub AdjustHeight(sMaxHeight As Single)
    Dim sHeight As Single
    On Error Resume Next
    sHeight = Frame.Height + (UserControl.Height - UserControl.ScaleHeight)
    If sHeight > sMaxHeight Then sHeight = sMaxHeight
    If sHeight = UserControl.Height Then Exit Sub
    UserControl.Height = sHeight
End Sub
