VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RecentCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type RecentType
    FileName As String
    SessionName As String
End Type

Private arrRecent() As RecentType

Public Sub Add(FileName As String, SessionName As String)
    On Error GoTo errHandler
    Dim lngIdx As Long
    lngIdx = GetIndex(FileName)
    If lngIdx <> -1 Then
        Remove lngIdx
    End If
    ReDim Preserve arrRecent(UBound(arrRecent) + 1)
    With arrRecent(UBound(arrRecent) - 1)
        .FileName = FileName
        .SessionName = SessionName
    End With
    Exit Sub
errHandler:
    ErrorIn "RecentCollection.Add(FileName,SessionName)", Array(FileName, SessionName)
End Sub

Public Sub Remove(Index As Variant)
    On Error GoTo errHandler
    Dim lngIdx As Long
    Dim lng As Long
    Dim lngOrigSize As Long
    lngOrigSize = UBound(arrRecent) - 1
    lngIdx = GetIndex(Index)
    For lng = lngIdx + 1 To lngOrigSize
        arrRecent(lng - 1) = arrRecent(lng)
    Next
    ReDim Preserve arrRecent(lngOrigSize)
    'Set arrRecent(lngOrigSize) = Nothing
    Exit Sub
errHandler:
    ErrorIn "RecentCollection.Remove(Index)", Index
End Sub

Public Property Get ItemSessionName(Index As Variant) As String
    On Error GoTo errHandler
    With arrRecent(GetIndex(Index))
        ItemSessionName = .SessionName
    End With
    Exit Property
errHandler:
    ErrorIn "RecentCollection.ItemSessionName(Index)", Index
End Property

Public Property Let ItemSessionName(Index As Variant, strVal As String)
    On Error GoTo errHandler
    With arrRecent(GetIndex(Index))
        .SessionName = strVal
    End With
    Exit Property
errHandler:
    ErrorIn "RecentCollection.ItemSessionName(Index,strVal)", Array(Index, strVal)
End Property

Public Property Get ItemFileName(Index As Variant) As String
    On Error GoTo errHandler
    With arrRecent(GetIndex(Index))
        ItemFileName = .FileName
    End With
    Exit Property
errHandler:
    ErrorIn "RecentCollection.ItemFileName(Index)", Index
End Property

Public Property Let ItemFileName(Index As Variant, strVal As String)
    On Error GoTo errHandler
    With arrRecent(GetIndex(Index))
        .FileName = strVal
    End With
    Exit Property
errHandler:
    ErrorIn "RecentCollection.ItemFileName(Index,strVal)", Array(Index, strVal)
End Property

Public Function GetIndex(Index As Variant) As Long
    On Error GoTo errHandler
    Dim lng As Long
    GetIndex = -1
    Select Case VarType(Index)
        Case vbLong, vbByte, vbInteger
            GetIndex = Index
        Case vbString
            For lng = 0 To UBound(arrRecent) - 1
                If UCase(arrRecent(lng).FileName) = UCase(Index) Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
    End Select
    Exit Function
errHandler:
    ErrorIn "RecentCollection.GetIndex(Index)", Index
End Function

Public Property Get Count() As Long
    On Error GoTo errHandler
    Count = UBound(arrRecent)
    Exit Property
errHandler:
    ErrorIn "RecentCollection.Count"
End Property

Private Sub Class_Initialize()
    ReDim arrRecent(0)
        
    Exit Sub
    
'    Dim RH As New RegistryHandler
'    Dim AppName As String
'    Dim lngRecentCount As Long
'    Dim lng As Long
'    Dim strFileName As String
'    Dim strSessionName As String
'    Dim strValue As String
'
'    On Error GoTo IgnoreRecentErrors
'    lngRecentCount = 0
'    lngRecentCount = RH.GetSetting(HKEY_LOCAL_MACHINE, strRegistryOffset & "\Recent", "RecentCount")
'    For lng = 0 To lngRecentCount - 1
'        strFileName = RH.GetSetting(HKEY_LOCAL_MACHINE, strRegistryOffset & "\Recent", "File" & lng)
'        strSessionName = RH.GetSetting(HKEY_LOCAL_MACHINE, strRegistryOffset & "\Recent", "Session" & lng)
'        If Dir(strFileName) <> "" And strFileName <> "" Then
'            RecentFiles.Add strFileName, strSessionName
'        End If
'    Next
'IgnoreRecentErrors:
'    On Error GoTo 0
End Sub

Private Sub Class_Terminate()
'    Dim RH As New RegistryHandler
'    Dim AppName As String
'    Dim lngRecentCount As Long
'    Dim lng As Long
'    Dim strFileName As String
'    Dim strSessionName As String
'    Dim strValue As String
'    On Error GoTo IgnoreRecentErrors
'    lngRecentCount = UBound(arrRecent)
'    If lngRecentCount > 20 Then lngRecentCount = 20
'    RH.SetSetting HKEY_LOCAL_MACHINE, strRegistryOffset & "\Recent", "RecentCount", lngRecentCount
'    For lng = 0 To lngRecentCount - 1
'        strFileName = arrRecent(lng).FileName
'        strSessionName = arrRecent(lng).SessionName
'        RH.SetSetting HKEY_LOCAL_MACHINE, strRegistryOffset & "\Recent", "File" & lng, arrRecent(lng).FileName
'        RH.SetSetting HKEY_LOCAL_MACHINE, strRegistryOffset & "\Recent", "Session" & lng, arrRecent(lng).SessionName
'    Next
'IgnoreRecentErrors:
'    On Error GoTo 0
End Sub
