VERSION 5.00
Begin VB.UserControl ResizeBar 
   BackColor       =   &H000040C0&
   CanGetFocus     =   0   'False
   ClientHeight    =   1515
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   HasDC           =   0   'False
   ScaleHeight     =   1515
   ScaleWidth      =   4800
End
Attribute VB_Name = "ResizeBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

Private bResizing As Boolean
Private sngX As Single
Private sngY As Single
Private sngExtLeft As Single
Private sngExtTop As Single

'Event Declarations:
Event ResizeMove(x As Single, y As Single)
Event ResizeEnd(bApply As Boolean, x As Single, y As Single)
Event ResizeStart(x As Single, y As Single)
'Event DblClick()
Event Click()

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    On Error GoTo errHandler
    BackColor = UserControl.BackColor
    Exit Property
errHandler:
    ErrorIn "ResizeBar.BackColor"
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    On Error GoTo errHandler
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    Exit Property
errHandler:
    ErrorIn "ResizeBar.BackColor(New_BackColor)", New_BackColor
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    On Error GoTo errHandler
    Enabled = UserControl.Enabled
    Exit Property
errHandler:
    ErrorIn "ResizeBar.Enabled"
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    On Error GoTo errHandler
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
    Exit Property
errHandler:
    ErrorIn "ResizeBar.Enabled(New_Enabled)", New_Enabled
End Property

Private Sub UserControl_Click()
    On Error GoTo errHandler
    If Abs(sngExtLeft - Extender.Left) < UserControl.ScaleX(3, vbPixels, UserControl.ScaleMode) And _
       Abs(sngExtTop - Extender.Top) < UserControl.ScaleY(3, vbPixels, UserControl.ScaleMode) Then
        RaiseEvent Click
    End If
    Exit Sub
errHandler:
    ErrorIn "ResizeBar.UserControl_Click", , EA_EXTERNCALL
    HandleError
End Sub

'Private Sub UserControl_DblClick()
'    RaiseEvent DblClick
'End Sub
'
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errHandler
    If Button = vbLeftButton Then
        bResizing = True
        sngX = x
        sngY = y
        sngExtLeft = Extender.Left
        sngExtTop = Extender.Top
        RaiseEvent ResizeStart(Extender.Left, Extender.Top)
    End If
    Exit Sub
errHandler:
    ErrorIn "ResizeBar.UserControl_MouseDown(Button,Shift,x,y)", Array(Button, Shift, x, y), _
         EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errHandler
    If bResizing Then
        RaiseEvent ResizeMove(Extender.Left + x - sngX, Extender.Top + y - sngY)
    End If
    Exit Sub
errHandler:
    ErrorIn "ResizeBar.UserControl_MouseMove(Button,Shift,x,y)", Array(Button, Shift, x, y), _
         EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errHandler
    If bResizing Then
        RaiseEvent ResizeEnd(Button = vbLeftButton, Extender.Left + x - sngX, Extender.Top + y - sngY)
    End If
    bResizing = False
    Exit Sub
errHandler:
    ErrorIn "ResizeBar.UserControl_MouseUp(Button,Shift,x,y)", Array(Button, Shift, x, y), _
         EA_EXTERNCALL
    HandleError
End Sub

Private Function GetTotalUserControl() As ResizeBar
    On Error GoTo errHandler
    Dim lng As Long
    Static rb As ResizeBar
    If Not rb Is Nothing Then
        Set GetTotalUserControl = rb
    End If
    
    Exit Function
errHandler:
    ErrorIn "ResizeBar.GetTotalUserControl"
End Function

'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MappingInfo=UserControl,UserControl,-1,MouseIcon
'Public Property Get MouseIcon() As Picture
'    Set MouseIcon = UserControl.MouseIcon
'End Property
'
'Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
'    Set UserControl.MouseIcon = New_MouseIcon
'    PropertyChanged "MouseIcon"
'End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error GoTo errHandler
    bResizing = False
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H40C0&)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    Exit Sub
errHandler:
    ErrorIn "ResizeBar.UserControl_ReadProperties(PropBag)", PropBag, EA_EXTERNCALL
    HandleError
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error GoTo errHandler

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H40C0&)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
    Exit Sub
errHandler:
    ErrorIn "ResizeBar.UserControl_WriteProperties(PropBag)", PropBag, EA_EXTERNCALL
    HandleError
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    On Error GoTo errHandler
    MousePointer = UserControl.MousePointer
    Exit Property
errHandler:
    ErrorIn "ResizeBar.MousePointer"
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    On Error GoTo errHandler
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
    Exit Property
errHandler:
    ErrorIn "ResizeBar.MousePointer(New_MousePointer)", New_MousePointer
End Property
