VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ScriptCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// This is a collection of scripts linked to a session.

Private Type ScriptType
    Name As String
    FileName As String
    Enabled As Boolean
End Type

Private arrScript() As ScriptType
Private SessionObject As frmSession

Friend Sub Init(SessionForm As frmSession)
    Set SessionObject = SessionForm
End Sub

Public Sub Add(Name As String, FileName As String, Enabled As Boolean)
'// Adds a script to the session. Name is a key for later reference.
    On Error GoTo errHandler
    Dim lngIdx As Long
    lngIdx = GetIndex(Name)
    If lngIdx > -1 Then
        Remove lngIdx
    End If
    lngIdx = UBound(arrScript)
    ReDim Preserve arrScript(lngIdx + 1)
    With arrScript(lngIdx)
        .Name = Name
        .FileName = FileName
        .Enabled = Enabled
    End With
    Exit Sub
errHandler:
    ErrorIn "ScriptCollection.Add(Name,FileName,Enabled)", Array(Name, FileName, Enabled)
End Sub

Public Sub Remove(Index As Variant)
'// Removes a script reference from the session.
    On Error GoTo errHandler
    Dim lngIdx As Long
    Dim lng As Long
    Dim lngOrigSize As Long
    lngOrigSize = UBound(arrScript) - 1
    lngIdx = GetIndex(Index)
    For lng = lngIdx + 1 To lngOrigSize
        arrScript(lng - 1) = arrScript(lng)
    Next
    ReDim Preserve arrScript(lngOrigSize)
    'Set arrScript(lngOrigSize) = Nothing
    Exit Sub
errHandler:
    ErrorIn "ScriptCollection.Remove(Index)", Index
End Sub

Public Property Get ItemName(Index As Variant) As String
'// Read/write. Name of scriptfile.
    On Error GoTo errHandler
    With arrScript(GetIndex(Index))
        ItemName = .Name
    End With
    Exit Property
errHandler:
    ErrorIn "ScriptCollection.ItemName(Index)", Index
End Property

Public Property Let ItemName(Index As Variant, strVal As String)
    On Error GoTo errHandler
    With arrScript(GetIndex(Index))
        .Name = strVal
    End With
    Exit Property
errHandler:
    ErrorIn "ScriptCollection.ItemName(Index,strVal)", Array(Index, strVal)
End Property

Public Property Get ItemEnabled(Index As Variant) As Boolean
'// Read/write. Enabled status. If not enabled, the script will not have effect.
    On Error GoTo errHandler
    With arrScript(GetIndex(Index))
        ItemEnabled = .Enabled
    End With
    Exit Property
errHandler:
    ErrorIn "ScriptCollection.ItemEnabled(Index)", Index
End Property

Public Property Let ItemEnabled(Index As Variant, blnVal As Boolean)
    On Error GoTo errHandler
    With arrScript(GetIndex(Index))
        .Enabled = blnVal
    End With
    Exit Property
errHandler:
    ErrorIn "ScriptCollection.ItemEnabled(Index,blnVal)", Array(Index, blnVal)
End Property

Public Property Get ItemFileName(Index As Variant) As String
'// Read/write. Name of scriptfile (with full path).
    On Error GoTo errHandler
    With arrScript(GetIndex(Index))
        ItemFileName = .FileName
    End With
    Exit Property
errHandler:
    ErrorIn "ScriptCollection.ItemFileName(Index)", Index
End Property

Public Property Let ItemFileName(Index As Variant, strVal As String)
    On Error GoTo errHandler
    With arrScript(GetIndex(Index))
        .FileName = strVal
    End With
    Exit Property
errHandler:
    ErrorIn "ScriptCollection.ItemFileName(Index,strVal)", Array(Index, strVal)
End Property

Friend Function GetIndex(Index As Variant) As Long
    On Error GoTo errHandler
    Dim lng As Long
    GetIndex = -1
    Select Case VarType(Index)
        Case vbLong, vbByte, vbInteger
            GetIndex = Index
        Case vbString
            For lng = 0 To UBound(arrScript) - 1
                If UCase(arrScript(lng).Name) = UCase(Index) Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
    End Select
    Exit Function
errHandler:
    ErrorIn "ScriptCollection.GetIndex(Index)", Index
End Function

Public Function LoadScript(Index As Variant) As String
'// Reloads a script. If the scriptfile was edited, a reload is needed for the changes to take effect.
On Error GoTo ErrorHandler
    Dim lngIdx As Long
    Dim intFile As Integer
    Dim sFile As String
    lngIdx = GetIndex(Index)
    If lngIdx = -1 Then Exit Function
    With arrScript(lngIdx)
        If Not (.Enabled) Then Exit Function
        sFile = SessionObject.ExpandPath(.FileName)
        If Dir(sFile) = "" Then
            arrScript(lngIdx).Enabled = False
            Exit Function
        End If
        intFile = FreeFile
        Open sFile For Binary Access Read As #intFile Len = 1
        LoadScript = Input(LOF(intFile), #intFile)
        Close intFile
    End With
Exit Function
ErrorHandler:
    arrScript(lngIdx).Enabled = False
End Function

Public Property Get Count() As Long
'// Returns the number of scriptfiles in the collection.
    On Error GoTo errHandler
    Count = UBound(arrScript)
    Exit Property
errHandler:
    ErrorIn "ScriptCollection.Count"
End Property


Private Sub Class_Initialize()
    On Error GoTo errHandler
    ReDim arrScript(0)
    Exit Sub
errHandler:
    ErrorIn "ScriptCollection.Class_Initialize"
End Sub
