VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ScriptHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// Handles scripts and script commands.

Private WithEvents SC As ScriptControl
Attribute SC.VB_VarHelpID = -1
Public Scripts As New ScriptCollection
Public Language As String
'// Default language is VBScript. Do not alter this or strange things will happen.

Private SessionObject As frmSession

Private Sub EchoScriptError()
    On Error GoTo errHandler
    Dim strTemp As String
    With SC.Error
        strTemp = .Source
        If .Line > 0 And .Column > 0 Then
            strTemp = strTemp & " at line: " & .Line & " column: " & .Column
        End If
        If .Text <> "" Then
            strTemp = strTemp & vbCrLf & .Text
        End If
        If .Description <> "" Then
            strTemp = strTemp & vbCrLf & .Description
        End If
        .Clear
    End With
    SessionObject.Terminal.PrintString strTemp & vbCrLf
    Exit Sub
errHandler:
    ErrorIn "ScriptHandler.EchoScriptError"
End Sub

Friend Sub Init(SessionForm As frmSession)
    On Error GoTo errHandler
    Set SessionObject = SessionForm
    AddObjects
    Scripts.Init SessionObject
    Exit Sub
errHandler:
    ErrorIn "ScriptHandler.Init(SessionForm)", SessionForm
End Sub

Private Sub Class_Initialize()
    On Error GoTo errHandler
    Set SC = New ScriptControl
    Language = "VBScript"
    SC.Language = Language
    Exit Sub
errHandler:
    ErrorIn "ScriptHandler.Class_Initialize"
End Sub

Private Sub AddObjects()
    SC.AddObject "Session", SessionObject
    SC.AddObject "Application", Application
    SC.AddObject "Var", SessionObject.Variables
    SC.AddObject "Web", SessionObject.Web
End Sub

Public Sub ApplyChanges()
'// Resets and reloads all scripts.
    On Error GoTo ErrorHandler
    Dim lng As Long
    Dim strScr As String
    Set SC = New ScriptControl 'instead of sc.reset which crashes
    SC.Language = Language
    AddObjects
    For lng = Scripts.Count - 1 To 0 Step -1
        strScr = Scripts.LoadScript(lng)
        If (strScr <> "") And Scripts.ItemEnabled(lng) Then
            SC.AddCode strScr
        End If
    Next
Exit Sub
ErrorHandler:
    EchoScriptError
End Sub

Public Function ExecuteCommand(ByVal sCommand As String) As Boolean
'// Executes a command in the scripts object. Returns a boolean value, true if no errors were encountered, otherwise false.
    On Error GoTo ErrorHandler
    SC.ExecuteStatement sCommand
    ExecuteCommand = True
Exit Function
ErrorHandler:
    EchoScriptError
    ExecuteCommand = False
End Function

Private Sub SC_Error()
    EchoScriptError
End Sub
