VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SessionCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// Holds a collection of sessions. Each session can be found with a number as index or the name of the session.
'// Examples: application.sessions(1) and application.sessions("astro")

Private arrSession() As frmSession

Friend Sub Add(Session As frmSession)
    On Error GoTo errHandler
    ReDim Preserve arrSession(UBound(arrSession) + 1)
    Set arrSession(UBound(arrSession) - 1) = Session
    Exit Sub
errHandler:
    ErrorIn "SessionCollection.Add(Session)", Session
End Sub

Public Sub Remove(Index As Variant)
'// Removes a session. If SaveOnExit is set on the session, the session will save.
    On Error GoTo errHandler
    Dim lngIdx As Long
    Dim lng As Long
    Dim lngOrigSize As Long
    lngOrigSize = UBound(arrSession) - 1
    lngIdx = GetIndex(Index)
    For lng = lngIdx + 1 To lngOrigSize
        Set arrSession(lng - 1) = arrSession(lng)
    Next
    ReDim Preserve arrSession(lngOrigSize)
    Set arrSession(lngOrigSize) = Nothing
    Exit Sub
errHandler:
    ErrorIn "SessionCollection.Remove(Index)", Index
End Sub

Public Property Get Item(Index As Variant) As frmSession
Attribute Item.VB_UserMemId = 0
'// Returns the coresponding session.
    On Error GoTo errHandler
    Set Item = arrSession(GetIndex(Index))
    Exit Property
errHandler:
    ErrorIn "SessionCollection.Item(Index)", Index
End Property

Friend Property Let Item(Index As Variant, sesVal As frmSession)
    On Error GoTo errHandler
    Set arrSession(GetIndex(Index)) = sesVal
    Exit Property
errHandler:
    ErrorIn "SessionCollection.Item(Index,sesVal)", Array(Index, sesVal)
End Property

Public Function GetIndex(Index As Variant) As Long
'// This should be a private/friend function?
    On Error GoTo errHandler
    Dim lng As Long
    GetIndex = -1
    Select Case VarType(Index)
        Case vbLong, vbByte, vbInteger
            GetIndex = Index
        Case vbString
            For lng = 0 To UBound(arrSession) - 1
                If StrComp(arrSession(lng).SessionName, Index, vbTextCompare) = 0 Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
        Case vbObject
            If TypeOf Index Is frmSession Then
                For lng = 0 To UBound(arrSession) - 1
                    If arrSession(lng) Is Index Then
                        GetIndex = lng
                        Exit Function
                    End If
                Next
            End If
    End Select
    Exit Function
errHandler:
    ErrorIn "SessionCollection.GetIndex(Index)", Index
End Function

Public Property Get Count() As Long
'// Returns the number of sessions in the session collection.
    On Error GoTo errHandler
    Count = UBound(arrSession)
    Exit Property
errHandler:
    ErrorIn "SessionCollection.Count"
End Property

Private Sub Class_Initialize()
    On Error GoTo errHandler
    ReDim arrSession(0)
    Exit Sub
errHandler:
    ErrorIn "SessionCollection.Class_Initialize"
End Sub
