VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Substitute"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private sName As String
Private sPattern As String
Private sCommand As String
Private bEnabled As Boolean
Private bSimple As Boolean
Private oRegExp As RegExp
Private bCaseSensitive As Boolean

Private Sub UpdatePattern()
    On Error GoTo RegexpSyntaxError
    If Not bEnabled Then Exit Sub
    Dim sTmpPattern As String
    sTmpPattern = sPattern
    If bSimple Then sTmpPattern = Glob2Regexp(sTmpPattern)
    oRegExp.Pattern = ParseHomeMadeRegExp(sTmpPattern)
    oRegExp.Execute "Syntax check"
Exit Sub
RegexpSyntaxError:
    oRegExp.Pattern = ""
    bEnabled = False
    Err.Raise Regexp_SyntaxError, "Syntax error in regexp. " & sName & " has been disabled.", TypeName(Me)
End Sub

Public Property Get Name() As String
    Name = sName
End Property
Public Property Let Name(sVal As String)
    sName = sVal
End Property

Public Property Get Pattern() As String
    Pattern = sPattern
End Property

Public Property Let Pattern(sVal As String)
    sPattern = sVal
    UpdatePattern
End Property

Public Property Get Command() As String
    Command = sCommand
End Property
Public Property Let Command(sVal As String)
    On Error GoTo errHandler
    sCommand = ConvertToCRLF(sVal)
    Exit Property
errHandler:
    ErrorIn "Substitute.Command(sVal)", sVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(bVal As Boolean)
    On Error GoTo errHandler
    If bEnabled = bVal Then Exit Property
    bEnabled = bVal
    UpdatePattern
    Exit Property
errHandler:
    ErrorIn "Substitute.Enabled(bVal)", bVal
End Property

Public Property Get CaseSensitive() As Boolean
    On Error GoTo errHandler
    CaseSensitive = Not oRegExp.IgnoreCase
    Exit Property
errHandler:
    ErrorIn "Substitute.CaseSensitive"
End Property
Public Property Let CaseSensitive(bVal As Boolean)
    oRegExp.IgnoreCase = Not bVal
End Property

Public Property Get Simple() As Boolean
    Simple = bSimple
End Property
Public Property Let Simple(bVal As Boolean)
    If bSimple = bVal Then Exit Property
    bSimple = bVal
    UpdatePattern
End Property

Public Property Get RegExp() As VBScript_RegExp_55.RegExp
    On Error GoTo errHandler
    Set RegExp = oRegExp
    Exit Property
errHandler:
    ErrorIn "Substitute.RegExp"
End Property


Private Sub Class_Initialize()
    On Error GoTo errHandler
    Set oRegExp = New VBScript_RegExp_55.RegExp
    oRegExp.MultiLine = True
    oRegExp.Global = False
    bEnabled = True
    bCaseSensitive = False
    oRegExp.IgnoreCase = Not bCaseSensitive
    Exit Sub
errHandler:
    ErrorIn "Substitute.Class_Initialize"
End Sub

