VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SubstituteCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private arrContents() As Substitute

Private SessionObject As frmSession

Friend Sub Init(SessionForm As frmSession)
    Set SessionObject = SessionForm
End Sub

'Public Sub AddObject(objColItem As ICollectionItem)
'    Dim lngIdx As Long
'    lngIdx = GetIndex(objColItem.Name)
'    If lngIdx = -1 Then
'        lngIdx = UBound(arrContents)
'        ReDim Preserve arrContents(lngIdx + 1)
'        Set arrContents(lngIdx) = New Substitute
'    End If
'    With arrContents(lngIdx)
'        .Enabled = objColItem.bEnabled
'        .CaseSensitive = objColItem.bCaseSensitive
'        .Name = objColItem.Name
'        .Simple = objColItem.bSimple
'        .Command = objColItem.Command
'        .Pattern = objColItem.Pattern
'    End With
'End Sub

Public Sub AddObject(objSubstitute As Substitute)
    Dim lngIdx As Long
    lngIdx = UBound(arrContents)
    ReDim Preserve arrContents(lngIdx + 1)
    Set arrContents(lngIdx) = objSubstitute
End Sub

Public Sub Add(Name As String, Pattern As String, Command As String, bCaseSensitive As Boolean, Optional bEnabled As Boolean = True, Optional bSimple As Boolean = True)
    On Error GoTo errHandler
    Dim lngIdx As Long
    lngIdx = GetIndex(Name)
    If lngIdx = -1 Then
        lngIdx = UBound(arrContents)
        ReDim Preserve arrContents(lngIdx + 1)
        Set arrContents(lngIdx) = New Substitute
    End If
    With arrContents(lngIdx)
        .Enabled = bEnabled
        .CaseSensitive = bCaseSensitive
        .Name = Name
        .Simple = bSimple
        .Command = Command
        .Pattern = Pattern
    End With
    Exit Sub
errHandler:
    ErrorIn "SubstituteCollection.Add(Name,Pattern,Command,bCaseSensitive,bEnabled," & _
        "bSimple)", Array(Name, Pattern, Command, bCaseSensitive, bEnabled, bSimple)
End Sub

Public Sub Remove(Index As Variant)
    On Error GoTo errHandler
    Dim lngIdx As Long
    Dim lng As Long
    Dim lngOrigSize As Long
    lngOrigSize = UBound(arrContents) - 1
    lngIdx = GetIndex(Index)
    For lng = lngIdx + 1 To lngOrigSize
        Set arrContents(lng - 1) = arrContents(lng)
    Next
    ReDim Preserve arrContents(lngOrigSize)
    Set arrContents(lngOrigSize) = Nothing
    Exit Sub
errHandler:
    ErrorIn "SubstituteCollection.Remove(Index)", Index
End Sub

Public Property Get Item(Index As Variant) As Substitute
Attribute Item.VB_UserMemId = 0
On Error GoTo ErrorH
    Set Item = arrContents(GetIndex(Index))
    Exit Property
ErrorH:
    Set Item = Nothing
End Property

Public Function GetIndex(Index As Variant) As Long
    On Error GoTo errHandler
    Dim lng As Long
    GetIndex = -1
    Select Case VarType(Index)
        Case vbLong, vbByte, vbInteger
            If Index < UBound(arrContents) Then GetIndex = Index
        Case vbString
            For lng = 0 To UBound(arrContents) - 1
                If arrContents(lng).Name = Index Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
        Case vbObject
            For lng = 0 To UBound(arrContents) - 1
                If arrContents(lng) Is Index Then
                    GetIndex = lng
                    Exit Function
                End If
            Next
    End Select
    Exit Function
errHandler:
    ErrorIn "SubstituteCollection.GetIndex(Index)", Index
End Function

Public Property Get Count() As Long
    On Error GoTo errHandler
    Count = UBound(arrContents)
    Exit Property
errHandler:
    ErrorIn "SubstituteCollection.Count"
End Property

Public Sub Swap(Index1 As Variant, Index2 As Variant)
    On Error GoTo errHandler
    Dim oTemp As Substitute
    Dim l1 As Long, l2 As Long
    l1 = GetIndex(Index1)
    l2 = GetIndex(Index2)
    Set oTemp = arrContents(l1)
    Set arrContents(l1) = arrContents(l2)
    Set arrContents(l2) = oTemp
    Exit Sub
errHandler:
    ErrorIn "SubstituteCollection.Swap(Index1,Index2)", Array(Index1, Index2)
End Sub

Private Sub Class_Initialize()
    On Error GoTo errHandler
    ReDim arrContents(0)
    Exit Sub
errHandler:
    ErrorIn "SubstituteCollection.Class_Initialize"
End Sub

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------

Private Sub DoAction(ActionNo As Long, ByRef strBuffer As String)
    On Error GoTo errHandler
    Dim objMatches As MatchCollection
    Dim lngSearchFromIdx As Long
    Dim strReplace As String
    Dim lngFirstIndex As Long
    
    With arrContents(ActionNo)
        lngSearchFromIdx = 1
        Set objMatches = .RegExp.Execute(strBuffer)
        Do While objMatches.Count > 0
            If objMatches.Item(0).Length = 0 Then
                .Enabled = False
                SessionObject.Terminal.PrintString vbCrLf & "#Warning Substitute " & .Name & " disabled because of zerolength match." & vbCrLf
                Exit Sub
            End If
            SessionObject.CmdHandler.Execute .Command, MC2Collection(objMatches), bf_SubstituteResponse, True
            strReplace = SessionObject.Response.Buffer(bf_SubstituteResponse).GetString
            SessionObject.Response.Buffer(bf_SubstituteResponse).Flush
            lngFirstIndex = objMatches.Item(0).FirstIndex
            strBuffer = Left(strBuffer, lngFirstIndex + lngSearchFromIdx - 1) & strReplace & Mid(strBuffer, objMatches.Item(0).FirstIndex + objMatches.Item(0).Length + lngSearchFromIdx)
            If lngFirstIndex = 0 Then lngFirstIndex = 1
            lngSearchFromIdx = lngSearchFromIdx + lngFirstIndex + Len(strReplace) - 1
            If lngSearchFromIdx > Len(strBuffer) Then Exit Do
            Set objMatches = .RegExp.Execute(Mid(strBuffer, lngSearchFromIdx))
        Loop
    End With
    Exit Sub
errHandler:
    ErrorIn "SubstituteCollection.DoAction(ActionNo,strBuffer)", Array(ActionNo, strBuffer)
End Sub

Public Sub Evaluate(ByRef strText As String)
    On Error GoTo errHandler
'executes all the actions required....
    Dim lngAction As Long
    For lngAction = 0 To UBound(arrContents) - 1
        If arrContents(lngAction).Enabled Then
            DoAction lngAction, strText
        End If
    Next
    Exit Sub
errHandler:
    ErrorIn "SubstituteCollection.Evaluate(strText)", strText
End Sub


