VERSION 5.00
Begin VB.UserControl Terminal 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5295
   ClipBehavior    =   0  'None
   KeyPreview      =   -1  'True
   ScaleHeight     =   3480
   ScaleWidth      =   5295
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   2040
      Top             =   1080
   End
   Begin VB.VScrollBar Scrollbar 
      Height          =   3465
      Left            =   5040
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   240
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "Edit Menu"
      Begin VB.Menu mnuCopy 
         Caption         =   "Copy Selection"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuPaste 
         Caption         =   "Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu mnuEcho 
         Caption         =   "Echo clipboard"
      End
   End
End
Attribute VB_Name = "Terminal"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


Private minimumXDim As Long  'do not wrap before 40 under no circumtances

Private Const xDim = 127
Private Const yDim = &H1FFF

Private Type BufferType
    Color As Byte 'high 4bit is backcolor
    Char As Byte
End Type

Private CharXsize As Long
Private CharYsize As Long
Private hBrush(15) As Long
Private Colors(15) As Long
Private Buffer(xDim, yDim) As BufferType
Private VisibleXDim As Long
Private VisibleYDim As Long
Private ViewOffset As Long
Private LastLineOffset As Long
Private oCursor As New Cursor
Private BlinkState As Boolean
'Copy handling:
Private SelStart As PositionType
Private SelEnd As PositionType
Private MousePos As PositionType

Private Type PositionType
    Xpos As Long
    YPos As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function ExtTextOut Lib "gdi32" Alias "ExtTextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal wOptions As Long, lpRect As RECT, ByVal lpString As String, ByVal nCount As Long, lpDx As Long) As Long
Private Const OPAQUE = 2
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function InvertRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As Any, ByVal lpFile As String, ByVal lpParameters As Any, ByVal lpDirectory As Any, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1

Public Event KeyPressed(KeyAscii As Integer)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event WriteString(sString As String) 'used by Paste
Public Event Resize()
Public Event SelectedText()

Private Sub RenderCursor()
    On Error GoTo errHandler
    Dim strC As String
    Dim XorPattern As Long
    With oCursor
        If (.Xpos <= VisibleXDim) And (.YPos <= (VisibleYDim + Scrollbar.Value)) Then
            With Buffer(.Xpos, (.YPos + LastLineOffset - VisibleYDim) And yDim)
                strC = Chr(.Char)
                XorPattern = CLng(BlinkState) And &HFFFFFF
                SetBkColor UserControl.hdc, Colors(.Color \ 16) Xor XorPattern
                SetTextColor UserControl.hdc, Colors(.Color And 15) Xor XorPattern
            End With
            TextOut UserControl.hdc, .Xpos * CharXsize, (.YPos - Scrollbar.Value) * CharYsize, strC, 1
        End If
    End With
    Exit Sub
errHandler:
    ErrorIn "Terminal.RenderCursor"
End Sub

Private Sub mnuCopy_Click()
    On Error GoTo errHandler
    Copy
    Exit Sub
errHandler:
    ErrorIn "Terminal.mnuCopy_Click"
End Sub

'Private Sub mnuEcho_Click()
'    On Error GoTo errHandler
'    Clipboard.GetText
'    Exit Sub
'errHandler:
'    ErrorIn "Terminal.mnuEcho_Click"
'End Sub

Private Sub mnuPaste_Click()
    On Error GoTo errHandler
    Paste
    Exit Sub
errHandler:
    ErrorIn "Terminal.mnuPaste_Click"
End Sub



Private Sub Timer1_Timer()
    BlinkState = Not BlinkState
    RenderCursor
End Sub

Private Sub UserControl_DblClick()
    On Error GoTo errHandler
    'Check if its a link and then open it in a browser
    Dim StartX As Long
    Dim EndX As Long
    Dim lngX As Long
    Dim strTemp As String
    Dim C As Byte
    StartX = MousePos.Xpos
    EndX = MousePos.Xpos
    C = Buffer(StartX, MousePos.YPos And yDim).Char
    While StartX > 0 And (C <> 32) And (C <> 0)
        StartX = StartX - 1
        C = Buffer(StartX, MousePos.YPos And yDim).Char
    Wend
    If C = 0 Or C = 32 Then
        StartX = StartX + 1
    End If
    
    C = Buffer(EndX, MousePos.YPos And yDim).Char
    While EndX < xDim And (C <> 32) And (C <> 0)
        EndX = EndX + 1
        C = Buffer(EndX, MousePos.YPos And yDim).Char
    Wend
    If C = 0 Or C = 32 Then
        EndX = EndX - 1
    End If
    strTemp = ""
    For lngX = StartX To EndX
        strTemp = strTemp & Chr(Buffer(lngX, MousePos.YPos And yDim).Char)
    Next
    If LCase(Left(strTemp, 7)) = "http://" Then
        ShellExecute 0, 0&, strTemp & vbNullString, 0&, 0&, SW_SHOWNORMAL
    End If
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_DblClick"
End Sub

Private Sub UserControl_EnterFocus()
    On Error GoTo errHandler
    BlinkState = True
    RenderCursor
    Timer1.Enabled = True
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_EnterFocus"
End Sub

Private Sub UserControl_ExitFocus()
    On Error GoTo errHandler
    Timer1.Enabled = False
    BlinkState = False
    RenderCursor
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_ExitFocus"
End Sub

Public Sub SetFont(FontName As String, FontSize As Integer, FontBold As Boolean)
'// Sets the font used in the terminal window. For speed MonkeyTerm can only display monospaced fonts correctly, but this funtion does not check if the font will work or not.
    On Error GoTo errHandler
    With UserControl.Font
        If FontName <> "" Then .Name = FontName
        .Size = FontSize
        .Bold = FontBold
    End With
    UserControl.Cls
    CharYsize = UserControl.ScaleY(UserControl.TextHeight("M"), UserControl.ScaleMode, vbPixels)
    ' \ 15 'todo: make smart calc
    CharXsize = UserControl.ScaleX(UserControl.TextWidth(String(100, "M")) / 100, UserControl.ScaleMode, vbPixels) ' \ (15 * 30)
    UserControl_Resize
    Exit Sub
errHandler:
    ErrorIn "Terminal.SetFont(FontName,FontSize,FontBold)", Array(FontName, FontSize, FontBold)
End Sub

Public Property Get Color(Index As Integer) As Long
'// Reads or writes the actual color for one of the 16 displayable colors.
    On Error GoTo errHandler
    Color = Colors(Index)
    Exit Property
errHandler:
    ErrorIn "Terminal.Color(Index)", Index
End Property

Public Property Let Color(Index As Integer, lColor As Long)
    On Error GoTo errHandler
    Colors(Index) = lColor
    DeleteObject hBrush(Index)
    hBrush(Index) = CreateSolidBrush(lColor)
    If Index = 0 Then
        UserControl.BackColor = lColor
    End If
    UpdateChanges
    Exit Property
errHandler:
    ErrorIn "Terminal.Color(Index,lColor)", Array(Index, lColor)
End Property

Private Sub UserControl_Initialize()
    On Error GoTo errHandler
    Dim Intensity As Byte
    Dim CurColor As Byte
    Dim lngX As Long, lngY As Long
    
    minimumXDim = 40
    With oCursor
        .Color = 7 'is overwritten by the protocolparser
        .Xpos = 0
        .YPos = 0
        .Echo = True
    End With
    Scrollbar.Min = -yDim
    Scrollbar.Max = 0
    Scrollbar.Value = 0
    SetBkMode UserControl.hdc, OPAQUE
    SetFont "Fixedsys", 9, False
    ResetColors
    UserControl.FillColor = &HFFFFFF
    
    SelEnd.Xpos = -1
    SelEnd.YPos = -1
    SelStart.Xpos = -1
    SelStart.YPos = -1
     
     
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_Initialize"
End Sub

Public Sub ResetColors()
'// Resets all colors to default values.
    On Error GoTo errHandler
    Dim lng As Long
    For lng = 0 To 15
        Colors(lng) = QBColor((lng And (&HFF - 1 - 4)) + ((lng And 1) * 4) + ((lng And 4) \ 4))
        hBrush(lng) = CreateSolidBrush(Colors(lng))
    Next
    UserControl.BackColor = Colors(0)
    UpdateChanges
    Exit Sub
errHandler:
    ErrorIn "Terminal.ResetColors"
End Sub


Private Sub GetSelectionBox(ByRef BoxStart As PositionType, ByRef BoxEnd As PositionType)
    On Error GoTo errHandler
    'Dim MyRect As RECT
    Dim VisXdimPlusOne As Long
    Dim lngTemp As Long
    If ((SelStart.Xpos <> SelEnd.Xpos) Or (SelStart.YPos <> SelEnd.YPos)) And (SelStart.Xpos >= 0) Then
        If ((SelStart.Xpos > SelEnd.Xpos) And (SelStart.YPos = SelEnd.YPos)) Or _
            (SelStart.YPos > SelEnd.YPos) Then
            BoxStart.Xpos = SelEnd.Xpos
            BoxEnd.Xpos = SelStart.Xpos
            BoxStart.YPos = (SelEnd.YPos - LastLineOffset + VisibleYDim - Scrollbar.Value)
            BoxEnd.YPos = (SelStart.YPos - LastLineOffset + VisibleYDim - Scrollbar.Value)
        Else
            BoxStart.YPos = (SelStart.YPos - LastLineOffset + VisibleYDim - Scrollbar.Value)
            BoxEnd.YPos = (SelEnd.YPos - LastLineOffset + VisibleYDim - Scrollbar.Value)
            BoxStart.Xpos = SelStart.Xpos
            BoxEnd.Xpos = SelEnd.Xpos
        End If
        If (BoxStart.Xpos > VisibleXDim) Then
            BoxStart.Xpos = 0
            BoxStart.YPos = BoxStart.YPos + 1
        End If
        If (BoxEnd.Xpos > VisibleXDim) Then
            BoxEnd.Xpos = VisibleXDim
        End If
        If BoxStart.YPos >= yDim + 1 Then
            BoxStart.YPos = BoxStart.YPos - yDim - 1
        End If
        If BoxEnd.YPos >= yDim + 1 Then
            BoxEnd.YPos = BoxEnd.YPos - yDim - 1
        End If

        If BoxEnd.YPos < BoxStart.YPos Then 'can this happen?
            lngTemp = BoxEnd.YPos 'swap
            BoxEnd.YPos = BoxStart.YPos
            BoxStart.YPos = lngTemp
        End If

        If BoxStart.YPos < 0 Then
            BoxStart.Xpos = 0
            BoxStart.YPos = 0
        End If
        If BoxEnd.YPos > (VisibleYDim + 1) Then
            BoxEnd.Xpos = VisibleXDim
            BoxEnd.YPos = VisibleYDim + 1
        End If

        If (BoxStart.YPos > BoxEnd.YPos) Or _
           (BoxEnd.YPos > VisibleYDim + 1) Or _
           (BoxStart.YPos > VisibleYDim) Or (BoxEnd.YPos < 0) Then
            'validate and unselect if invalid.
            BoxStart.Xpos = -1
            BoxEnd.Xpos = -1
            BoxStart.YPos = -1
            BoxEnd.YPos = -1
        End If


    Else
        BoxStart.Xpos = -1
        BoxEnd.Xpos = -1
        BoxStart.YPos = -1
        BoxEnd.YPos = -1
    End If
    
    Exit Sub
errHandler:
    ErrorIn "Terminal.GetSelectionBox(BoxStart,BoxEnd)"
End Sub

Private Sub UpdateChanges()
    On Error GoTo errHandler
    Dim CurX As Long
    Dim CurY As Long
    Dim CurColor As Byte
    Dim strDump As String
    Dim lngStrOffset As Long
    Dim lngX As Long, lngY As Long
    Dim BufferY As Long
    Dim VisXdimPlusOne As Long
    Dim MyRect As RECT
    Dim BoxStart As PositionType
    Dim BoxEnd As PositionType
    Dim YIsInSelBox As Boolean
    Dim TempColor As Byte
    With MyRect
        .Top = (VisibleYDim + 1) * CharYsize
        .Bottom = UserControl.ScaleY(UserControl.Height, UserControl.ScaleMode, vbPixels)
        .Left = 0
        .Right = UserControl.ScaleX(UserControl.Width, UserControl.ScaleMode, vbPixels)
    End With
    FillRect UserControl.hdc, MyRect, hBrush(0)

    GetSelectionBox BoxStart, BoxEnd
    If VisibleXDim < xDim Then
        VisXdimPlusOne = VisibleXDim + 1
    Else
        VisXdimPlusOne = VisibleXDim
    End If

    CurY = 0
    For lngY = 0 To VisibleYDim
        CurX = 0
        BufferY = (lngY + LastLineOffset - VisibleYDim + Scrollbar.Value) And yDim
        With Buffer(0, BufferY)
            lngStrOffset = 0
            strDump = ""
            If ((lngY = BoxStart.YPos) And (BoxStart.Xpos = 0)) Or _
                (lngY > BoxStart.YPos) And (lngY <= BoxEnd.YPos) Then
                CurColor = .Color Xor 255
            Else
                CurColor = .Color
            End If
        End With
        For lngX = 0 To VisXdimPlusOne
            With Buffer(lngX, BufferY)
                If .Char = 0 Then
                    strDump = strDump & " "
                Else
                    strDump = strDump & Chr(.Char)
                End If
                If lngX = VisXdimPlusOne Then
                    SetBkColor UserControl.hdc, Colors(CurColor \ 16)
                    SetTextColor UserControl.hdc, Colors(CurColor And 15)
                    TextOut UserControl.hdc, lngStrOffset, CurY, strDump, Len(strDump)
                Else
                    TempColor = Buffer(lngX + 1, BufferY).Color
                    If (lngY >= BoxStart.YPos) And (lngY <= BoxEnd.YPos) Then
                        If lngY = BoxStart.YPos Then
                            If (lngX + 1 >= BoxStart.Xpos) Then
                                If (lngY < BoxEnd.YPos) Then
                                    TempColor = TempColor Xor 255
                                ElseIf lngX < BoxEnd.Xpos Then
                                    TempColor = TempColor Xor 255
                                End If
                            End If
                        ElseIf (lngY = BoxEnd.YPos) Then
                            If (lngX < BoxEnd.Xpos) And (lngY > BoxStart.YPos) Then
                                TempColor = TempColor Xor 255
                            End If
                        Else
                            TempColor = TempColor Xor 255
                        End If
                    End If
                    If (CurColor <> TempColor) Then
                        SetBkColor UserControl.hdc, Colors(CurColor \ 16)
                        SetTextColor UserControl.hdc, Colors(CurColor And 15)
                        TextOut UserControl.hdc, lngStrOffset, CurY, strDump, Len(strDump)
                        lngStrOffset = CurX + CharXsize
                        CurColor = TempColor
                        strDump = ""
                    End If
                End If
            End With
            CurX = CurX + CharXsize
        Next
        CurY = CurY + CharYsize
    Next
    RenderCursor
    Exit Sub
errHandler:
    ErrorIn "Terminal.UpdateChanges"
End Sub

Private Function ConvertMouseXYtoPos(ByVal x As Single, ByVal y As Single) As PositionType
    On Error GoTo errHandler
    If x < 0 Then x = 0
    If x > UserControl.ScaleX(VisibleXDim * CharXsize, vbPixels, UserControl.ScaleMode) Then x = UserControl.ScaleX(VisibleXDim * CharXsize, vbPixels, UserControl.ScaleMode)
    If y < 0 Then y = 0
    If y > UserControl.ScaleY(VisibleYDim * CharYsize, vbPixels, UserControl.ScaleMode) Then y = UserControl.ScaleY(VisibleYDim * CharYsize, vbPixels, UserControl.ScaleMode)
    
    MousePos.Xpos = (x \ UserControl.ScaleX(CharXsize, vbPixels, UserControl.ScaleMode))
    MousePos.YPos = ((y \ UserControl.ScaleY(CharYsize, vbPixels, UserControl.ScaleMode)) + LastLineOffset - VisibleYDim + Scrollbar.Value)
    ConvertMouseXYtoPos = MousePos
    Exit Function
errHandler:
    ErrorIn "Terminal.ConvertMouseXYtoPos(X,Y)", Array(x, y)
End Function

Public Function Paste()
'// Pastes the text from the clipboard onto the terminal window.
    On Error GoTo errHandler
    RaiseEvent WriteString(Clipboard.GetText)
    Exit Function
errHandler:
    ErrorIn "Terminal.Paste"
End Function

Public Property Get SelectedText() As String
'// Returns the selected text
    On Error GoTo errHandler
    Dim lngY As Long
    Dim lngX As Long
    Dim PosStart As PositionType
    Dim PosEnd As PositionType
    Dim strTemp As String
    Dim strTempLine As String
    Dim lngTemp As Long
    Dim lngXStart As Long
    Dim lngXEnd As Long
    If ((SelStart.Xpos <> SelEnd.Xpos) Or (SelStart.YPos <> SelEnd.YPos)) And (SelStart.Xpos > -1) Then
        PosStart.Xpos = SelStart.Xpos
        PosEnd.Xpos = SelEnd.Xpos
        PosStart.YPos = SelStart.YPos
        PosEnd.YPos = SelEnd.YPos
        'If PosStart.YPos < LastLineOffset Then
        '    PosStart.YPos = PosStart.YPos + yDim + 1
        'End If
        'If PosEnd.YPos < LastLineOffset Then
        '    PosEnd.YPos = PosEnd.YPos + yDim + 1
        'End If
        If PosEnd.YPos < PosStart.YPos Then 'swap
            lngTemp = PosEnd.YPos
            PosEnd.YPos = PosStart.YPos
            PosStart.YPos = lngTemp
        End If
        If PosEnd.Xpos < PosStart.Xpos Then 'swap
            lngTemp = PosEnd.Xpos
            PosEnd.Xpos = PosStart.Xpos
            PosStart.Xpos = lngTemp
        End If
        strTemp = ""
        lngY = PosStart.YPos
        For lngY = PosStart.YPos To PosEnd.YPos
            strTempLine = ""
            If lngY = PosStart.YPos Then
                lngXStart = PosStart.Xpos
            Else
                lngXStart = 0
            End If
            If lngY = PosEnd.YPos Then
                lngXEnd = PosEnd.Xpos
            Else
                lngXEnd = xDim
            End If
            For lngX = lngXStart To lngXEnd
                If Buffer(lngX, lngY And yDim).Char <> 0 Then
                    strTempLine = strTempLine & Chr(Buffer(lngX, lngY And yDim).Char)
                End If
            Next
            strTemp = strTemp & RTrim(strTempLine)
            If lngY < PosEnd.YPos Then
                strTemp = strTemp & vbCrLf
            End If
        Next
        SelectedText = strTemp
    Else
        SelectedText = ""
    End If
    Exit Property
errHandler:
    ErrorIn "Terminal.SelectedText"
End Property

Public Sub Copy()
'// Copies the text from the selection onto the clipboard.
    On Error GoTo errHandler
    Clipboard.Clear
    Clipboard.SetText SelectedText
    Exit Sub
errHandler:
    ErrorIn "Terminal.Copy"
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errHandler
    If KeyCode = vbKeyV And Shift = 2 Then
        Paste
    End If
    RaiseEvent KeyDown(KeyCode, Shift)
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_KeyDown(KeyCode,Shift)", Array(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPressed(KeyAscii)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errHandler
    Select Case Button
        Case vbLeftButton
            SelStart = ConvertMouseXYtoPos(x, y)
        Case vbRightButton
            PopupMenu mnuEdit
        Case vbMiddleButton
            Paste
    End Select
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_MouseDown(Button,Shift,X,Y)", Array(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errHandler
    Dim OldPos As PositionType
    If (Button And vbLeftButton) > 0 Then
        'TODO: make it posible to scroll if y is out of bounds
        If y < 0 Then
            If Scrollbar.Value > Scrollbar.Min Then
                Scrollbar.Value = Scrollbar.Value - 1
            End If
        ElseIf y > (VisibleYDim + 1) * CharYsize * 15 Then
            If Scrollbar.Value < Scrollbar.Max Then
                Scrollbar.Value = Scrollbar.Value + 1
            End If
        End If
        OldPos = SelEnd
        SelEnd = ConvertMouseXYtoPos(x, y)
        If (OldPos.Xpos <> SelEnd.Xpos) Or (OldPos.YPos <> SelEnd.YPos) Then
            UpdateChanges
        End If
    End If
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_MouseMove(Button,Shift,X,Y)", Array(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errHandler
    Dim OldPos As PositionType
    If (Button And vbLeftButton) > 0 Then
        OldPos = SelEnd
        SelEnd = ConvertMouseXYtoPos(x, y)
        If (OldPos.Xpos <> SelEnd.Xpos) Or (OldPos.YPos <> SelEnd.YPos) Then
            UpdateChanges
        End If
        If ((SelStart.Xpos <> SelEnd.Xpos) Or (SelStart.YPos <> SelEnd.YPos)) And (SelStart.Xpos > -1) Then
            RaiseEvent SelectedText
        End If
    End If
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_MouseUp(Button,Shift,X,Y)", Array(Button, Shift, x, y)
End Sub

Private Sub UserControl_Paint()
    On Error GoTo errHandler
    UserControl.Cls
    UpdateChanges
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_Paint"
End Sub

Private Sub UserControl_Resize()
    On Error GoTo errHandler
    Dim OldVisYDim As Long
    Dim sngTemp As Single
    VisibleXDim = ((UserControl.ScaleX(UserControl.Width - Scrollbar.Width, UserControl.ScaleMode, vbPixels) - 4) \ (CharXsize)) - 1
    If VisibleXDim < minimumXDim Then VisibleXDim = minimumXDim
    OldVisYDim = VisibleYDim
    VisibleYDim = ((UserControl.ScaleY(UserControl.Height, UserControl.ScaleMode, vbPixels) - 4) \ (CharYsize)) - 1
    If VisibleXDim > xDim Then VisibleXDim = xDim
    If VisibleYDim > yDim Then VisibleYDim = yDim ':-)
    If VisibleYDim < 1 Then VisibleYDim = 1
    'TODO: Snap to Integer Size
    With oCursor
        .YPos = .YPos + VisibleYDim - OldVisYDim
        If .YPos < 0 Then .YPos = 0
        If .YPos > VisibleYDim Then .YPos = VisibleYDim
    End With
    Scrollbar.Left = UserControl.Width - Scrollbar.Width - 4 * 15
    sngTemp = UserControl.Height - 4 * 15
    If sngTemp < 0 Then sngTemp = 0
    Scrollbar.Height = sngTemp
    Scrollbar.LargeChange = VisibleYDim
    Scrollbar.Min = -yDim + VisibleYDim
    
    'TODO: NegotiateTerminalSize
    
    UpdateChanges
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_Resize"
End Sub

Private Sub UserControl_Terminate()
    On Error GoTo errHandler
    Dim lng As Long
    For lng = 0 To 15
        DeleteObject hBrush(lng)
    Next
    Exit Sub
errHandler:
    ErrorIn "Terminal.UserControl_Terminate"
End Sub

Public Sub PrintReturn()
'// Prints a single newline on the terminal window.
    On Error GoTo errHandler
    Dim lngX As Long
    With oCursor
        .Xpos = 0
        If .YPos = VisibleYDim Then
            LastLineOffset = (LastLineOffset + 1) And yDim
            If (Scrollbar.Value > -yDim + VisibleYDim) And (Scrollbar.Value < 0) Then
                Scrollbar.Value = Scrollbar.Value - 1
            End If
            If SelStart.YPos + yDim + 1 = LastLineOffset Then
                If SelStart.YPos = SelEnd.YPos Then
                    SelEnd.Xpos = SelStart.Xpos
                Else
                    SelStart.YPos = SelStart.YPos + 1
                End If
            End If
            If SelEnd.YPos + yDim + 1 = LastLineOffset Then
                If SelStart.YPos = SelEnd.YPos Then
                    SelEnd.Xpos = SelStart.Xpos
                Else
                    SelEnd.YPos = SelEnd.YPos + 1
                End If
            End If
            For lngX = 0 To xDim
                Buffer(lngX, LastLineOffset).Char = 32
                Buffer(lngX, LastLineOffset).Color = 0
            Next
            'clear the new line
        Else
            .YPos = .YPos + 1
        End If
    End With
    Exit Sub
errHandler:
    ErrorIn "Terminal.PrintReturn"
End Sub

Public Sub PrintAChar(C As Byte)
'// Will print a single character onto the terminal window.
    On Error GoTo errHandler
    With oCursor
        With Buffer(.Xpos, (.YPos + LastLineOffset - VisibleYDim) And yDim)
            .Char = C
            .Color = oCursor.Color
        End With
        .Xpos = (.Xpos + 1)
        If .Xpos > VisibleXDim Then
            PrintReturn
        End If
    End With
    Exit Sub
errHandler:
    ErrorIn "Terminal.PrintAChar(c)", C
End Sub

Public Sub PrintString(ByVal str As String, Optional bForceScreenUpdate As Boolean = True)
'// Will print a string on the terminal window. No ANSI will be parsed so the text is send "as-is".
    On Error GoTo errHandler
    Dim l As Long
    Dim C As Byte
    For l = 1 To Len(str)
        C = Asc(Mid(str, l, 1))
        Select Case C
            Case 13
            Case 10: PrintReturn
            Case Else: PrintAChar C
        End Select
    Next
    If bForceScreenUpdate Then UpdateChanges
Exit Sub
errHandler:
    ErrorIn "Terminal.PrintString(str)", str
End Sub

Public Sub FillArea(lX1 As Long, lY1 As Long, lX2 As Long, lY2 As Long, Optional bChar As Byte = 32, Optional bColor As Byte = 0)
'// Fills a rectangle on the terminal window with a chosen character and a chosen background color. Default is black(color=0) spaces (will erase any section of text).
'// (0,0) is the upper left corner.
    Dim lngX As Long
    Dim lngY As Long
    Dim ltX1 As Long
    Dim ltX2 As Long
    Dim BufferY As Long
    For lngY = lY1 To lY2
        ltX1 = 0
        ltX2 = xDim
        If lngY = lY1 Then ltX1 = lX1
        If lngY = lY2 Then ltX1 = lX2
        BufferY = (lngY + LastLineOffset - VisibleYDim) And yDim
        For lngX = ltX1 To ltX2
            With Buffer(lngX, BufferY)
                .Char = bChar
                .Color = bColor
            End With
        Next
    Next
End Sub

Public Sub ClearScreen()
'// Clears the visible area of the screen with the default background color.
    FillArea 0, 0, xDim, VisibleYDim
End Sub

Public Sub WriteScreenBuffer(lngX As Long, lngY As Long, bCharcode As Byte, bColor As Byte)
'// Writes a character directly onto the terminal window without setting cursors etc. (0,0) is the upper left corner.
    With Buffer(lngX, (lngY + LastLineOffset - VisibleYDim) And yDim)
        .Char = bCharcode
        .Color = bColor
    End With
End Sub

Public Property Get Cursor() As Cursor
'// Returns the cusor object.
    Set Cursor = oCursor
End Property

Private Sub Scrollbar_Change()
    On Error GoTo errHandler
    UpdateChanges
    Exit Sub
errHandler:
    ErrorIn "Terminal.Scrollbar_Change"
End Sub

Private Sub Scrollbar_Scroll()
    On Error GoTo errHandler
    UpdateChanges
    Exit Sub
errHandler:
    ErrorIn "Terminal.Scrollbar_Scroll"
End Sub

Public Property Get PageHeight() As Long
'// Returns the visible height of the terminal window.
    PageHeight = VisibleYDim
End Property
Public Property Get PageWidth() As Long
'// Returns the visible width of the terminal window.
    PageWidth = VisibleXDim
End Property

Public Sub Scroll(lngDeltaY As Long)
'// Will scroll the terminal window up or down.
    On Error GoTo errHandler
    Dim lTemp As Long
    lTemp = Scrollbar.Value + lngDeltaY
    If lTemp < Scrollbar.Min Then lTemp = Scrollbar.Min
    If lTemp > Scrollbar.Max Then lTemp = Scrollbar.Max
    Scrollbar.Value = lTemp
    UpdateChanges
    Exit Sub
errHandler:
    ErrorIn "Terminal.Scroll(lngDeltaY)", lngDeltaY
End Sub

Public Sub GotoBottom()
'// Scrolls the terminal window to the bottom.
    On Error GoTo errHandler
    Scrollbar.Value = 0
    UpdateChanges
    Exit Sub
errHandler:
    ErrorIn "Terminal.GotoBottom"
End Sub

Public Property Get FontName() As String
Attribute FontName.VB_Description = "Specifies the name of the font that appears in each row for the given level."
'// Reads or writes the font properties. See SetFont.
    FontName = UserControl.FontName
End Property

Public Property Get FontSize() As Integer
Attribute FontSize.VB_Description = "Specifies the size (in points) of the font that appears in each row for the given level."
'// Reads or writes the font properties. See SetFont.
    FontSize = UserControl.FontSize
End Property

Public Property Get FontBold() As Boolean
Attribute FontBold.VB_Description = "Returns/sets bold font styles."
'// Reads or writes the font properties. See SetFont.
    FontBold = UserControl.FontBold
End Property

Public Property Get WrapWidth() As Long
'// Reads or writes the wrapwidth. The position at witch the terminal window will wrap the text.
    WrapWidth = minimumXDim
End Property

Public Property Let WrapWidth(lNewWrapWidth As Long)
    minimumXDim = lNewWrapWidth
End Property

Public Sub Redraw()
'// Redraws the entire screen.
    UpdateChanges
End Sub
