Attribute VB_Name = "ToolBox"
Option Explicit

Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long


'Public Function StringEncode(str As String) As String
    'StringEncode = """" & Replace(Replace(Replace(str, """", """"""), vbLf, """ & vbLf & """), vbCr, """ & vbCr & """) & """"
'StringEncode = """" & Replace(Replace(Replace(Replace(str, """", """"""), vbLf, "\n"), vbCr, "\r"), "\", "\\") & """"
'End Function

Public Function ConvertToCRLF(str As String)
    ConvertToCRLF = Replace(Replace(str, vbCr, ""), vbLf, vbCrLf)
End Function

Public Function Glob2Regexp(sGlob As String) As String
    On Error GoTo errHandler
    Dim sOut As String
    Dim L As Long
    Dim C As String
    Dim bInEscape As Boolean
    bInEscape = False
    For L = 1 To Len(sGlob)
        C = Mid(sGlob, L, 1)
        If bInEscape Then
            Select Case C
                Case "\", "(", ")", "[", "]", ".", "?", "*", "n", "a"
                    C = "\" & C
                Case Else
                    C = "\x" & Right("0" & Hex(Asc(C)), 2)
            End Select
            bInEscape = False
        Else
            Select Case C
                Case "\": bInEscape = True: C = ""
                Case "?": C = "(.)"
                Case "*": C = "(.*)"
                Case ".", "+", "(", ")", "|", "{", "}", "^", "$": C = "\" & C
            End Select
        End If
        sOut = sOut & C
    Next
    Glob2Regexp = "^" & sOut & "$"
    Exit Function
errHandler:
    ErrorIn "ToolBox.Glob2Regexp(sGlob)", sGlob
End Function

Public Function String2Bool(strTemp As String) As Boolean
    If Trim(UCase(strTemp)) = "YES" Then String2Bool = True Else String2Bool = False
End Function

Public Function Bool2String(blnTemp As Boolean) As String
    If blnTemp Then Bool2String = "yes" Else Bool2String = "no"
End Function

Public Function ArgumentEncode(strArgumentType As String, strArgument As String) As String
    On Error GoTo errHandler
    Dim strOut As String
    strOut = Replace(strArgument, "\", "\\")
    Select Case strArgumentType
        Case "$"
            strOut = """" & Replace(strOut, """", """""") & """"
            strOut = Replace(strOut, vbCrLf, """ & vbCrlf & """)
            strOut = Replace(strOut, vbCr, """ & vbCr & """)
            strOut = Replace(strOut, vbLf, """ & vbLf & """)
        Case "%"
            strOut = Replace(strOut, vbCr, "\r")
            strOut = Replace(strOut, vbLf, "\n")
        Case ""
            strOut = Replace(strOut, vbCr, "\r")
            strOut = Replace(strOut, vbLf, "\n")
            strOut = Replace(strOut, "#", "\#")
    End Select
    ArgumentEncode = strOut
    Exit Function
errHandler:
    ErrorIn "ToolBox.ArgumentEncode(strArgumentType,strArgument)", Array(strArgumentType, _
         strArgument)
End Function

Function MC2Collection(oMC As MatchCollection) As Collection
    'converts a matchcollection to a normal collection
    Dim oCol As New Collection
    Dim L As Long
    If oMC Is Nothing Then
        Set MC2Collection = oCol
        Exit Function
    End If
    oCol.Add oMC.Item(0)
    For L = 1 To oMC.Item(0).SubMatches.Count
        oCol.Add (oMC.Item(0).SubMatches(L - 1))
    Next
    Set MC2Collection = oCol
End Function

Public Function GetMatchNo(oMatches As Collection, lngNo As Long) As String
    If oMatches Is Nothing Then
        GetMatchNo = ""
        Exit Function
    End If
    If lngNo >= oMatches.Count Then
        GetMatchNo = ""
    Else
        GetMatchNo = oMatches(lngNo + 1)
    End If
End Function

Public Function InsertMatches(ByVal strLine As String, ByVal oMatches As Collection) As String
    'inserts $ and %-params ... escapes
    'todo optimize....
    Dim lngIdx As Long
    Dim strOut As String
    Dim strC As String
    Dim strTemp As String
    Dim strMatch As String
    Dim lngArgPos As Long
    Dim blnInEscape As Boolean
    lngArgPos = -1
    blnInEscape = False
    For lngIdx = 1 To Len(strLine)
        strC = Mid(strLine, lngIdx, 1)
        If strC = "\" Then blnInEscape = Not blnInEscape
        Select Case strC
            Case "$", "%", ""
                If lngArgPos > 0 Then
                    If Mid(strTemp, 1, lngArgPos) = strC Then
                        lngArgPos = -1
                    Else
                        If Not blnInEscape Then lngArgPos = Len(strTemp) + 1
                    End If
                Else
                    If Not blnInEscape Then lngArgPos = Len(strTemp) + 1
                End If
            Case "0" To "9"
            Case Else
                If (lngArgPos > 0) And (lngArgPos < Len(strTemp)) Then
                    strMatch = GetMatchNo(oMatches, Mid(strTemp, lngArgPos + 1, Len(strTemp)))
                    'todo:
                    'If Mid(strTemp, lngArgPos, 1) = "$" Then strMatch = StringEncode(strMatch)
                    strMatch = ArgumentEncode(Mid(strTemp, lngArgPos, 1), strMatch)
                    strTemp = Left(strTemp, lngArgPos - 1) & strMatch
                End If
                lngArgPos = -1
        End Select
        If strC <> "\" Then blnInEscape = False
        strTemp = strTemp & strC
    Next
    If (lngArgPos > 0) And (lngArgPos < Len(strTemp)) Then
        strMatch = GetMatchNo(oMatches, Mid(strTemp, lngArgPos + 1, Len(strTemp)))
        'todo:
        'If Mid(strTemp, lngArgPos, 1) = "$" Then strMatch = StringEncode(strMatch)
        strMatch = ArgumentEncode(Mid(strTemp, lngArgPos, 1), strMatch)
        strTemp = Left(strTemp, lngArgPos - 1) & strMatch
    End If
    InsertMatches = strTemp
End Function



Public Function UnEscape(strIn As String) As String
    On Error GoTo errHandler
    Dim blnInEscape As Boolean
    Dim strC As String
    Dim strOut As String
    Dim L As Long
    strOut = ""
    For L = 1 To Len(strIn)
        strC = Mid(strIn, L, 1)
        If blnInEscape Then
            Select Case strC
                Case "n": strC = vbLf
                Case "r": strC = vbCr
                Case "v": strC = vbVerticalTab
                Case "f": strC = vbFormFeed
                Case "t": strC = vbTab
            End Select
            strOut = strOut & strC
            blnInEscape = False
        ElseIf strC = "\" Then
            blnInEscape = True
        Else
            strOut = strOut & strC
        End If
    Next
    If blnInEscape Then strOut = strOut & "\"
    UnEscape = strOut
    Exit Function
errHandler:
    ErrorIn "ToolBox.UnEscape(strIn)", strIn
End Function

Public Function Escape(strIn As String) As String
    On Error GoTo errHandler
    Escape = ArgumentEncode("%", strIn)
    Exit Function
errHandler:
    ErrorIn "ToolBox.Escape(strIn)", strIn
End Function


Public Function ParseHomeMadeRegExp(strIn As String) As String
    On Error GoTo errHandler
'substitutes \a with (?:\x1B\[[\d;]*\w)
    Dim blnInEscape As Boolean
    Dim strC As String
    Dim strOut As String
    Dim L As Long
    strOut = ""
    For L = 1 To Len(strIn)
        strC = Mid(strIn, L, 1)
        If blnInEscape Then
            Select Case strC
                Case "a":   strOut = strOut & "(?:\x1B\[[\d;]*\w)"
                Case Else:  strOut = strOut & "\" & strC
            End Select
            blnInEscape = False
        ElseIf strC = "\" Then
            blnInEscape = True
        Else
            strOut = strOut & strC
        End If
    Next
    If blnInEscape Then strOut = strOut & "\"
    ParseHomeMadeRegExp = strOut
    Exit Function
errHandler:
    ErrorIn "ToolBox.ParseHomeMadeRegExp(strIn)", strIn
End Function



'Public Function MaxArg(s As String)
''only used for in load to autogenerate patterns
'On Error GoTo ErrorHandler
'    Dim strArgNumber As String
'    Dim blnIsInArg As Boolean
'    Dim c As String
'    Dim lng As Long
'    Dim lngMaxArg As Long
'    Dim lngTemp As Long
'    lngMaxArg = -1
'    blnIsInArg = False
'    strArgNumber = ""
'    For lng = 1 To Len(s)
'        c = Mid(s, lng, 1)
'        Select Case c
'            Case "0" To "9"
'                If blnIsInArg Then strArgNumber = strArgNumber & c
'            Case "$", "%", ""
'                If blnIsInArg Then
'                    lngTemp = CLng(strArgNumber)
'                    If lngTemp > lngMaxArg Then lngMaxArg = lngTemp
'                End If
'                blnIsInArg = True
'                strArgNumber = ""
'            Case Else
'                If blnIsInArg Then
'                    lngTemp = CLng(strArgNumber)
'                    If lngTemp > lngMaxArg Then lngMaxArg = lngTemp
'                    blnIsInArg = False
'                End If
'        End Select
'    Next
'    If blnIsInArg Then
'        lngTemp = CLng(strArgNumber)
'        If lngTemp > lngMaxArg Then lngMaxArg = lngTemp
'        blnIsInArg = False
'    End If
'    MaxArg = lngMaxArg
'Exit Function
'ErrorHandler:
'    If Err.Number = 6 Then 'overflow (clng)
'        'skriv noget ud i terminal vinduet
'    End If
'    Resume Next
'End Function
'

Public Function GetFolderPath(sPath As String) As String
    On Error GoTo errHandler
    Dim L As Long
    L = InStrRev(sPath, "\")
    If L > 0 Then
        GetFolderPath = Left(sPath, L - 1)
    Else
        GetFolderPath = ""
    End If
    Exit Function
errHandler:
    ErrorIn "ToolBox.GetFolderPath(sPath)", sPath
End Function

Public Function GetFileObject(strFileName As String) As Object
    On Error Resume Next
    Dim objFSO As Object, objTS As Object
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    Set objTS = objFSO.OpenTextFile(strFileName, ForAppending, True)
    Set GetFileObject = objTS
End Function

Public Sub CloseFileObject(objTS As Object)
    On Error Resume Next
    objTS.Close
    Set objTS = Nothing
End Sub

Public Sub LogToFile(objFile As Object, strFile As String, strData As String)
    On Error Resume Next
    If (objFile Is Nothing) Then Set objFile = GetFileObject(strFile)
    objFile.Write strData
End Sub
