VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 1  'vbDataSource
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Variables"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// A collection of variables. These variables can be access through either <b>session.variables</b> or just through <b>vars</b>.

Private oVars As Object

'Friend Function GetKey(Key As Variant) As Long
'    On Error GoTo errHandler
'    Dim arrTemp As Variant
'
'    GetIndex = -1
'    Select Case VarType(Index)
'        Case vbLong, vbByte, vbInteger
'            arrTemp = oVars.Keys
'            GetKey = arrTemp(vntIndexKey)
'        Case vbString
'            GetKey = Index
'    End Select
'    Exit Function
'errHandler:
'    ErrorIn "Variables.GetIndex(Index)", Index
'End Function

Public Sub Add(vntName As Variant, vntValue As Variant)
'// Add a variable. If another variable with the same name already exists, the call is ignored.
On Error GoTo ErrorH
    oVars.Add CStr(vntName), CStr(vntValue)
    Exit Sub
ErrorH:
End Sub

Public Sub Remove(vntIndexKey As Variant)
'// Removes a variable from the collection with the name or index value from vntIndexKey.
On Error GoTo ErrorH
    Dim strKey As String
    Dim arrTemp As Variant
    
    If IsNumeric(vntIndexKey) Then
        arrTemp = oVars.Keys
        strKey = arrTemp(vntIndexKey)
    Else
        strKey = vntIndexKey
    End If
    
    oVars.Remove strKey
    Exit Sub
ErrorH:
End Sub

Public Property Get Key(vntIndexKey As Variant) As Variant
'// Reads or writes the name of a variable. The name itself is the key but a numeric index can be used as well.
On Error GoTo ErrorH
    Dim arrTemp As Variant
    
    arrTemp = oVars.Keys
    Key = arrTemp(vntIndexKey)
    Exit Property
ErrorH:
End Property

Public Property Let Key(vntIndexKey As Variant, vntValue As Variant)
    On Error GoTo errHandler
    Dim strValue As String
    
    strValue = oVars.Item(vntIndexKey)
    oVars.Remove vntIndexKey, CStr(vntValue)
    oVars.Add
    Exit Property
errHandler:
    ErrorIn "Variables.Key(vntIndexKey,vntValue)", Array(vntIndexKey, vntValue)
End Property

Public Property Get Value(vntIndexKey As Variant) As Variant
Attribute Value.VB_UserMemId = 0
'// Reads or writes to a variable with the name or index value of vntIndexKey.
On Error GoTo ErrorH
    Dim strKey As String
    Dim arrTemp As Variant
    
    If IsNumeric(vntIndexKey) Then          ' Access with key is faster than with index.
        arrTemp = oVars.Keys
        strKey = arrTemp(vntIndexKey)
    Else
        strKey = vntIndexKey
    End If
    If oVars.Exists(strKey) Then            ' Only read is allowed if called with no default value.
        Value = oVars.Item(strKey)
    Else
        Value = vbNullString
    End If
    Exit Property
ErrorH:
End Property

Public Property Let Value(vntIndexKey As Variant, vntValue As Variant)
On Error GoTo ErrorH
    Dim strKey As String
    Dim arrTemp As Variant

    If IsNumeric(vntIndexKey) Then          ' Access with key is faster than with index.
        arrTemp = oVars.Keys
        strKey = arrTemp(vntIndexKey)
        If oVars.Exists(strKey) Then oVars.Item(strKey) = CStr(vntValue)
    Else
        oVars.Item(CStr(vntIndexKey)) = CStr(vntValue)
    End If
    Exit Property
ErrorH:
End Property

Public Property Get Count() As Long
'// Returns the number of variables.
    On Error GoTo errHandler
    Count = oVars.Count
    Exit Property
errHandler:
    ErrorIn "Variables.Count"
End Property

Public Sub RemoveAll()
'// Removes all variables.
    On Error GoTo errHandler
    oVars.RemoveAll
    Exit Sub
errHandler:
    ErrorIn "Variables.RemoveAll"
End Sub

Public Function Keys() As Variant
'// Returns an array of variable names (keys)
    On Error GoTo errHandler
    Keys = oVars.Keys
    Exit Function
errHandler:
    ErrorIn "Variables.Keys"
End Function

Public Function Exists(vntIndexKey As Variant) As Boolean
'// Returns checks if the variable exists
    On Error GoTo errHandler
    Exists = oVars.Exists(vntIndexKey)
    Exit Function
errHandler:
    ErrorIn "Variables.Exists(vntIndexKey)", Array(vntIndexKey)
End Function


Public Function Items() As Variant
'// Returns an array of variable values.
    On Error GoTo errHandler
    Items = oVars.Items
    Exit Function
errHandler:
    ErrorIn "Variables.Items"
End Function

Private Sub Class_Initialize()
    On Error GoTo errHandler
    Set oVars = CreateObject("Scripting.Dictionary")
    oVars.CompareMode = 1 '1 = vbTextCompare, 0 = vbBinaryCompare
    Exit Sub
errHandler:
    ErrorIn "Variables.Class_Initialize"
End Sub
