VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Response"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Const GrowBy = 2048

Private sBuffer As String
Private lBufferLen As Long
Private sFilename As String

Private iSocketKey As Integer

Private oHeaders As New StringCollection 'local copy
Private sStatusLine As String 'local copy

Friend Property Let SocketKey(ByVal vData As Integer)
    iSocketKey = vData
End Property
Friend Property Get SocketKey() As Integer
    SocketKey = iSocketKey
End Property

Public Property Let Mimetype(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Mimetype = 5
    oHeaders.Item("Content-Type") = vData
End Property
Public Property Get Mimetype() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Mimetype
    Mimetype = oHeaders.Item("Content-Type")
End Property

Public Sub Redirect(ByVal sUrl As String)
    sStatusLine = "302 " & sUrl
    oHeaders.Item("Location") = sUrl
End Sub

Public Property Let StatusLine(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.StatusLine = 5
    sStatusLine = vData
End Property
Public Property Get StatusLine() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.StatusLine
    StatusLine = sStatusLine
End Property


Public Property Let Filename(ByVal vData As String)
    sFilename = vData
End Property
Public Property Get Filename() As String
    Filename = sFilename
End Property

Public Property Get Headers() As StringCollection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Headers
    Set Headers = oHeaders
End Property

Private Sub Class_Initialize()
    oHeaders.Item("Server") = "MonkeyWebServer0.1"
    oHeaders.Item("Date") = Date2string(GetGmtTime)
    oHeaders.Item("Expires") = Date2string(GetGmtTime)
    oHeaders.Item("Last-modified") = Date2string(GetGmtTime)
    oHeaders.Item("Content-Type") = "text/html"
End Sub

Public Sub Append(s As String)
    If Len(s) = 0 Then Exit Sub
    If Len(s) > Len(sBuffer) - lBufferLen Then
        sBuffer = sBuffer & Space(Len(s) + GrowBy)
    End If
    Mid(sBuffer, lBufferLen + 1, Len(s)) = s
    lBufferLen = lBufferLen + Len(s)
End Sub

Public Sub Flush()
    lBufferLen = 0
End Sub

Public Function GetContents() As String
    Dim sOut As String
    Dim l As Long
    Dim sKeys As Variant
    Dim sItems As Variant
    If sStatusLine="" Then
    	If lBufferLen=0 Then 
    	    sStatusLine="204 No Content"
        Else
    	    sStatusLine="200 OK"
        End If
    End If

    sOut = "HTTP/1.0 " & sStatusLine & vbCrLf
    'oHeaders.item("Content-Length") = lBufferLen
    If Headers.Count > 0 Then
        sKeys = Headers.Keys
        sItems = Headers.Items
        For l = 0 To UBound(sKeys)
            sOut = sOut & sKeys(l) & ":" & sItems(l) & vbCrLf
        Next
    End If
    sOut = sOut & vbCrLf & Left(sBuffer, lBufferLen)
    GetContents = sOut
    
End Function


