VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "HTTPRequestBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Const GrowBy = 2048

Private sBuffer As String
Private lBufferLen As Long
Private lEntityStartPos As Long
Private lHeaderStartPos As Long
Private oRequest As Request

Public Sub Add(s As String)
    If Len(s) > Len(sBuffer) - lBufferLen Then
        sBuffer = sBuffer & Space(Len(s) + GrowBy)
    End If
    Mid(sBuffer, lBufferLen + 1, Len(s)) = s
    lBufferLen = lBufferLen + Len(s)
End Sub

Private Sub Class_Initialize()
    lBufferLen = 0
    lEntityStartPos = -1
    sBuffer = ""
End Sub

Private Property Get EntityStartPos() As Long
    Dim lPos As Long
    If lEntityStartPos > 0 Then
        EntityStartPos = lEntityStartPos
        Exit Function
    End If
    lPos = InStrRev(sBuffer, vbCrLf & vbCrLf, lBufferLen)
    'the header block ends with 2 x crlf
    If lPos > 0 Then
        lEntityStartPos = lPos + 4
    End If
    EntityStartPos = lEntityStartPos
End Property

Private Property Get HeaderStartPos() As Long
    Dim lPos As Long
    If lHeaderStartPos > 0 Then
        HeaderStartPos = lHeaderStartPos
        Exit Property
    End If
    lPos = InStr(Mid(sBuffer, 1, lBufferLen), vbCrLf)
    'the header block starts on line 2
    If lPos > 0 Then
        lHeaderStartPos = lPos + 2
    End If
    HeaderStartPos = lHeaderStartPos
End Property

Public Property Get URL() As String
    Dim sTemp() As String
    'only valid when iscomplete
    sTemp = Split(Left(sBuffer, HeaderStartPos), " ", 3)
    URL = sTemp(1)
End Property

Public Property Get Header() As String
    'only valid when iscomplete
    Header = Mid(sBuffer, HeaderStartPos, EntityStartPos - HeaderStartPos - 4)
End Property

Public Property Get EntityBody() As String
    'only valid when iscomplete
    EntityBody = Mid(sBuffer, EntityStartPos)
End Property

Public Function IsComplete() As Boolean
    Dim lCLen As Long
    If EntityStartPos < 1 Then
        IsComplete = False
        Exit Function
    End If
    If oRequest Is Nothing Then
        Set oRequest = New Request
        oRequest.ParseURL URL
        oRequest.ParseHeader Header
    End If
    If oRequest.Headers("Content-Length") = "" Then
        IsComplete = True
        Exit Function
    End If
    lCLen = CLng(oRequest.Headers("Content-Length"))
    If lBufferLen - EntityStartPos < lCLen - 1 Then
        IsComplete = False
        Exit Function
    End If
    oRequest.ParseParams EntityBody
    IsComplete = True
End Function

Public Property Get RequestObject() As Request
    Set RequestObject = oRequest
End Property


