VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.UserControl WebServer 
   BackColor       =   &H00FF8080&
   CanGetFocus     =   0   'False
   ClientHeight    =   705
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   645
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   705
   ScaleWidth      =   645
   Begin MSWinsockLib.Winsock Sockets 
      Index           =   0
      Left            =   120
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      LocalPort       =   80
   End
End
Attribute VB_Name = "WebServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' http://www.w3.org/Protocols/rfc1945/rfc1945

Public Event DataArrival(s As String)
Public Event RequestDocument(oRequest As Request, oResponse As Response)

Public oBuffers As New Collection
Private sAcceptIPs As String


Public Property Get State() As StateConstants
    State = Sockets(0).State
End Property


Public Property Let AcceptIPs(sIPPattern As String)
    sAcceptIPs = sIPPattern
    If Len(sIPPattern) > 0 Then
        If Right(sAcceptIPs, 1) <> "." Then sAcceptIPs = sAcceptIPs & "."
    End If
End Property

Public Property Get AcceptIPs() As String
    If Len(sAcceptIPs) > 0 Then
        AcceptIPs = Left(sAcceptIPs, Len(sAcceptIPs) - 1)
    Else
        AcceptIPs = ""
    End If
End Property

Private Function IsSocketLoaded(lIdx As Integer) As Boolean
    Dim dummy As Integer
    On Error Resume Next
    dummy = Sockets.Item(lIdx).Index
    IsSocketLoaded = (Err.Number = 0)
End Function

Private Function FindFreeSocket() As Long
    Dim l As Integer
    'this might seem slow but not if there is few connections at the server.
    If Sockets.Count > Sockets.UBound Then
        FindFreeSocket = Sockets.UBound + 1
        Exit Function
    End If
    For l = 1 To Sockets.UBound
        If Not IsSocketLoaded(l) Then
            FindFreeSocket = l 'this way we keep the connections concentrated at the bottom.
            Exit Function
        End If
    Next
End Function

Private Sub Sockets_Close(Index As Integer)
    If Index > 0 Then
        Unload Sockets(Index)
        oBuffers.Remove "Sck" & Index
    End If
End Sub

Public Sub StopServer()
    Dim lng As Long
    On Error Resume Next
    Sockets(0).Close
    For lng = 1 To Sockets.UBound
        Sockets(lng).Close
        Unload Sockets.Item(lng)
        oBuffers.Remove "Sck" & lng
    Next
End Sub

Public Sub StartServer()
    Sockets(0).Close
    Sockets(0).Listen
End Sub

Private Sub Sockets_ConnectionRequest(Index As Integer, ByVal requestID As Long)
    Dim lNewSock As Long
    If Len(AcceptIPs) > 0 Then
        If Left(Sockets(0).RemoteHostIP & ".", Len(sAcceptIPs)) <> sAcceptIPs Then
            Sockets(0).Close
            Exit Sub
        End If
    End If
    lNewSock = FindFreeSocket
    Load Sockets(lNewSock)
    Sockets(lNewSock).LocalPort = 0
    Sockets(lNewSock).Accept requestID
    oBuffers.Add New HTTPRequestBuffer, "Sck" & lNewSock
    'Debug.Print lNewSock
End Sub

Private Sub Sockets_DataArrival(Index As Integer, ByVal bytesTotal As Long)
    Dim s As String
    Dim oBuffer As HTTPRequestBuffer
    Dim oResponse As Response
    Set oBuffer = oBuffers.Item("Sck" & Index)
    Sockets(Index).GetData s
    oBuffer.Add s
    If oBuffer.IsComplete Then
        Set oResponse = New Response
        oResponse.SocketKey = Index
        RaiseEvent RequestDocument(oBuffer.RequestObject, oResponse)
    End If
End Sub

Public Sub Reply(oResponse As Response)
    Dim Index As Integer
    Dim lContentLength As Long
    Dim iFile As Integer
    Dim sFile As String
    Dim bBuffer() As Byte
    Index = oResponse.SocketKey
    If Not IsSocketLoaded(Index) Then Exit Sub
    If oResponse.Filename = "" Then
        Sockets.Item(Index).SendData oResponse.GetContents
    Else 'SEND THE FILE
        oResponse.Flush 'only send the file+the headers
        sFile = Dir(oResponse.Filename)
        If sFile = "" Then
            lContentLength = 0
            oResponse.StatusLine = "404 " & oResponse.Filename & " Not found"
        Else
            iFile = FreeFile
            Open oResponse.Filename For Binary Access Read As iFile Len = 1
            lContentLength = LOF(iFile)
            If lContentLength > 0 Then
                ReDim bBuffer(lContentLength - 1)
                Get #iFile, , bBuffer
                oResponse.StatusLine = "200 OK" 'to avoid it being set to "204 no content" in response.getcontents.
            End If
            Close iFile
        End If
        'oResponse.Headers("Content-Length") = lContentLength
        Sockets.Item(Index).SendData oResponse.GetContents
        If lContentLength > 0 Then
            Sockets.Item(Index).SendData bBuffer
        End If
    End If
    Sockets.Item(Index).Tag = "Unload me"
End Sub

Private Sub Sockets_SendComplete(Index As Integer)
    If Sockets.Item(Index).Tag = "Unload me" Then
        Sockets.Item(Index).Close
        Unload Sockets.Item(Index)
        oBuffers.Remove "Sck" & Index
    End If
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Sockets(0),Sockets,0,LocalPort
Public Property Get LocalPort() As Long
Attribute LocalPort.VB_Description = "Returns/Sets the port used on the local computer"
    LocalPort = Sockets(0).LocalPort
End Property

Public Property Let LocalPort(ByVal New_LocalPort As Long)
    Sockets(0).LocalPort() = New_LocalPort
    PropertyChanged "LocalPort"
End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    
    Sockets(0).LocalPort = PropBag.ReadProperty("LocalPort", 80)
    sAcceptIPs = PropBag.ReadProperty("AcceptIPs", "")

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("LocalPort", Sockets(0).LocalPort, 80)
    Call PropBag.WriteProperty("LocalPort", sAcceptIPs, "")
End Sub

