VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUserSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private bMergeMode As Boolean

Private objXMLDoc As New DOMDocument
Private intVersion As Integer

Public Function LoadAppSettings(objApp As frmMain) As Boolean
    Dim objDoc As New DOMDocument
    Dim objTemp As IXMLDOMElement, objNode As IXMLDOMNode, objPos As IXMLDOMNode
    Dim varTemp As Variant

    objDoc.Load App.Path & "/mtsettings.xml"
        
    If Trim(objDoc.parseError.reason) = "" Then
        Set objPos = objDoc.selectSingleNode("ApplicationSettings")
        
        Set objNode = objPos.selectSingleNode("Webserver")
        If Not (objNode Is Nothing) Then
            varTemp = ReadAttributes(objNode, "port")
            If varTemp <> "" Then objApp.WebServer.LocalPort = varTemp
            varTemp = ReadAttributes(objNode, "autostart")
            If varTemp <> "" Then objApp.AutoStartWebServer = String2Bool(CStr(varTemp))
        End If
        
        Set objNode = objPos.selectSingleNode("Window")
        If Not (objNode Is Nothing) Then
            varTemp = ReadAttributes(objNode, "Left")
            If varTemp <> "" Then objApp.Left = varTemp
            varTemp = ReadAttributes(objNode, "Top")
            If varTemp <> "" Then objApp.Top = varTemp
            varTemp = ReadAttributes(objNode, "Width")
            If varTemp <> "" Then objApp.Width = varTemp
            varTemp = ReadAttributes(objNode, "Height")
            If varTemp <> "" Then objApp.Height = varTemp
            varTemp = ReadAttributes(objNode, "WindowState")
            If varTemp <> "" Then objApp.WindowState = varTemp
        End If
        
        Set objNode = objPos.selectSingleNode("Settings")
        If Not (objNode Is Nothing) Then
            varTemp = ReadAttributes(objNode, "SaveOnExit")
            If varTemp <> "" Then objApp.gSaveOnExit = String2Bool(CStr(varTemp))
            varTemp = ReadAttributes(objNode, "OpenConnDialogOnLoad")
            If varTemp <> "" Then objApp.OpenConnDialogOnLoad = String2Bool(CStr(varTemp))
'            varTemp = ReadAttributes(objNode, "SaveOnExit")
'            If varTemp <> "" Then objApp.gSaveOnExit = String2Bool(CStr(varTemp))
            Set objTemp = objNode.selectSingleNode("HelpFile")
            If Not (objTemp Is Nothing) Then
                varTemp = objTemp.nodeValue & ""
                If varTemp <> "" Then App.HelpFile = varTemp
            End If
            varTemp = ReadAttributes(objNode, "TipOfTheDay")
            If varTemp <> "" Then
                TipOfTheDay = String2Bool(CStr(varTemp))
            Else
                TipOfTheDay = True
            End If
        End If
        
        'Dim strFileName As String, strSessionName As String
        For Each objNode In objPos.selectNodes("RecentList/Connection")
            If Not ((objNode.selectSingleNode("FileName") Is Nothing) Or _
            (objNode.selectSingleNode("SessionName") Is Nothing)) Then
                RecentFiles.Add objNode.selectSingleNode("FileName").Text, _
                objNode.selectSingleNode("SessionName").Text
            End If
        Next
    Else
        LoadAppSettings = False
    End If
    Exit Function
End Function

Public Function SaveAppSettings(objApp As frmMain) As Boolean
    On Error GoTo errHandler
    Dim objSubNode As IXMLDOMElement, objNode As IXMLDOMElement, objPos As IXMLDOMNode
    Dim objTemp As IXMLDOMElement
    Dim objAttrib As IXMLDOMAttribute
    Dim objDoc As New DOMDocument, objOldDoc As New DOMDocument
    Dim lfreefile As Integer
    Dim intLoop As Integer
    Dim strOutput As String
    
' *** Load the settings, if present.
    objOldDoc.Load App.Path & "/mtsettings.xml"

' *** Set root node.
    Set objPos = objDoc.createElement("ApplicationSettings")
    objDoc.appendChild objPos

' *** Webserver
    Set objNode = objPos.appendChild(objDoc.createElement("Webserver"))
    objNode.setAttribute "port", objApp.WebServer.LocalPort
    objNode.setAttribute "autostart", Bool2String(objApp.AutoStartWebServer)
    
' *** Application Window
    If (objApp.WindowState = vbMinimized) Then
        Set objTemp = objOldDoc.selectSingleNode("/ApplicationSettings/Window")
        If (Not objTemp Is Nothing) Then objPos.appendChild objTemp
    Else
        Set objNode = objPos.appendChild(objDoc.createElement("Window"))
        objNode.setAttribute "Left", objApp.Left
        objNode.setAttribute "Top", objApp.Top
        objNode.setAttribute "Width", objApp.Width
        objNode.setAttribute "Height", objApp.Height
        objNode.setAttribute "WindowState", objApp.WindowState
    End If
    
' *** Misc Settings
    Set objNode = objPos.appendChild(objDoc.createElement("Settings"))
    objNode.setAttribute "SaveOnExit", Bool2String(objApp.gSaveOnExit)
    objNode.setAttribute "TipOfTheDay", Bool2String(TipOfTheDay)
    objNode.setAttribute "OpenConnDialogOnLoad", Bool2String(objApp.OpenConnDialogOnLoad)
    objNode.setAttribute "Version", App.Major & "." & App.Minor & "." & App.Revision
    Set objNode = objPos.appendChild(objDoc.createElement("HelpFile"))
    objNode.appendChild objDoc.createCDATASection(App.HelpFile)

' *** Recent List
    Set objNode = objPos.appendChild(objDoc.createElement("RecentList"))
    For intLoop = 0 To RecentFiles.Count - 1
        Set objSubNode = objNode.appendChild(objDoc.createElement("Connection"))
        Set objTemp = objSubNode.appendChild(objDoc.createElement("FileName"))
        objTemp.appendChild objDoc.createCDATASection(RecentFiles.ItemFileName(intLoop))
        Set objTemp = objSubNode.appendChild(objDoc.createElement("SessionName"))
        objTemp.appendChild objDoc.createCDATASection(RecentFiles.ItemSessionName(intLoop))
    Next
        
    strOutput = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCrLf & PrettyPrint(objDoc.childNodes)
    
    lfreefile = FreeFile
    Open App.Path & "/mtsettings.xml" For Output As #lfreefile
    Print #lfreefile, strOutput
    Close #lfreefile
    SaveAppSettings = True
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.SaveAppSettings(objApp)", objApp
End Function

Public Function Save(strFileName As String, objSession As frmSession) As Boolean
'// Saves the session specific settings to an XML file. Returns True on success, otherwise false.
'// Raises event OnSave(strFileName, Status) on completion.
    On Error GoTo errHandler
    Dim objNode As IXMLDOMElement, objPos As IXMLDOMNode
    Dim objAttrib As IXMLDOMAttribute
    Dim strOutput As String
    Dim lfreefile As Integer
    Dim objTemp As Object
    Dim varName As Variant
    
    Dim intLoop As Integer, intKeyCode As Integer, intShift As Integer
    Dim strName As String, strCommand As String, strPattern As String, strLocation As String, strValue As String
    Dim blnEnabled As Boolean, blnLineStart As Boolean
    Dim blnCase As Boolean
    
    objXMLDoc.preserveWhiteSpace = True

' *** Set root node.
    Set objNode = objXMLDoc.createElement("savefile")
    objNode.setAttribute "version", "2"
    Set objPos = objXMLDoc.appendChild(objNode)
    
' *** Save Aliases
    Set objNode = objPos.appendChild(objXMLDoc.createElement("aliases"))
    For intLoop = 0 To objSession.Aliases.Count - 1
        objNode.appendChild MakeColItem(objSession.Aliases.Item(intLoop))
    Next
    
' *** Save Actions
    Set objNode = objPos.appendChild(objXMLDoc.createElement("actions"))
    For intLoop = 0 To objSession.Actions.Count - 1
        objNode.appendChild MakeColItem(objSession.Actions.Item(intLoop))
    Next
    
' *** Save Substitutes
    Set objNode = objPos.appendChild(objXMLDoc.createElement("substitutes"))
    For intLoop = 0 To objSession.Substitutes.Count - 1
        objNode.appendChild MakeColItem(objSession.Substitutes.Item(intLoop))
    Next
    
' *** Save Scripts
    Set objNode = objPos.appendChild(objXMLDoc.createElement("scripts"))
    For intLoop = 0 To objSession.CmdHandler.Script.Scripts.Count - 1
        strName = objSession.CmdHandler.Script.Scripts.ItemName(intLoop)
        strLocation = objSession.CmdHandler.Script.Scripts.ItemFileName(intLoop)
        blnEnabled = objSession.CmdHandler.Script.Scripts.ItemEnabled(intLoop)
        objNode.appendChild MakeScript(intLoop, strName, strLocation, blnEnabled)
    Next

' *** Save Keybindings
    Set objNode = objPos.appendChild(objXMLDoc.createElement("keybindings"))
    For intLoop = 1 To objSession.KeyBindings.Count
        objNode.appendChild MakeKeyBinding(objSession.KeyBindings(intLoop))
    Next
    
' *** Save Variables
    Set objNode = objPos.appendChild(objXMLDoc.createElement("variables"))
    For Each varName In objSession.Variables.Keys
        strName = CStr(varName)
        strValue = objSession.Variables.Value(strName)
        objNode.appendChild MakeVariable(strName, strValue)
    Next
    
' ** Save Events
    Set objNode = objPos.appendChild(objXMLDoc.createElement("events"))
    For intLoop = 1 To objSession.Events.Count
        objNode.appendChild MakeEvent(objSession.Events(intLoop))
    Next
    
' *** Save Colors
    Set objTemp = objXMLDoc.createElement("colors")
    objTemp.setAttribute "default", objSession.Protocol.DefaultColor
    Set objNode = objPos.appendChild(objTemp)
    For intLoop = 0 To 15
        objNode.appendChild MakeColor(intLoop, objSession.Terminal.Color(intLoop))
    Next
    
' *** Save Terminal Options
    Set objNode = objPos.appendChild(objXMLDoc.createElement("terminal"))
    Set objTemp = objXMLDoc.createElement("chatwindow")
    objTemp.setAttribute "bgcolor", Right("00000" & Hex(objSession.CmdBox.BackColor), 6)
    objTemp.setAttribute "fgcolor", Right("00000" & Hex(objSession.CmdBox.ForeColor), 6)
    objTemp.setAttribute "height", objSession.CmdBox.Height
    objNode.appendChild objTemp
    Set objTemp = objXMLDoc.createElement("font")
    objTemp.setAttribute "name", objSession.Terminal.FontName
    objTemp.setAttribute "size", objSession.Terminal.FontSize
    objTemp.setAttribute "bold", Bool2String(objSession.FontBold)
    objNode.appendChild objTemp
    Set objTemp = objXMLDoc.createElement("ANSILogging")
    objTemp.setAttribute "enabled", Bool2String(objSession.Protocol.IsLogging(WithANSI:=True))
    objTemp.setAttribute "filename", objSession.ANSIFilename
    objNode.appendChild objTemp
    Set objTemp = objXMLDoc.createElement("TXTLogging")
    objTemp.setAttribute "enabled", Bool2String(objSession.Protocol.IsLogging(WithANSI:=False))
    objTemp.setAttribute "filename", objSession.TXTFilename
    objNode.appendChild objTemp
    
' *** Save Web Options
    'Set objNode = objPos.appendChild(objXMLDoc.createElement("web"))
    'Set objTemp = objXMLDoc.createElement("server")
    'objTemp.setAttribute "port",
    'Set objTemp = objXMLDoc.createElement("browser")
    'objTemp.setAttribute "enabled", objSession.Web.Browser.Visible
    'objTemp.setAttribute "width", objSession.Web.Browser.Width
    'objNode.appendChild objTemp
    
' *** Save Options
    Set objNode = objPos.appendChild(objXMLDoc.createElement("options"))
    objNode.appendChild MakeOption("JumpOnKeyPressed", Bool2String(objSession.JumpOnKeyPressed))
    objNode.appendChild MakeOption("JumpOnOutput", Bool2String(objSession.JumpOnOutput))
    objNode.appendChild MakeOption("TabWidth", objSession.Protocol.TabWidth)
    objNode.appendChild MakeOption("GagOutput", Bool2String(objSession.Actions.GagOutput))
    objNode.appendChild MakeOption("KeepCommand", Bool2String(objSession.KeepCommand))
    objNode.appendChild MakeConnection(objSession.SessionName, objSession.Host, objSession.Port)
    'objNode.appendChild MakeOption("StartSeverOnLoad", Bool2String(
    'Set objTemp = MakeOption("WalkLetters", objSession.CmdHandler.WalkLetters)
    'objTemp.setAttribute "enabled", Bool2String(objSession.CmdHandler.WalkLettersEnabled)
    'objNode.appendChild objTemp
    
    strOutput = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & vbCrLf & PrettyPrint(objXMLDoc.childNodes)
    
    lfreefile = FreeFile
    Open strFileName For Output As #lfreefile
    Print #lfreefile, strOutput
    Close #lfreefile
    
    Save = True
    objSession.Events.FireEvent EventType:=etOnSave, ParamValues:=Array(strFileName, 0)
    Exit Function
    
errHandler:
    ErrorIn "clsUserSettings.Save(strFileName,objSession)", Array(strFileName, objSession)
    Save = False
    objSession.Events.FireEvent EventType:=etOnSave, ParamValues:=Array(strFileName, -1)
End Function

'Friend Function Parse_Save() As Boolean
'
'End Function



Friend Function Parse_Load(objPos As IXMLDOMNode, objSession As frmSession) As Boolean
    On Error GoTo errHandler
    Dim objNode As IXMLDOMNode

    If Trim(objXMLDoc.parseError.reason) = "" Then
        
        ' Load linked templates.
        For Each objNode In objPos.selectNodes("includes")
            'LoadTemplate objNode.selectNodes("include"), objSession
        Next

        ' Load Aliases
        For Each objNode In objPos.selectNodes("aliases")
            LoadColItems objNode.selectNodes("alias"), objSession.Aliases
        Next

        ' Load Actions.
        For Each objNode In objPos.selectNodes("actions")
            LoadColItems objNode.selectNodes("action"), objSession.Actions
        Next

        ' Load Substitutes
        For Each objNode In objPos.selectNodes("substitutes")
            LoadColItems objNode.selectNodes("substitute"), objSession.Substitutes
        Next

        ' Load Scripts. Priority not implemented, first read - highest priority.
        For Each objNode In objPos.selectNodes("scripts")
            LoadScripts objNode, objSession.CmdHandler.Script.Scripts
        Next
        objSession.CmdHandler.Script.ApplyChanges
        
        ' Load Keybindings.
        For Each objNode In objPos.selectNodes("keybindings")
            LoadKeybindings objNode, objSession.KeyBindings
        Next
        
        ' Load Variables.
        For Each objNode In objPos.selectNodes("variables")
            LoadVariables objNode, objSession.Variables
        Next
        
        ' Load Events.
        For Each objNode In objPos.selectNodes("events")
            LoadEvents objNode, objSession.Events
        Next
        
        ' Load Options. Only one options tag allowed
        LoadOptions objPos.selectSingleNode("options"), objSession
        
        ' Load Colors.
        LoadColors objPos.selectSingleNode("colors"), objSession
        
        LoadTerminal objPos.selectSingleNode("terminal"), objSession
    Else
        Parse_Load = False
        Err.Raise LoadSave_ErrorLoading, TypeName(Me), "XML Parse error." & vbCrLf & "Line " & objXMLDoc.parseError.Line & ": " & objXMLDoc.parseError.reason
    End If
    Parse_Load = True
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.Parse_Load(objSession)", objSession
End Function

Public Function CheckVersion(strFileName As String) As Integer
'// Checks to see what version the savefile is.
    On Error GoTo errHandler
    Dim varTemp As Variant
    objXMLDoc.Load strFileName
    If Trim(objXMLDoc.parseError.reason) = "" Then
        varTemp = ReadAttributes(objXMLDoc.selectSingleNode("savefile"), "version")
        If Not IsNumeric(varTemp) Then varTemp = 0
    Else
        varTemp = 0
    End If
    CheckVersion = varTemp
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.CheckVersion(strFileName)", strFileName
End Function

Public Function Load(strFileName As String, objSession As frmSession, Optional bImportMerge As Boolean = False) As Boolean
'// Load the session specific settings from an XML file. Returns True on success, otherwise False.
'// Raises event OnLoad(strFileName, Status) on completion.
    On Error GoTo errHandler
    Dim objNode As IXMLDOMNode
    Dim objPos As IXMLDOMNode
    Dim varTemp As Variant
    
    bMergeMode = bImportMerge

    objXMLDoc.Load strFileName
        
    If Trim(objXMLDoc.parseError.reason) = "" Then
        Set objPos = objXMLDoc.selectSingleNode("savefile")
        ' Read Version.
        varTemp = ReadAttributes(objPos, "version")
        If IsNumeric(varTemp) Then intVersion = varTemp
    
        Load = Parse_Load(objPos, objSession)
        If Not bMergeMode Then
            If Load Then
                objSession.Events.FireEvent EventType:=etOnLoad, ParamValues:=Array(strFileName, 0)
            Else
                objSession.Events.FireEvent EventType:=etOnLoad, ParamValues:=Array(strFileName, -1)
            End If
        End If
    Else
        Load = False
    End If
    Exit Function
    
errHandler:
    ErrorIn "clsUserSettings.Load(strFileName,objSession)", Array(strFileName, objSession)
    Load = False
    objSession.Events.FireEvent EventType:=etOnLoad, ParamValues:=Array(strFileName, -1)
End Function

Private Function GetTemplatePath(objSourceNode As IXMLDOMNode)
    If (objSourceNode Is Nothing) Then Exit Function
    
    GetTemplatePath = ReadAttributes(objSourceNode, "name")
End Function

Private Sub LoadTerminal(objSourceNode As IXMLDOMNode, objTarget As frmSession)
On Error Resume Next
    Dim strFontName As String, intSize As Integer, blnBold As Boolean
    Dim strFileName As String, blnEnabled As Boolean
    Dim objNode As IXMLDOMNode
    
    If Not bMergeMode Then
        
        If (objSourceNode Is Nothing) Then Exit Sub
        Set objNode = objSourceNode.selectSingleNode("font")
        If Not (objNode Is Nothing) Then
            strFontName = ReadAttributes(objNode, "name")
            intSize = ReadAttributes(objNode, "size")
            blnBold = String2Bool(ReadAttributes(objNode, "bold"))
            objTarget.Terminal.SetFont strFontName, intSize, blnBold
        End If
        
        Set objNode = objSourceNode.selectSingleNode("chatwindow")
        If Not (objNode Is Nothing) Then
            objTarget.CmdBox.BackColor = CLng("&H" & ReadAttributes(objNode, "bgcolor"))
            objTarget.CmdBox.ForeColor = CLng("&H" & ReadAttributes(objNode, "fgcolor"))
            objTarget.CmdBox.Height = ReadAttributes(objNode, "height")
            objTarget.UpdateLayout
        End If
    
        Set objNode = objSourceNode.selectSingleNode("ANSILogging")
        If Not (objNode Is Nothing) Then
            strFileName = ReadAttributes(objNode, "filename")
            blnEnabled = String2Bool(ReadAttributes(objNode, "enabled"))
            objTarget.Protocol.SetLogInfo FileName:=strFileName, StartLog:=blnEnabled, WithANSI:=True
        End If
        
        Set objNode = objSourceNode.selectSingleNode("TXTLogging")
        If Not (objNode Is Nothing) Then
            strFileName = ReadAttributes(objNode, "filename")
            blnEnabled = String2Bool(ReadAttributes(objNode, "enabled"))
            objTarget.Protocol.SetLogInfo FileName:=strFileName, StartLog:=blnEnabled, WithANSI:=False
        End If
    
    End If
End Sub

Private Sub LoadColItems(objSourceNodes As IXMLDOMNodeList, objTarget As Object)
    On Error GoTo errHandler
    Dim objNode As IXMLDOMNode
    Dim strName As String, strFormat As String, blnEnabled As Boolean
    Dim strPattern As String, strCommand As String, bCaseSensitive As Boolean
    Dim bSimple As Boolean
    Dim lColIndex As Long
    Dim objPatternNode As IXMLDOMNode, objCommandNode As IXMLDOMNode
    
    For Each objNode In objSourceNodes
        strName = ReadAttributes(objNode, "name")
        Set objPatternNode = objNode.selectSingleNode("pattern")
        Set objCommandNode = objNode.selectSingleNode("command")
        If (objCommandNode Is Nothing) And (intVersion < 2) Then    ' Old format
            Set objCommandNode = objNode.selectSingleNode("event")
        End If
        blnEnabled = String2Bool(ReadAttributes(objPatternNode, "enabled"))
        strFormat = ReadAttributes(objCommandNode, "format")
        strCommand = objCommandNode.Text
        strPattern = objPatternNode.Text
        If String2Bool(ReadAttributes(objPatternNode, "case")) Then bCaseSensitive = True Else bCaseSensitive = False
        If UCase(strFormat) <> "STRICT" Then strCommand = ClearCommand(strCommand)
        If UCase(ReadAttributes(objPatternNode, "format")) <> "STRICT" Then strPattern = ClearCommand(strPattern)
        If strName = "" Then
            'old format
            strName = strPattern
        End If
        bSimple = ReadAttributes(objPatternNode, "simple") <> "no"
        
        lColIndex = objTarget.GetIndex(strName)
        
        If lColIndex > -1 Then
            If MsgBox("A " & Replace(LCase(TypeName(objTarget)), "collection", "") & " with the name " & strName & " already exists in this session." & vbCrLf & vbCrLf & _
                "Do you want to overwrite with the new value?", vbQuestion + vbYesNo + vbDefaultButton2, "MonkeyTerm") = vbYes Then
                objTarget.Add strName, strPattern, strCommand, bCaseSensitive, blnEnabled, bSimple
            End If
        Else
            objTarget.Add strName, strPattern, strCommand, bCaseSensitive, blnEnabled, bSimple
        End If
    Next
    Exit Sub
errHandler:
    ErrorIn "clsUserSettings.LoadColItems(objSourceNodes,objTarget)", Array(objSourceNodes, _
         objTarget)
End Sub

Private Sub LoadScripts(objSourceNode As IXMLDOMNode, objTarget As ScriptCollection)
On Error Resume Next
    Dim strName As String, strFileName As String
    Dim blnEnabled As Boolean, intPriority As Integer
    Dim lScriptIdx As Long
    Dim objNode As IXMLDOMNode

    For Each objNode In objSourceNode.selectNodes("file")
        strName = ReadAttributes(objNode, "name")
        strFileName = ReadAttributes(objNode, "location")
        blnEnabled = String2Bool(ReadAttributes(objNode, "enabled"))
        'intPriority = ReadAttributes(objNode, "priority") Later...
        lScriptIdx = objTarget.GetIndex(strName)
        If lScriptIdx < 0 Then
            objTarget.Add strName, strFileName, blnEnabled
        Else
            If MsgBox("A script with the name " & strName & " already exists in this session." & vbCrLf & vbCrLf & _
                "Do you want to overwrite with the new value?", vbQuestion + vbYesNo + vbDefaultButton2, "MonkeyTerm") = vbYes Then
            'TODO: check that there isn't any files with the same name
                objTarget.Add strName, strFileName, blnEnabled
            End If
        End If
    Next
End Sub

Private Sub LoadVariables(objSourceNode As IXMLDOMNode, objTarget As Variables)
On Error Resume Next
    Dim strName As String, strValue As String
    Dim objNode As IXMLDOMNode
    For Each objNode In objSourceNode.selectNodes("variable")
        strName = ReadAttributes(objNode, "name")
        strValue = objNode.Text
        If objTarget.Exists(strName) Then
            If MsgBox("Variable " & strName & " already exists in this session." & vbCrLf & vbCrLf & _
                "Do you want to overwrite with the new value?", vbQuestion + vbYesNo + vbDefaultButton2, "MonkeyTerm") = vbYes Then
            End If
        Else
            objTarget.Add strName, strValue
        End If
    Next
End Sub

Private Sub LoadEvents(objSourceNode As IXMLDOMNode, objTarget As EventCollection)
On Error Resume Next
    Dim strName As String, strCommand As String, uType As eEventType, blnEnabled As Boolean
    Dim objNode As IXMLDOMNode
    Dim lColIdx As Long
    Dim objData As Collection

    For Each objNode In objSourceNode.selectNodes("event")
        strName = ReadAttributes(objNode, "name")
        uType = EventTypeValue(ReadAttributes(objNode, "type"))
        blnEnabled = String2Bool(ReadAttributes(objNode, "enabled"))
        strCommand = objNode.selectSingleNode("command").Text
        
        Set objData = New Collection
        Select Case uType
            Case etTimer
                objData.Add objNode.selectSingleNode("property[@name='interval']").Text, "Interval"
                objData.Add String2Bool(objNode.selectSingleNode("property[@name='fireonce']").Text), "FireOnce"
            Case etWeb
                objData.Add objNode.selectSingleNode("property[@name='pattern']").Text, "Pattern"
        End Select
        
        If objData.Count = 0 Then Set objData = Nothing
        
        lColIdx = objTarget.GetIndex(strName)
        
        If lColIdx > -1 Then
            If MsgBox("An event with the name " & strName & " already exists in this session." & vbCrLf & vbCrLf & _
                "Do you want to overwrite with the new event?", vbQuestion + vbYesNo + vbDefaultButton2, "MonkeyTerm") = vbYes Then
                objTarget.Add uType, strName, ConvertToCRLF(strCommand), objData, blnEnabled
            End If
        Else
            objTarget.Add uType, strName, ConvertToCRLF(strCommand), objData, blnEnabled
        End If
    Next
End Sub

Private Sub LoadKeybindings(objSourceNode As IXMLDOMNode, objTarget As KeyBindingCollection)
    On Error Resume Next
    Dim objNode As IXMLDOMNode
    Dim strKeys As String, strCommand As String
    Dim intShift As Integer, intKeyCode As Integer, blnEnabled As Boolean
    Dim lColIdx As Long
    Dim objReg As RegExp, objMatches As MatchCollection, blnFound As Boolean
    
    For Each objNode In objSourceNode.selectNodes("keybind")
    
        If String2Bool(ReadAttributes(objNode, "shift")) Then intShift = 1 Else intShift = 0
        If String2Bool(ReadAttributes(objNode, "ctrl")) Then intShift = intShift + 2
        If String2Bool(ReadAttributes(objNode, "alt")) Then intShift = intShift + 4
        blnEnabled = String2Bool(ReadAttributes(objNode, "enabled"))
    
        strKeys = Trim(ReadAttributes(objNode, "key"))
        
        blnFound = False
        Set objReg = New RegExp
        objReg.MultiLine = False
        objReg.Global = False
        objReg.Pattern = "\[(\+|\-|\*|\/)\]"
        Set objMatches = objReg.Execute(strKeys)
        If objMatches.Count = 1 Then
            Select Case objMatches(0)
                Case "[+]": intKeyCode = vbKeyAdd
                Case "[-]": intKeyCode = vbKeySubtract
                Case "[*]": intKeyCode = vbKeyMultiply
                Case "[/]": intKeyCode = vbKeyDivide
                Case Else: Exit Sub
            End Select
            blnFound = True
        End If
        
        If Not blnFound Then
            objReg.Pattern = "F(\d+)"
            Set objMatches = objReg.Execute(strKeys)
            If objMatches.Count = 1 Then
                intKeyCode = CInt(objMatches(0).SubMatches(0)) + vbKeyF1 - 1
                blnFound = True
            End If
        End If
        
        If Not blnFound Then
            objReg.Pattern = "\[(\d+)\]"
            Set objMatches = objReg.Execute(strKeys)
            If objMatches.Count = 1 Then
                intKeyCode = CInt(objMatches(0).SubMatches(0))
                blnFound = True
            End If
        End If

        If Not blnFound Then
            objReg.Pattern = "^[a-zA-Z\.\,]$"
            Set objMatches = objReg.Execute(strKeys)
            If objMatches.Count = 1 Then
                intKeyCode = Asc(UCase(objMatches(0).Value))
                blnFound = True
            End If
        End If

        If Not blnFound Then
            objReg.Pattern = "Numpad\s*(\d)"
            Set objMatches = objReg.Execute(strKeys)
            If objMatches.Count = 1 Then
                intKeyCode = vbKeyNumpad0 + objMatches(0).SubMatches(0)
                blnFound = True
            End If
        End If
        
        If Not blnFound Then
            Select Case LCase(strKeys)
                Case "scroll lock": intKeyCode = vbKeyScrollLock
                Case "pause": intKeyCode = vbKeyPause
                Case "escape": intKeyCode = vbKeyEscape
                Case "up": intKeyCode = vbKeyUp
                Case "down": intKeyCode = vbKeyDown
                Case "left": intKeyCode = vbKeyLeft
                Case "right": intKeyCode = vbKeyRight
                Case "insert": intKeyCode = vbKeyInsert
                Case "delete": intKeyCode = vbKeyDelete
                Case "home": intKeyCode = vbKeyHome
                Case "end": intKeyCode = vbKeyEnd
                Case "pageup": intKeyCode = vbKeyPageUp
                Case "pagedown": intKeyCode = vbKeyPageDown
                Case Else: blnFound = True
            End Select
            blnFound = Not blnFound
        End If
        
        strCommand = objNode.Text
        
        If blnFound Then
            lColIdx = objTarget.GetIndex(intKeyCode, intShift)
            If lColIdx > -1 Then
                If MsgBox("A keybinding for " & strKeys & " already exists in this session." & vbCrLf & vbCrLf & _
                    "Do you want to overwrite with the new keybinding?", vbQuestion + vbYesNo + vbDefaultButton2, "MonkeyTerm") = vbYes Then
                    objTarget.Add intKeyCode, intShift, strCommand, blnEnabled
                End If
            Else
                objTarget.Add intKeyCode, intShift, strCommand, blnEnabled
            End If
        End If
        
    Next
End Sub

Private Sub LoadOptions(objSourceNode As IXMLDOMNode, objTarget As frmSession)
On Error Resume Next
    Dim strTemp As String
    'strTemp = ReadAttributes(objSourceNode.selectSingleNode("WalkLetters"), "value")
    'If strTemp <> "" Then objTarget.CmdHandler.WalkLetters = strTemp
    'strTemp = ReadAttributes(objSourceNode.selectSingleNode("WalkLetters"), "enabled")
    'If (strTemp = "") Or String2Bool(strTemp) Then objTarget.CmdHandler.WalkLettersEnabled = True Else objTarget.CmdHandler.WalkLettersEnabled = False
    
    If Not bMergeMode Then
        
        strTemp = ReadAttributes(objSourceNode.selectSingleNode("JumpOnKeyPressed"), "value")
        If strTemp <> "" Then objTarget.JumpOnKeyPressed = String2Bool(strTemp)
        
        strTemp = ReadAttributes(objSourceNode.selectSingleNode("JumpOnOutput"), "value")
        If strTemp <> "" Then objTarget.JumpOnOutput = String2Bool(strTemp)
        
        strTemp = ReadAttributes(objSourceNode.selectSingleNode("GagOutput"), "value")
        If strTemp <> "" Then objTarget.Actions.GagOutput = String2Bool(strTemp)
        
        strTemp = ReadAttributes(objSourceNode.selectSingleNode("KeepCommand"), "value")
        If strTemp <> "" Then objTarget.KeepCommand = String2Bool(strTemp)
        
        strTemp = ReadAttributes(objSourceNode.selectSingleNode("TabWidth"), "value")
        If strTemp <> "" Then objTarget.Protocol.TabWidth = strTemp
        
        strTemp = ReadAttributes(objSourceNode.selectSingleNode("Connection"), "name")
        If strTemp <> "" Then
            objTarget.SessionName = strTemp
            objTarget.Host = ReadAttributes(objSourceNode.selectSingleNode("Connection"), "host")
            objTarget.Port = ReadAttributes(objSourceNode.selectSingleNode("Connection"), "port")
        End If
        
    End If
    
End Sub

Private Sub LoadColors(objSourceNode As IXMLDOMNode, objTarget As frmSession)
On Error Resume Next
    Dim lngColor As Long, intIndex As Integer
    Dim objNode As IXMLDOMNode, strTemp As String
    
    If Not bMergeMode Then
        
        strTemp = ReadAttributes(objSourceNode, "default")
        If (strTemp = "") Or (Not IsNumeric(strTemp)) Then strTemp = "7"
        lngColor = CLng(strTemp)
        If (lngColor >= 0) And (lngColor <= 15) Then
            objTarget.Protocol.DefaultColor = lngColor
        Else
            objTarget.Protocol.DefaultColor = 7
        End If
        For Each objNode In objSourceNode.selectNodes("color")
            intIndex = ReadAttributes(objNode, "index")
            lngColor = CLng("&H" & Right(ReadAttributes(objNode, "value"), 6))
            objTarget.Terminal.Color(intIndex) = lngColor
        Next
    End If
End Sub

'Public Function MakeColItem(oColItem As Object) As IXMLDOMElement
Friend Function MakeColItem(oColItem As Object) As IXMLDOMElement
    On Error GoTo errHandler
    'good for actions/substitutes and aliases
    Dim objNode As IXMLDOMElement
    Dim objSubNode As IXMLDOMElement
    Dim objCDataElement As IXMLDOMCDATASection
    
    Set objNode = objXMLDoc.createElement(LCase(TypeName(oColItem)))
    'If Trim(strName) <> "" Then objNode.setAttribute "name", strName
    objNode.setAttribute "name", oColItem.Name
    Set objSubNode = objXMLDoc.createElement("pattern")
    objSubNode.setAttribute "enabled", Bool2String(oColItem.Enabled)
    objSubNode.setAttribute "case", Bool2String(oColItem.CaseSensitive)
    objSubNode.setAttribute "format", "strict"
    objSubNode.setAttribute "simple", Bool2String(oColItem.Simple)
    objSubNode.Text = oColItem.Pattern
    objNode.appendChild objSubNode
    Set objSubNode = objXMLDoc.createElement("command")
    objSubNode.setAttribute "format", "strict"
    Set objCDataElement = objXMLDoc.createCDATASection(oColItem.Command)
    objSubNode.appendChild objCDataElement
    objNode.appendChild objSubNode
    
    Set MakeColItem = objNode
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.MakeColItem(oColItem)", oColItem
End Function

Public Function GetKeybinding(XMLString As String, intKeyCode, intShift, strCommand) As Boolean
On Error GoTo ErrorH
    Dim objNode As IXMLDOMNode
    Dim strXML As String, strKey As String
    
    strXML = "<?xml version=""1.0"" encoding=""ISO-8859-1""?>" & "<root>" & XMLString & "</root>"
    objXMLDoc.loadXML strXML
    If Trim(objXMLDoc.parseError.reason) <> "" Then
        GetKeybinding = False
        Exit Function
    End If
        
    Set objNode = objXMLDoc.selectSingleNode("root").firstChild
    If String2Bool(ReadAttributes(objNode, "shift")) Then intShift = 1 Else intShift = 0
    If String2Bool(ReadAttributes(objNode, "ctrl")) Then intShift = intShift + 2
    If String2Bool(ReadAttributes(objNode, "alt")) Then intShift = intShift + 4
    strCommand = objNode.Text
    strKey = ReadAttributes(objNode, "key")
    If Len(strKey) > 1 Then
        intKeyCode = CInt(Replace(Replace(strKey, "[", ""), "]", ""))
    Else
        intKeyCode = Asc(strKey)
    End If
    
    GetKeybinding = True
    Exit Function
    
ErrorH:
    GetKeybinding = False
End Function


Private Function MakeScript(intPriority As Integer, strName As String, strLocation As String, blnEnabled As Boolean) As IXMLDOMElement
    On Error GoTo errHandler
    Dim objNode As IXMLDOMElement
    
    Set objNode = objXMLDoc.createElement("file")
    'objNode.setAttribute "priority", CStr(intPriority) ' Later...
    objNode.setAttribute "name", strName
    objNode.setAttribute "location", strLocation
    objNode.setAttribute "enabled", Bool2String(blnEnabled)
    
    Set MakeScript = objNode
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.MakeScript(intPriority,strName,strLocation,blnEnabled)", _
         Array(intPriority, strName, strLocation, blnEnabled)
End Function

Private Function MakeOption(strName As String, strValue As String) As IXMLDOMElement
    On Error GoTo errHandler
    Dim objNode As IXMLDOMElement
    
    Set objNode = objXMLDoc.createElement(strName)
    objNode.setAttribute "value", strValue
    
    Set MakeOption = objNode
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.MakeOption(strName,strValue)", Array(strName, strValue)
End Function

Private Function MakeConnection(strSessionName As String, strHost As String, lngPort As Long) As IXMLDOMElement
    On Error GoTo errHandler
    Dim objNode As IXMLDOMElement
    
    Set objNode = objXMLDoc.createElement("Connection")
    objNode.setAttribute "name", strSessionName
    objNode.setAttribute "host", strHost
    objNode.setAttribute "port", lngPort
    
    Set MakeConnection = objNode
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.MakeConnection(strSessionName,strHost,lngPort)", Array(strSessionName, _
         strHost, lngPort)
End Function

Public Function MakeKeyBinding(objKeyBind As KeyBinding) As IXMLDOMElement
    On Error GoTo errHandler
    Dim objElement As IXMLDOMElement
    Dim objCDataElement As IXMLDOMCDATASection
    Dim strName As String
    Dim intKeyCode As Integer, intShift As Integer, strCommand As String, blnEnabled As Boolean
    
    intKeyCode = objKeyBind.KeyCode
    intShift = objKeyBind.Shift
    strCommand = objKeyBind.Command
    blnEnabled = objKeyBind.Enabled
    strName = objKeyBind.GetKeyCode
    
    Set objElement = objXMLDoc.createElement("keybind")
    If (intShift And 1) = 1 Then objElement.setAttribute "shift", "yes"
    If (intShift And 2) = 2 Then objElement.setAttribute "ctrl", "yes"
    If (intShift And 4) = 4 Then objElement.setAttribute "alt", "yes"
    
    objElement.setAttribute "key", strName
    If blnEnabled Then objElement.setAttribute "enabled", "yes"
    Set objCDataElement = objXMLDoc.createCDATASection(strCommand)
    objElement.appendChild objCDataElement
    
    Set MakeKeyBinding = objElement
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.MakeKeyBinding(intKeyCode,intShift,strCommand)", Array(intKeyCode, _
         intShift, strCommand)
End Function

Private Function MakeColor(intIndex As Integer, lngColor As Long) As IXMLDOMElement
    On Error GoTo errHandler
    Dim objNode As IXMLDOMElement
    Dim strColor As String
    
    strColor = Right("00000" & Hex(lngColor), 6)
    Set objNode = objXMLDoc.createElement("color")
    objNode.setAttribute "index", intIndex
    objNode.setAttribute "value", strColor
    
    Set MakeColor = objNode
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.MakeColor(intIndex,lngColor)", Array(intIndex, lngColor)
End Function

Private Function MakeVariable(strName As String, strValue As String) As IXMLDOMElement
    On Error GoTo errHandler
    Dim objNode As IXMLDOMElement
    Dim objCDataElement As IXMLDOMCDATASection
    
    Set objNode = objXMLDoc.createElement("variable")
    Set objCDataElement = objXMLDoc.createCDATASection(strValue)
    objNode.setAttribute "name", strName
    objNode.appendChild objCDataElement
    
    Set MakeVariable = objNode
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.MakeVariable(strName,strValue)", Array(strName, strValue)
End Function

Private Function MakeProperty(strName As String, strValue As String) As IXMLDOMElement
    Dim objCData As IXMLDOMCDATASection
    
    Set MakeProperty = objXMLDoc.createElement("property")
    MakeProperty.setAttribute "name", strName
    Set objCData = objXMLDoc.createCDATASection(strValue)
    MakeProperty.appendChild objCData
End Function

Private Function MakeEvent(objEvent As clsEvent) As IXMLDOMElement
    On Error GoTo errHandler
    Dim objNode As IXMLDOMElement
    Dim objSubNode As IXMLDOMElement
    Dim objCDataElement As IXMLDOMCDATASection
    Dim objData As Collection
    Dim intLoop As Integer
    
    Set objNode = objXMLDoc.createElement("event")
    objNode.setAttribute "name", objEvent.Name
    objNode.setAttribute "enabled", Bool2String(objEvent.Enabled)
    objNode.setAttribute "type", arrEventTypes(objEvent.EventType)
    
    Set objSubNode = objXMLDoc.createElement("command")
    objSubNode.setAttribute "format", "strict"
    Set objCDataElement = objXMLDoc.createCDATASection(objEvent.Command)
    objSubNode.appendChild objCDataElement
    objNode.appendChild objSubNode
    
    Set objData = objEvent.GetData
    Select Case objEvent.EventType
        Case etTimer
            objNode.appendChild MakeProperty("interval", objData("Interval"))
            objNode.appendChild MakeProperty("fireonce", objData("FireOnce"))
        Case etWeb
            objNode.appendChild MakeProperty("pattern", objData("Pattern"))
    End Select
    
    Set MakeEvent = objNode
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.MakeEvent(objEvent)", objEvent
End Function

Private Function ClearCommand(strCommand As Variant) As String
    On Error GoTo errHandler
    Dim intN As Integer
    Dim strN As String
    Dim strPartCommand As Variant
    Dim arrCommands
    
    ' Strip all leading newlines, tabs and spaces.
    For intN = 1 To Len(strCommand)
        strN = Mid(strCommand, intN, 1)
        Select Case strN
            Case Chr(13), Chr(10), Chr(9), Chr(64) ' CR, LF, TAB, SPACE: do nothing, strip them!
            Case Else: Exit For
        End Select
    Next
    If intN > 1 Then strCommand = Mid(strCommand, intN)
    
    ' Strip at the end of the file.
    For intN = Len(strCommand) To 0 Step -1
        strN = Mid(strCommand, intN, 1)
        Select Case strN
            Case Chr(13), Chr(10), Chr(9), Chr(64) ' CR, LF, TAB, SPACE: do nothing, strip them!
            Case Else: Exit For
        End Select
    Next
    If intN < Len(strCommand) Then strCommand = Left(strCommand, intN)
    
    ' Now split lines and strip individual lines.
    arrCommands = Split(strCommand, Chr(10))
    If UBound(arrCommands) > 0 Then
        strCommand = ""
        For Each strPartCommand In arrCommands
            strCommand = strCommand & ClearCommand(strPartCommand) & vbCrLf
        Next
    End If
    
    ClearCommand = strCommand
    Exit Function
errHandler:
    ErrorIn "clsUserSettings.ClearCommand(strCommand)", strCommand
End Function

' If node doesn't exist an error is thrown and functions returns empty string.
Private Function ReadAttributes(objTreePos As Object, strNodeName As String) As String
    On Error GoTo ERRORReadAttributes
    
    ReadAttributes = objTreePos.Attributes.getNamedItem(strNodeName).nodeValue
    Exit Function

ERRORReadAttributes:
    ReadAttributes = ""
End Function

Private Function PrettyPrint(objNodes As IXMLDOMNodeList, Optional intLevel As Integer = 0) As String
On Error GoTo ERRORPrettyPrint
    Dim strResult As String, strOutput As String
    Dim objNode As IXMLDOMNode
    Dim objAttrib As IXMLDOMAttribute
    
    For Each objNode In objNodes
        If objNode.hasChildNodes And ReadAttributes(objNode, "format") <> "strict" Then
            strOutput = objNode.nodeName
            For Each objAttrib In objNode.Attributes
                strOutput = strOutput & " " & objAttrib.Name & "=""" & objAttrib.Value & """"
            Next
            strResult = strResult & String(intLevel, vbTab) & "<" & strOutput & ">" & vbCrLf & PrettyPrint(objNode.childNodes, intLevel + 1) & String(intLevel, vbTab) & "</" & objNode.nodeName & ">" & vbCrLf
        Else
            strResult = strResult & String(intLevel, vbTab) & objNode.xml & vbCrLf
        End If
    Next
    
    PrettyPrint = strResult
    Exit Function
    
ERRORPrettyPrint:
    PrettyPrint = "<? Error parsing document />" & vbCrLf
End Function
